#!/usr/bin/env python3

import unittest

class TestsProject():
	""" Runs all the tests """
	def __init__(self, testList):
		""" Constructor (the testList specifies all the tests) """
		suiteList = []
		# Group all tests together, so there will be only one final output and we don't have to search for some failure in the beginning
		for test in testList:
			suite = unittest.TestLoader().loadTestsFromTestCase(test)
			suiteList.append(suite)
		allTests = unittest.TestSuite(suiteList)
		unittest.TextTestRunner(verbosity=2).run(allTests)
