#!/usr/bin/env python3

""" Converts a logisim memory file to a verilog memory file """
import sys

if len(sys.argv) < 4:
	print("USAGE: " + sys.argv[0] + " <inputfile> <data bit width> <address bit width>")
	exit(1)

inputFilename = sys.argv[1]
dataBit = sys.argv[2]
addressBit = sys.argv[3]
inputFile = open(inputFilename)

segmentCount = 0

def processSegment(segment, segmentCount):
	intSegment = int(segment, 16)
	print (('{0:0>' + dataBit + 'b}').format(intSegment))
	return segmentCount + 1

# Ignore the first line, contains comments
for dataline in inputFile.readlines()[1:]:
	for part in dataline.strip().split(" "):
		# Test if this line describes multiple segments
		if part.count("*") > 0:
			[ count, value ] = part.split("*")

			for i in range(int(count)):
				segmentCount =processSegment(value, segmentCount)
		else:
			segmentCount = processSegment(part, segmentCount)


# Fill the end with zeroes
for i in range(2**int(addressBit) - segmentCount):
	segmentCount = processSegment("0", segmentCount)