#!/usr/bin/env python3

from translator.intermediateBuilder.intermediateBuilder import IntermediateBuilder
from translator.intermediateBuilder.circuit import Circuit
from translator.visitor.intermediateVisitor.intermediateNamingVisitor import IntermediateNamingVisitor
from translator.visitor.intermediateVisitor.intermediatePrintVisitor import IntermediatePrintVisitor
from translator.visitor.intermediateVisitor.intermediateConnectivityVisitor import IntermediateConnectivityVisitor
from translator.visitor.intermediateVisitor.intermediateIndependentVisitor import IntermediateIndependentCheckVisitor

#The circ file that we are going to translate to verilog
# filename = 'testVerilogFile/circFiles/simpleFlipFlop2.circ'
filename = 'test.circ'

builder = IntermediateBuilder(filename, True)
returnValue = builder.makeIntermediateTree()
intermediateTree = returnValue[0]

#We traverse the intermediateTree with a naming visitor, so that all the components get a valid name
namingVisitor = IntermediateNamingVisitor()
intermediateTree.traverse(namingVisitor)	

dumpVisitor = IntermediatePrintVisitor()
intermediateTree.traverse(dumpVisitor)
