#!/usr/bin/env python3

from allTests import TestsProject
from testIntermediateBuilder.testIntermediateBuilderGate import TestIntermediateBuilderGate
from testIntermediateBuilder.testIntermediateBuilderPlexer import TestIntermediateBuilderPlexer
from testIntermediateBuilder.testIntermediateBuilderArithmetic import TestIntermediateBuilderArithmetic
from testIntermediateBuilder.testIntermediateBuilderInOutputAndExtra import TestIntermediateBuilderInOutputAndExtra
from testIntermediateBuilder.testIntermediateBuilderMemory import TestIntermediateBuilderMemory
from testIntermediateBuilder.testIntermediateBuilderImportedCircuit import TestIntermediateBuilderImportedCircuit
from testIntermediateBuilder.testIntermediateBuilderSplitter import TestIntermediateBuilderSplitter
from testIntermediateBuilder.testIntermediateBuilderConnectionsComp import TestIntermediateBuilderConnectionsComp
from testVerilogTree.testVerilogGate import TestVerilogGate
from testVerilogTree.testVerilogPlexer import TestVerilogPlexer
from testVerilogTree.testVerilogArithmetic import TestVerilogArithmetic
from testVerilogTree.testVerilogInOutAndExtra import TestVerilogInOutAndExtra
from testVerilogTree.testVerilogMemory import TestVerilogMemory
from testVerilogTree.testVerilogImportedCircuit import TestVerilogImportedCircuit
from testVerilogFile.testVerilogFileTestBench import TestVerilogFileTestBench
from testVerilogFile.testVerilogFile import TestVerilogFile
from testTestingVisitor.testIndependentCheckVisitor import TestIndependentCheckVisitor
from testTestingVisitor.testConnectivityVisitor import TestConnectivityVisitor
from testDEVS.testDEVSTrace import TestDEVSTrace
from testDEVS.testDEVSSim import TestDEVSSim

testList = [ 	 
			TestIntermediateBuilderGate, TestIntermediateBuilderPlexer, TestIntermediateBuilderArithmetic, 
			TestIntermediateBuilderInOutputAndExtra, TestIntermediateBuilderMemory, TestIntermediateBuilderImportedCircuit, 
			TestIntermediateBuilderSplitter, TestIntermediateBuilderConnectionsComp, 
			TestVerilogGate, TestVerilogPlexer, TestVerilogArithmetic, 
			TestVerilogInOutAndExtra, TestVerilogMemory, TestVerilogImportedCircuit, TestVerilogFile, 
			TestConnectivityVisitor, TestIndependentCheckVisitor, TestDEVSTrace, TestDEVSSim
			] 			
testProject = TestsProject(testList)

#The circ files, that we will translate using the translator and whom we can test via the testBenches (in testVerilogFile/verilogFiles/copyOfTestbenches)
#Possible FileNames:
#'testVerilogFile/circFiles/simpleBaseGate.circ', 'testVerilogFile/circFiles/simpleOddGate.circ',
#'testVerilogFile/circFiles/andOrNandNot.circ', 'testVerilogFile/circFiles/collidingWires.circ',
#'testVerilogFile/circFiles/simplePlexer2.circ', 'testVerilogFile/circFiles/simplePlexer3.circ',
#'testVerilogFile/circFiles/simpleNoneCompletePlexer.circ', 'testVerilogFile/circFiles/simpleCarryArithmetic4.circ',
#'testVerilogFile/circFiles/simpleCarryArithmetic3.circ', 'testVerilogFile/circFiles/simpleOtherArithmetic2.circ',
#'testVerilogFile/circFiles/simpleOtherArithmetic3.circ', 'testVerilogFile/circFiles/simpleOtherArithmetic4.circ',
#'testVerilogFile/circFiles/simpleInOutputAndExtra3.circ', 'testVerilogFile/circFiles/simpleFlipFlop2.circ',
#'testVerilogFile/circFiles/simpleAbstractRegisterAndRandom2.circ', 'testVerilogFile/circFiles/simpleAbstractRegisterAndRandom3.circ',
#'testVerilogFile/circFiles/simpleLargeMemoryAndShiftRegister3.circ', 'testVerilogFile/circFiles/simpleLargeMemoryAndShiftRegister4.circ',
#'testVerilogFile/circFiles/simplePullResistor3.circ', 'testVerilogFile/circFiles/simpleImportedCircuits4.circ', 'testVerilogFile/circFiles/simpleSplitter7.circ'
filenames = []	
TestVerilogFileTestBench().writeFiles(filenames)
