#!/usr/bin/env python3

from translator.intermediateBuilder.intermediateBuilder import IntermediateBuilder
from translator.visitor.verilogVisitor.verilogWriteVisitor import VerilogWriteVisitor
from translator.visitor.intermediateVisitor.intermediateTranslatorVisitor import IntermediateTranslatorVisitor
from translator.visitor.intermediateVisitor.intermediateNamingVisitor import IntermediateNamingVisitor

class TestVerilogFileTestBench():
	""" Writes the files to the testVerilogFile/verilogFiles (so that we can check this with testbenches) """
	def writeFiles(self, filenames):
		for filename in filenames:
			xml = IntermediateBuilder(filename, True)
			returnValue = xml.makeIntermediateTree()
			intermediateTree = returnValue[0]
				
			translateVisitor = IntermediateTranslatorVisitor()
			#So that all the components of the tree will have a valid name
			namingVisitor = IntermediateNamingVisitor()
			intermediateTree.traverse(namingVisitor)
			#Because we traversed the tree with the visitor, we know that the verilogTree will be stored in the visitor
			intermediateTree.traverse(translateVisitor)
			#We invoke the method makeVerilogTree on the translateVisitor
			verilogTree = translateVisitor.makeVerilogTree()

			writeVisitor = VerilogWriteVisitor()
			verilogTree.traverse(writeVisitor)
			writeVisitor.writeToFiles('testVerilogFile/verilogFiles/')

 