module test_collidingWires;

	reg a, b, expectedAfterNot;
	reg [1:0] c, d, expected, expectedBeforeNotOutput;
	wire [1:0] e, g;
	wire f;
	
	collidingWires testObj(.ThirdInput(a), .FourthInput(b), .SecondInput(c), .inputFirst(d), .beforeNotOutput(e), .afterNotGate(f), .Outputi(g));
	
	initial 
	begin	
		$display("Testen van de collidingWires.");
		#0 a= 0; b= 0; c=0; d=0; expected= 3; expectedBeforeNotOutput= 0; expectedAfterNot= 1; 
		#10 a= 0; b= 0; c=0; d=1; expected= 2; expectedBeforeNotOutput= 1; expectedAfterNot= 1;		
		#10 a= 0; b= 0; c=0; d=3; expected= 0; expectedBeforeNotOutput= 3; expectedAfterNot= 1;		
		#10 a= 0; b= 0; c=0; d=2; expected= 1; expectedBeforeNotOutput= 2; expectedAfterNot= 1;
		#10 a= 0; b= 0; c=1; d=0; expected= 3; expectedBeforeNotOutput= 0; expectedAfterNot= 1;
		#10 a= 0; b= 0; c=2; d=0; expected= 3; expectedBeforeNotOutput= 0; expectedAfterNot= 1;
		#10 a= 0; b= 0; c=3; d=1; expected= 2; expectedBeforeNotOutput= 1; expectedAfterNot= 1;
		#10 a= 0; b= 1; c=0; d=0; expected= 3; expectedBeforeNotOutput= 0; expectedAfterNot= 1;		
		#10 a= 0; b= 1; c=0; d=1; expected= 2'b 1x; expectedBeforeNotOutput= 2'b 0x; expectedAfterNot= 1;	
		#10 a= 0; b= 1; c=0; d=2; expected= 2'b x1; expectedBeforeNotOutput= 2'b x0; expectedAfterNot= 1;			
		#10 a= 0; b= 1; c=0; d=3; expected= 2'b xx; expectedBeforeNotOutput= 2'b xx; expectedAfterNot= 1;		
		#10 a= 0; b= 1; c=1; d=0; expected= 2'b 1x; expectedBeforeNotOutput= 2'b 0x; expectedAfterNot= 1;		
		#10 a= 0; b= 1; c=2; d=0; expected= 2'b x1; expectedBeforeNotOutput= 2'b x0; expectedAfterNot= 1;		
		#10 a= 0; b= 1; c=3; d=0; expected= 2'b xx; expectedBeforeNotOutput= 2'b xx; expectedAfterNot= 1;
		#10 a= 0; b= 1; c=1; d=1; expected= 2; expectedBeforeNotOutput= 1; expectedAfterNot= 1;		
		#10 a= 0; b= 1; c=1; d=2; expected= 2'b xx; expectedBeforeNotOutput= 2'b xx; expectedAfterNot= 1;		
		#10 a= 0; b= 1; c=1; d=3; expected= 2'b x0; expectedBeforeNotOutput= 2'b x1; expectedAfterNot= 1;		
		#10 a= 0; b= 1; c=2; d=1; expected= 2'b xx; expectedBeforeNotOutput= 2'b xx; expectedAfterNot= 1;		
		#10 a= 0; b= 1; c=2; d=2; expected= 1; expectedBeforeNotOutput= 2; expectedAfterNot= 1;				
		#10 a= 0; b= 1; c=2; d=3; expected= 2'b 0x; expectedBeforeNotOutput= 2'b 1x; expectedAfterNot= 1;	
		#10 a= 0; b= 1; c=3; d=1; expected= 2'b x0; expectedBeforeNotOutput= 2'b x1; expectedAfterNot= 1;		
		#10 a= 0; b= 1; c=3; d=2; expected= 2'b 0x; expectedBeforeNotOutput= 2'b 1x; expectedAfterNot= 1;		
		#10 a= 0; b= 1; c=3; d=3; expected= 0; expectedBeforeNotOutput= 3; expectedAfterNot= 1;		

		#10 a= 1; b= 0; c=0; d=0; expected= 0; expectedBeforeNotOutput= 3; expectedAfterNot= 0; 
		#10 a= 1; b= 0; c=0; d=1; expected= 0; expectedBeforeNotOutput= 3; expectedAfterNot= 0;		
		#10 a= 1; b= 0; c=0; d=2; expected= 0; expectedBeforeNotOutput= 3; expectedAfterNot= 0;		
		#10 a= 1; b= 0; c=0; d=3; expected= 0; expectedBeforeNotOutput= 3; expectedAfterNot= 0;	
		#10 a= 1; b= 0; c=1; d=0; expected= 1; expectedBeforeNotOutput= 2; expectedAfterNot= 0;		
		#10 a= 1; b= 0; c=2; d=0; expected= 2; expectedBeforeNotOutput= 1; expectedAfterNot= 0;		
		#10 a= 1; b= 0; c=3; d=0; expected= 3; expectedBeforeNotOutput= 0; expectedAfterNot= 0;		
		#10 a= 1; b= 0; c=1; d=1; expected= 1; expectedBeforeNotOutput= 2; expectedAfterNot= 0;		
		#10 a= 1; b= 0; c=1; d=2; expected= 1; expectedBeforeNotOutput= 2; expectedAfterNot= 0;		
		#10 a= 1; b= 0; c=1; d=3; expected= 1; expectedBeforeNotOutput= 2; expectedAfterNot= 0;		
		#10 a= 1; b= 1; c=0; d=0; expected= 2'b xx; expectedBeforeNotOutput= 2'b xx; expectedAfterNot= 0; 
		#10 a= 1; b= 1; c=0; d=1; expected= 2'b xx; expectedBeforeNotOutput= 2'b xx; expectedAfterNot= 0; 
		#10 a= 1; b= 1; c=0; d=2; expected= 2'b xx; expectedBeforeNotOutput= 2'b xx; expectedAfterNot= 0; 
		#10 a= 1; b= 1; c=0; d=3; expected= 2'b xx; expectedBeforeNotOutput= 2'b xx; expectedAfterNot= 0; 
		#10 a= 1; b= 1; c=1; d=0; expected= 2'b xx; expectedBeforeNotOutput= 2'b xx; expectedAfterNot= 0; 	
		#10 a= 1; b= 1; c=2; d=0; expected= 2'b xx; expectedBeforeNotOutput= 2'b xx; expectedAfterNot= 0; 	
		#10 a= 1; b= 1; c=3; d=0; expected= 2'b xx; expectedBeforeNotOutput= 2'b xx; expectedAfterNot= 0; 	

		
		#5 $finish; 	
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_collidingWires);
	end
endmodule 