module test_simpleAbstractRegisterAndRandom2;

	reg [7:0] a, expectedHighReg;
	reg [0:0] b, c;
	reg [3:0] d, expectedFallingReg, startRandom, resetRandom;
	wire [7:0] g;
	wire [3:0] h, i,  r;
	
	simpleAbstractRegisterAndRandom2 testObj(.highRegInput(a), .enableInput(b), .resetInput(c), .input4long(d), .outHighReg(g), .outFallingReg(h), .outRandom(i), .outRandom2(r));
	
	initial 
	begin	
		$display("Testen van de simpleAbstractRegisterAndRandom2.");
		//We can't really control random, we can only control that the startRandom and resetRandom of the random with seed are the same 
		//(the first assignments are without delay, because otherwise the clock would trigger and #0 != 0
		 b= 1'b x; c=1'b x; 
			a= 8'b xxxxxxxx; expectedHighReg= 8'b 00000000; d= 4'b xxxx; expectedFallingReg= 4'b 0000; 
			startRandom= r; resetRandom= 4'b 0000;
		#1 b= 1'b x; c=1'b x; 
			a= 8'b xxxxxxxx; expectedHighReg= 8'b 00000000; d= 4'b xxxx; expectedFallingReg= 4'b 0000; 
		#1 b= 1'b x; c=1'b x; 
			a= 8'b xxxxxxxx; expectedHighReg= 8'b 00000000; d= 4'b xxxx; expectedFallingReg= 4'b 0000; 
		//Clock rises	
		#8 b= 1'b 0; c=1'b x; 
			a= 8'b 11110011; expectedHighReg= 8'b 00000000; d= 4'b x01x; expectedFallingReg= 4'b 0000; 
		#1 b= 1'b 1; c=1'b x; 
			a= 8'b 11110011; expectedHighReg= 8'b 11110011; d= 4'b x01x; expectedFallingReg= 4'b 0000; 
		#1 b= 1'b 1; c=1'b x; 
			a= 8'b 1111x011; expectedHighReg= 8'b 11110011; d= 4'b x01x; expectedFallingReg= 4'b 0000; 	
		//Clock falls
		#8 b= 1'b 1; c=1'b x; 
			a= 8'b 1111x011; expectedHighReg= 8'b 11110011; d= 4'b 0011; expectedFallingReg= 4'b 0011; 	 
		//Reset
		#8 b= 1'b 1; c=1'b 1; 
			a= 8'b 01010011; expectedHighReg= 8'b 00000000; d= 4'b 0011; expectedFallingReg= 4'b 0000; 
			resetRandom= startRandom;
			
		//The random should change a couple of times
		#8 b= 1'b 1; c=1'b 0; a= 8'b 00000000; d=  4'b 0000;
		
		#80 $finish; 
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simpleAbstractRegisterAndRandom2);
	end
endmodule 