module test_simpleAbstractRegisterAndRandom3;

	
	reg [0:0] a, b, d, e, g, h, j, k, m, expectedWrap2, expectedStay2, expectedContinue2, expectedLoad2;
	reg [3:0] c, f, i, l, expectedWrap, expectedStay, expectedContinue, expectedLoad;
	wire [3:0] n, p, r, t;
	wire [0:0] o, q, s, u;

	
	simpleAbstractRegisterAndRandom3 testObj(.reset(a), .loadWrap(b), .inWrap(c), .countWrap(d), .loadStay(e), .inStay(f), .countStay(g), 
			.loadContinue(h), .inContinue(i), .countContinue(j), .loadLoad(k), .inLoad(l), .countLoad(m), .outWrap(n), .outWrap2(o), 
			.outStay(p), .outStay2(q), .outContinue(r), .outContinue2(s), .outLoad(t), .outLoad2(u));
	
	initial 
	begin	
		$display("Testen van de simpleAbstractRegisterAndRandom3.");
		a= 1'b x; 
		b= 1'b 0; c= 4'b 0000; d= 1'b 0; expectedWrap= 4'b 0000; expectedWrap2= 1'b 0;
		e= 1'b 0; f= 4'b 0000; g= 1'b 0; expectedStay= 4'b 0000; expectedStay2= 1'b 0;
		h= 1'b 0; i= 4'b 0000; j= 1'b 0; expectedContinue= 4'b 0000; expectedContinue2= 1'b 0;
		k= 1'b 0; l= 4'b 0000; m= 1'b 0; expectedLoad= 4'b 0000; expectedLoad2= 1'b 0;
		//Clock rises (counter remains unchanged)
		#10 a= 1'b 0;
		b= 1'b 0; c= 4'b 0000; d= 1'b 0; expectedWrap= 4'b 0000; expectedWrap2= 1'b 0;
		e= 1'b 0; f= 4'b 0100; g= 1'b 0; expectedStay= 4'b 0000; expectedStay2= 1'b 0;
		h= 1'b 0; i= 4'b 0000; j= 1'b 0; expectedContinue= 4'b 0000; expectedContinue2= 1'b 0;
		k= 1'b 0; l= 4'b 0000; m= 1'b 0; expectedLoad= 4'b 0000; expectedLoad2= 1'b 0;
		//Counter falls (set on decrement)
		#10 a= 1'b 0;
		b= 1'b 1; c= 4'b 0000; d= 1'b 1; expectedWrap= 4'b 0000; expectedWrap2= 1'b 1;
		e= 1'b 1; f= 4'b 0000; g= 1'b 1; expectedStay= 4'b 0000; expectedStay2= 1'b 1;
		h= 1'b 1; i= 4'b 0000; j= 1'b 1; expectedContinue= 4'b 0000; expectedContinue2= 1'b 1;
		k= 1'b 1; l= 4'b 0000; m= 1'b 1; expectedLoad= 4'b 0000; expectedLoad2= 1'b 1;
		
		//Clock rises (counter loads value)
		#10 a= 1'b 0;
		b= 1'b 1; c= 4'b 0010; d= 1'b 0; expectedWrap= 4'b 0010; expectedWrap2= 1'b 0;
		e= 1'b 1; f= 4'b 0011; g= 1'b 0; expectedStay= 4'b 0011; expectedStay2= 1'b 1;
		h= 1'b 1; i= 4'b 0011; j= 1'b 0; expectedContinue= 4'b 0011; expectedContinue2= 1'b 1;
		k= 1'b 1; l= 4'b 0010; m= 1'b 0; expectedLoad= 4'b 0010; expectedLoad2= 1'b 0;
		
		//Clock rises (counter increment)
		#20 a= 1'b 0;
		b= 1'b 0; c= 4'b 0010; d= 1'b 1; expectedWrap= 4'b 0011; expectedWrap2= 1'b 1;
		e= 1'b 0; f= 4'b 0000; g= 1'b 1; expectedStay= 4'b 0011; expectedStay2= 1'b 1;
		h= 1'b 0; i= 4'b 0011; j= 1'b 1; expectedContinue= 4'b 0100; expectedContinue2= 1'b 0;
		k= 1'b x; l= 4'b 0010; m= 1'b 1; expectedLoad= 4'b 0011; expectedLoad2= 1'b 1;
		
		//Clock falls (set on decrement)
		#10 a= 1'b 0;
		b= 1'b 1; c= 4'b 0010; d= 1'b 1; expectedWrap= 4'b 0011; expectedWrap2= 1'b 0;
		e= 1'b 1; f= 4'b 0000; g= 1'b 1; expectedStay= 4'b 0011; expectedStay2= 1'b 0;
		h= 1'b 1; i= 4'b 0011; j= 1'b 1; expectedContinue= 4'b 0100; expectedContinue2= 1'b 0;
		k= 1'b 1; l= 4'b 0010; m= 1'b x; expectedLoad= 4'b 0011; expectedLoad2= 1'b 0;
		
		//Clock rises (stay->counter decrement / rest->counter increment, max value)
		#10 a= 1'b 0;
		b= 1'b 0; c= 4'b 0010; d= 1'b 1; expectedWrap= 4'b 0000; expectedWrap2= 1'b 0;
		e= 1'b 1; f= 4'b 0000; g= 1'b 1; expectedStay= 4'b 0010; expectedStay2= 1'b 0;
		h= 1'b x; i= 4'b 0011; j= 1'b x; expectedContinue= 4'b 0101; expectedContinue2= 1'b 0;
		k= 1'b x; l= 4'b 0010; m= 1'b 1; expectedLoad= 4'b 0010; expectedLoad2= 1'b 0;
		
		//Clock falls (set on load)
		#10 a= 1'b 0;
		b= 1'b 1; c= 4'b 0010; d= 1'b 0; expectedWrap= 4'b 0000; expectedWrap2= 1'b 0;
		e= 1'b 1; f= 4'b 0000; g= 1'b 0; expectedStay= 4'b 0010; expectedStay2= 1'b 0;
		h= 1'b 1; i= 4'b 0011; j= 1'b 0; expectedContinue= 4'b 0101; expectedContinue2= 1'b 0;
		k= 1'b 1; l= 4'b 0010; m= 1'b 0; expectedLoad= 4'b 0010; expectedLoad2= 1'b 0;
		
		//Clock rises (wrap->do nothing / rest->set on load)
		#10 a= 1'b 0;
		b= 1'b 0; c= 4'b 0010; d= 1'b 0; expectedWrap= 4'b 0000; expectedWrap2= 1'b 0;
		e= 1'b 1; f= 4'b 0000; g= 1'b 0; expectedStay= 4'b 0000; expectedStay2= 1'b 0;
		h= 1'b 1; i= 4'b 0000; j= 1'b 0; expectedContinue= 4'b 0000; expectedContinue2= 1'b 0;
		k= 1'b 1; l= 4'b 0000; m= 1'b 0; expectedLoad= 4'b 0000; expectedLoad2= 1'b 0;
		
		//Clock falls (set on decrement)
		#10 a= 1'b 0;
		b= 1'b 1; c= 4'b 0010; d= 1'b 1; expectedWrap= 4'b 0000; expectedWrap2= 1'b 1;
		e= 1'b 1; f= 4'b 0000; g= 1'b 1; expectedStay= 4'b 0000; expectedStay2= 1'b 1;
		h= 1'b 1; i= 4'b 0000; j= 1'b 1; expectedContinue= 4'b 0000; expectedContinue2= 1'b 1;
		k= 1'b 1; l= 4'b 0011; m= 1'b 1; expectedLoad= 4'b 0000; expectedLoad2= 1'b 1;
		
		//Clock rises (counter decrement, max value)
		#10 a= 1'b 0;
		b= 1'b 1; c= 4'b 0010; d= 1'b 1; expectedWrap= 4'b 0011; expectedWrap2= 1'b 0;
		e= 1'b 1; f= 4'b 0000; g= 1'b 1; expectedStay= 4'b 0000; expectedStay2= 1'b 1;
		h= 1'b 1; i= 4'b 0000; j= 1'b 1; expectedContinue= 4'b 1111; expectedContinue2= 1'b 0;
		k= 1'b 1; l= 4'b 0011; m= 1'b 1; expectedLoad= 4'b 0011; expectedLoad2= 1'b 0;
		
		#20 $finish; 
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simpleAbstractRegisterAndRandom3);
	end
endmodule 