module test_simpleBaseGate;

	reg [1:0] a, expected, expectedControlBuf, expectedOdd, expectedControlInv, expectedNand;
	wire [1:0] b, c, d, e, f;
	
	simpleBaseGate testObj(.twoBitInput(a), .endingOutput(b), .afterControlBuf(c), .afterOddXor(d), .afterControlInv(e), .afterNand(f));
	
	initial 
	begin	
		$display("Testen van de simpel.");
		//clock is still low
		#0 a= 0; expected=2'b xx; expectedControlBuf =2'b zz; expectedOdd=2'b xx; expectedControlInv=2'b zz; expectedNand=2'b 11; 
		//The cycle starts after 1 second, then the clock will start to cycle (1 is for 5 periods and 0 for 1 period)
		#1 a= 0; expected=2'b 01; expectedControlBuf =2'b 00; expectedOdd=2'b 10; expectedControlInv=2'b 01; expectedNand=2'b 11; 
		#1 a= 1; expected=2'b 01; expectedControlBuf =2'b 01; expectedOdd=2'b 11; expectedControlInv=2'b 01; expectedNand=2'b 11;
		#1 a= 2; expected=2'b 11; expectedControlBuf =2'b 10; expectedOdd=2'b 10; expectedControlInv=2'b 01; expectedNand=2'b 01; 
		#1 a= 3; expected=2'b 11; expectedControlBuf =2'b 11; expectedOdd=2'b 11; expectedControlInv=2'b 01; expectedNand=2'b 01; 
		#1 a= 0; expected=2'b 01; expectedControlBuf =2'b 00; expectedOdd=2'b 10; expectedControlInv=2'b 01; expectedNand=2'b 11; 
		//clock is back low again
		#1 a= 1; expected=2'b xx; expectedControlBuf =2'b zz; expectedOdd=2'b xx; expectedControlInv=2'b zz; expectedNand=2'b 11; 
		//after 1 period of a low clock, the clock changes to high again
		#1 a= 1; expected=2'b 01; expectedControlBuf =2'b 01; expectedOdd=2'b 11; expectedControlInv=2'b 01; expectedNand=2'b 11; 
		//clock stays high for another 4 periods (in total 5 periods)
		#4 a= 2; expected=2'b 11; expectedControlBuf =2'b 10; expectedOdd=2'b 10; expectedControlInv=2'b 01; expectedNand=2'b 01; 
		//afterwards the clock will be low again for 1 period
		#1 a= 3; expected=2'b xx; expectedControlBuf =2'b zz; expectedOdd=2'b xx; expectedControlInv=2'b zz; expectedNand=2'b 01; 
		//and after the one low clock period, it goes back to a high period
		#1 a= 2; expected=2'b 11; expectedControlBuf =2'b 10; expectedOdd=2'b 10; expectedControlInv=2'b 01; expectedNand=2'b 01; 
		//the clock has to stop ticking
		#5 $finish; 	
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simpleBaseGate);
	end
endmodule 