module test_simpleCarryArithmetic3;

	reg [4:0] b;
	reg [7:0] c, d, e, f, expectedOutputDivider, expectedOutputSubtractor, expectedOutputAdder, expectedOutputMultiplier, expectedExtraOutputDivider, expectedExtraOutputMultiplier, expectedOutputOfNotTranslatedDivider;
	reg a, expectedCollideOutputCarryOrBorrow;
	wire [7:0] h, i, k, l, m, n, o;
	wire j;
	
	simpleCarryArithmetic3 testObj(.carryOrBorrw(a), .inputNoOutputAdder(b), .higherBitInputDivider(c), .secondInputMultiplier(d), .lowerInputDivider(e), .divisorInput(f), 
									.outputDivider(h), .outputSubtractor(i), .collideOutputCarryOrBorrow(j), .outputAdder(k), .outputMultiplier(l), .extraOutputDivider(m), 
									.extraOutputMultiplier(n), .outputOfNotTranslatedDivider(o));

	//Sample test instead of thoroughly test								
	initial 
	begin	
		$display("Testen van de simpleCarryArithmetic3.");
		#0 b= 5'b 00000; expectedOutputOfNotTranslatedDivider= 8'b xxxxxxxx; a= 0; c= 8'b 00000000; d= 8'b 00000000; e= 8'b 00000000; f = 8'b 00000000; expectedCollideOutputCarryOrBorrow= 0;
			expectedOutputDivider= 8'b 00000000; expectedOutputSubtractor= 8'b 00000000; expectedOutputAdder= 8'b 00000000; expectedOutputMultiplier= 8'b 00000000; expectedExtraOutputDivider= 8'b 00000000;
			expectedExtraOutputMultiplier= 8'b 00000000; 
		//Test a floating value in divider	
		#10 b= 5'b 00001; expectedOutputOfNotTranslatedDivider= 8'b xxxxxxxx; a= 0; c= 8'b 00000000; d= 8'b 00000000; e= 8'b 00000000; f = 8'b 0000000x; expectedCollideOutputCarryOrBorrow= 1'b x;
			expectedOutputDivider= 8'b xxxxxxxx; expectedOutputSubtractor= 8'b xxxxxxxx; expectedOutputAdder= 8'b xxxxxxxx; expectedOutputMultiplier= 8'b xxxxxxxx; expectedExtraOutputDivider= 8'b xxxxxxxx;
			expectedExtraOutputMultiplier= 8'b xxxxxxxx; 
		#10 b= 5'b 00001; expectedOutputOfNotTranslatedDivider= 8'b xxxxxxxx; a= 0; c= 8'b 0x000000; d= 8'b 00000000; e= 8'b 00000000; f = 8'b 00000000; expectedCollideOutputCarryOrBorrow= 1'b x;
			expectedOutputDivider= 8'b xxxxxxxx; expectedOutputSubtractor= 8'b xxxxxxxx; expectedOutputAdder= 8'b xxxxxxxx; expectedOutputMultiplier= 8'b xxxxxxxx; expectedExtraOutputDivider= 8'b xxxxxxxx;
			expectedExtraOutputMultiplier= 8'b xxxxxxxx; 
		//Test the divider 10000000000000000/11111111 (and the change in all the rest)
		#10 b= 5'b 11101; expectedOutputOfNotTranslatedDivider= 8'b xxxxxxxx; a= 0; c= 8'b 10000000; d= 8'b 00000000; e= 8'b 00000000; f = 8'b 11111111; expectedCollideOutputCarryOrBorrow= 1;
			expectedOutputDivider= 8'b 10000000; expectedOutputSubtractor= 8'b 10000000; expectedOutputAdder= 8'b 00000000; expectedOutputMultiplier= 8'b 10000000; expectedExtraOutputDivider= 8'b 10000000;
			expectedExtraOutputMultiplier= 8'b 00000000; 
		//Test the divider 10000000000000000/0 (and the change in all the rest)	
		#10 b= 5'b 11001; expectedOutputOfNotTranslatedDivider= 8'b xxxxxxxx; a= 0; c= 8'b 10000000; d= 8'b 00000000; e= 8'b 00000000; f = 8'b 00000000; expectedCollideOutputCarryOrBorrow= 0;
			expectedOutputDivider= 8'b 00000000; expectedOutputSubtractor= 8'b 00000000; expectedOutputAdder= 8'b 00000000; expectedOutputMultiplier= 8'b 00000000; expectedExtraOutputDivider= 8'b 00000000;
			expectedExtraOutputMultiplier= 8'b 00000000; 
		//Error in the collide
		#10 b= 5'b 11001; expectedOutputOfNotTranslatedDivider= 8'b xxxxxxxx; a= 1; c= 8'b 10000010; d= 8'b 00010010; e= 8'b 00101001; f = 8'b 00000100; expectedCollideOutputCarryOrBorrow= 1'b x;
			expectedOutputDivider= 8'b 10001010; expectedOutputSubtractor= 8'b 10011110; expectedOutputAdder= 8'b 10110010; expectedOutputMultiplier= 8'b 10110000; expectedExtraOutputDivider= 8'b 00000001;
			expectedExtraOutputMultiplier= 8'b 00000000; 
		#20;
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simpleCarryArithmetic3);
	end
endmodule 