module test_simpleCarryArithmetic4;

	reg [7:0] a, b, d, expectedOutputMult, expectedOutputSub, expectedSecondOutputMult, expectedOutputAdd, expectedOutputDiv, expectedSecondOutputDiv;
	reg c, expectedSecondOutputAdd, expectedSecondOutputSub; 
	wire [7:0] e, f, g, i, j, l;
	wire h, k;
	
	
	simpleCarryArithmetic4 testObj(.extraInput(a), .firstInput(b), .input1(c), .secondInput(d), .outputMult(e), .outputSub(f), .secondOutputMult(g), .secondOutputAdd(h), .outputAdd(i), .outputDiv(j), .secondOutputSub(k), .secondOutputDiv(l));

	initial 
	begin	
		$display("Testen van de simpleCarryArithmetic4.");
		#0 a= 8'b 00000000; b= 8'b 00000000; c= 1'b 0; d= 8'b 00000000; expectedSecondOutputAdd= 1'b 0; expectedSecondOutputSub= 1'b 0; expectedOutputMult= 8'b 00000000; 
			expectedOutputSub= 8'b 00000000; expectedSecondOutputMult= 8'b 00000000; expectedOutputAdd= 8'b 00000000; expectedOutputDiv= 8'b 00000000; expectedSecondOutputDiv= 8'b 00000000;
		#10 c= 1'b 0; b= 8'b 00000001; d= 8'b 00000000; a= 8'b 10000000; expectedOutputAdd= 8'b 00000001; expectedSecondOutputAdd= 1'b 0; expectedOutputSub= 8'b 00000001; expectedSecondOutputSub= 1'b 0; 
			expectedOutputMult= 8'b 10000000; expectedSecondOutputMult= 8'b 00000000; expectedOutputDiv= 8'b 00000001; expectedSecondOutputDiv= 8'b 00000000;	
		#10 c= 1'b 0; b= 8'b 00000001; d= 8'b 00000001; a= 8'b 10000000; expectedOutputAdd= 8'b 00000010; expectedSecondOutputAdd= 1'b 0; expectedOutputSub= 8'b 00000000; expectedSecondOutputSub= 1'b 0; 
			expectedOutputMult= 8'b 10000001; expectedSecondOutputMult= 8'b 00000000; expectedOutputDiv= 8'b 00000001; expectedSecondOutputDiv= 8'b 00000000;			
		#10 c= 1'b 1; b= 8'b 00100001; d= 8'b 00000001; a= 8'b 10001000; expectedOutputAdd= 8'b 00100011; expectedSecondOutputAdd= 1'b 0; expectedOutputSub= 8'b 00011111; expectedSecondOutputSub= 1'b 0; 
			expectedOutputMult= 8'b 10101001; expectedSecondOutputMult= 8'b 00000000; expectedOutputDiv= 8'b 00100001; expectedSecondOutputDiv= 8'b 00000000;		
		#10 c= 1'b 1; b= 8'b 10100001; d= 8'b 10000001; a= 8'b 10001000; expectedOutputAdd= 8'b 00100011; expectedSecondOutputAdd= 1'b 1; expectedOutputSub= 8'b 00011111; expectedSecondOutputSub= 1'b 0; 
			expectedOutputMult= 8'b 10101001; expectedSecondOutputMult= 8'b 01010001; expectedOutputDiv= 8'b 00001111; expectedSecondOutputDiv= 8'b 00010010;		
		#10 c= 1'b 1; b= 8'b 10100001; d= 8'b 11000001; a= 8'b 10101000; expectedOutputAdd= 8'b 01100011; expectedSecondOutputAdd= 1'b 1; expectedOutputSub= 8'b 11011111; expectedSecondOutputSub= 1'b 1; 
			expectedOutputMult= 8'b 00001001; expectedSecondOutputMult= 8'b 01111010; expectedOutputDiv= 8'b 11011111; expectedSecondOutputDiv= 8'b 10000010;		
		#10 c= 1'b 0; b= 8'b 10100001; d= 8'b 11000001; a= 8'b 00000000; expectedOutputAdd= 8'b 01100010; expectedSecondOutputAdd= 1'b 1; expectedOutputSub= 8'b 11100000; expectedSecondOutputSub= 1'b 1; 
			expectedOutputMult= 8'b 01100001; expectedSecondOutputMult= 8'b 01111001; expectedOutputDiv= 8'b 00000000; expectedSecondOutputDiv= 8'b 10100001;		
		#10 c= 1'b x; b= 8'b 10100001; d= 8'b 11000001; a= 8'b 00x00000; expectedOutputAdd= 8'b 01100010; expectedSecondOutputAdd= 1'b 1; expectedOutputSub= 8'b 11100000; expectedSecondOutputSub= 1'b 1; 
			expectedOutputMult= 8'b xxx00001; expectedSecondOutputMult= 8'b xxxxxxxx; expectedOutputDiv= 8'b xxxxxxxx; expectedSecondOutputDiv= 8'b xxxxxxxx;	
		#10 c= 1'b x; b= 8'b 10100001; d= 8'b 11000x01; a= 8'b 00x00000; expectedOutputAdd= 8'b xxxxxx10; expectedSecondOutputAdd= 1'b x; expectedOutputSub= 8'b xxxxxx00; expectedSecondOutputSub= 1'b x; 
			expectedOutputMult= 8'b xxxxxx01; expectedSecondOutputMult= 8'b xxxxxxxx; expectedOutputDiv= 8'b xxxxxxxx; expectedSecondOutputDiv= 8'b xxxxxxxx;	
		#10 c= 1'b 1; b= 8'b 11000x11; d= 8'b 11000011; a= 8'b 00000001; expectedOutputAdd= 8'b xxxxxx11; expectedSecondOutputAdd= 1'b x; expectedOutputSub= 8'b xxxxxx11; expectedSecondOutputSub= 1'b x; 
			expectedOutputMult= 8'b xxxxxx10; expectedSecondOutputMult= 8'b xxxxxxxx; expectedOutputDiv= 8'b xxxxxxxx; expectedSecondOutputDiv= 8'b xxxxxxxx;	
		#10 c= 1'b x; b= 8'b 1x100011; d= 8'b 11000011; a= 8'b 00100001; expectedOutputAdd= 8'b xx100110; expectedSecondOutputAdd= 1'b x; expectedOutputSub= 8'b xx100000; expectedSecondOutputSub= 1'b x; 
			expectedOutputMult= 8'b xx111010; expectedSecondOutputMult= 8'b xxxxxxxx; expectedOutputDiv= 8'b xxxxxxxx; expectedSecondOutputDiv= 8'b xxxxxxxx;	
		#10 c= 1'b x; b= 8'b 1x100011; d= 8'b 11000011; a= 8'b 00100x00; expectedOutputAdd= 8'b xx100110; expectedSecondOutputAdd= 1'b x; expectedOutputSub= 8'b xx100000; expectedSecondOutputSub= 1'b x; 
			expectedOutputMult= 8'b xxxxxx01; expectedSecondOutputMult= 8'b xxxxxxxx; expectedOutputDiv= 8'b xxxxxxxx; expectedSecondOutputDiv= 8'b xxxxxxxx;	
		#10 c= 1'b 1; b= 8'b 10100011; d= 8'b 11000011; a= 8'b 00010100; expectedOutputAdd= 8'b 01100111; expectedSecondOutputAdd= 1'b 1; expectedOutputSub= 8'b 11011111; expectedSecondOutputSub= 1'b 1; 
			expectedOutputMult= 8'b 00111101; expectedSecondOutputMult= 8'b 01111100; expectedOutputDiv= 8'b 00011011; expectedSecondOutputDiv= 8'b 00010010;	
		#20;
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simpleCarryArithmetic4);
	end
endmodule 