module test_simpleFlipFlop2;

	reg [0:0] a, b, c, d, e, expectedDLow, expectedDLow2, expectedDFalling, expectedDFalling2, expectedTRising, expectedTRising2;
	reg [0:0] expectedJKFalling, expectedJKFalling2, expectedSRHigh, expectedSRHigh2, expectedSRRising, expectedSRRising2;
	wire [0:0] f, g, h, i, j, k, l, m, n, o, p, q;
	
	simpleFlipFlop2 testObj(.firstInput(a), .enableInput(b), .setInput(c), .secondInput(d), .resetInput(e), 
			.SRRising2(f), .DFalling(g), .DFalling2(h), .SRHigh2(i), .JKFalling2(j), .TRising(k), .JKFalling(l), 
			.SRRising(m), .SRHigh(n), .DLow2(o), .TRising2(p), .DLow(q));
	
	initial 
	begin	
		$display("Testen van de simpleFlipFlop2.");
		#0 a= 1'b x; d= 1'b x; c= 1'b x; b= 1'b x; e= 1'b x; 
			expectedDLow= 1'b 0; expectedDLow2= 1'b 1; expectedDFalling= 1'b 0; expectedDFalling2= 1'b 1; 
			expectedTRising= 1'b 0; expectedTRising2= 1'b 1; expectedJKFalling=1'b 0; expectedJKFalling2= 1'b 1;
			expectedSRHigh= 1'b 0; expectedSRHigh2= 1'b 1; expectedSRRising= 1'b 0; expectedSRRising2= 1'b 1;
		#1 a= 1'b 0; d= 1'b 0; c= 1'b 0; b= 1'b 0; e= 1'b x; 
			expectedDLow= 1'b 0; expectedDLow2= 1'b 1; expectedDFalling= 1'b 0; expectedDFalling2= 1'b 1; 
			expectedTRising= 1'b 0; expectedTRising2= 1'b 1; expectedJKFalling=1'b 0; expectedJKFalling2= 1'b 1;
			expectedSRHigh= 1'b 0; expectedSRHigh2= 1'b 1; expectedSRRising= 1'b 0; expectedSRRising2= 1'b 1;
		#1 a= 1'b 0; d= 1'b 0; c= 1'b 1; b= 1'b 0; e= 1'b x; 
			expectedDLow= 1'b 1; expectedDLow2= 1'b 0; expectedDFalling= 1'b 1; expectedDFalling2= 1'b 0; 
			expectedTRising= 1'b 1; expectedTRising2= 1'b 0; expectedJKFalling=1'b 1; expectedJKFalling2= 1'b 0;
			expectedSRHigh= 1'b 1; expectedSRHigh2= 1'b 0; expectedSRRising= 1'b 1; expectedSRRising2= 1'b 0;	
		#1 a= 1'b 0; d= 1'b 0; c= 1'b 1; b= 1'b 0; e= 1'b 1; 
			expectedDLow= 1'b 0; expectedDLow2= 1'b 1; expectedDFalling= 1'b 0; expectedDFalling2= 1'b 1; 
			expectedTRising= 1'b 0; expectedTRising2= 1'b 1; expectedJKFalling=1'b 0; expectedJKFalling2= 1'b 1;
			expectedSRHigh= 1'b 0; expectedSRHigh2= 1'b 1; expectedSRRising= 1'b 0; expectedSRRising2= 1'b 1;
		#1 a= 1'b 1; d= 1'b 0; c= 1'b 0; b= 1'b 1; e= 1'b 0; 
			expectedDLow= 1'b 1; expectedDLow2= 1'b 0; expectedDFalling= 1'b 0; expectedDFalling2= 1'b 1; 
			expectedTRising= 1'b 0; expectedTRising2= 1'b 1; expectedJKFalling=1'b 0; expectedJKFalling2= 1'b 1;
			expectedSRHigh= 1'b 0; expectedSRHigh2= 1'b 1; expectedSRRising= 1'b 0; expectedSRRising2= 1'b 1;	
		#1 a= 1'b x; d= 1'b 0; c= 1'b 0; b= 1'b 1; e= 1'b 0; 
			expectedDLow= 1'b 1; expectedDLow2= 1'b 0; expectedDFalling= 1'b 0; expectedDFalling2= 1'b 1; 
			expectedTRising= 1'b 0; expectedTRising2= 1'b 1; expectedJKFalling=1'b 0; expectedJKFalling2= 1'b 1;
			expectedSRHigh= 1'b 0; expectedSRHigh2= 1'b 1; expectedSRRising= 1'b 0; expectedSRRising2= 1'b 1;	
		//Clock rises
		#5 a= 1'b 1; d= 1'b 0; c= 1'b 0; b= 1'b 1; e= 1'b 0; 
			expectedDLow= 1'b 1; expectedDLow2= 1'b 0; expectedDFalling= 1'b 0; expectedDFalling2= 1'b 1; 
			expectedTRising= 1'b 1; expectedTRising2= 1'b 0; expectedJKFalling=1'b 0; expectedJKFalling2= 1'b 1;
			expectedSRHigh= 1'b 1; expectedSRHigh2= 1'b 0; expectedSRRising= 1'b 1; expectedSRRising2= 1'b 0;
		#1 a= 1'b 0; d= 1'b 1; c= 1'b 0; b= 1'b 1; e= 1'b 0; 
			expectedDLow= 1'b 1; expectedDLow2= 1'b 0; expectedDFalling= 1'b 0; expectedDFalling2= 1'b 1; 
			expectedTRising= 1'b 1; expectedTRising2= 1'b 0; expectedJKFalling=1'b 0; expectedJKFalling2= 1'b 1;
			expectedSRHigh= 1'b 0; expectedSRHigh2= 1'b 1; expectedSRRising= 1'b 1; expectedSRRising2= 1'b 0;	
		#1 a= 1'b 1; d= 1'b 0; c= 1'b 0; b= 1'b 1; e= 1'b 0; 
			expectedDLow= 1'b 1; expectedDLow2= 1'b 0; expectedDFalling= 1'b 0; expectedDFalling2= 1'b 1; 
			expectedTRising= 1'b 1; expectedTRising2= 1'b 0; expectedJKFalling=1'b 0; expectedJKFalling2= 1'b 1;
			expectedSRHigh= 1'b 1; expectedSRHigh2= 1'b 0; expectedSRRising= 1'b 1; expectedSRRising2= 1'b 0;	
		#1 a= 1'b 1; d= 1'b 1; c= 1'b 0; b= 1'b 1; e= 1'b 0; 
			expectedDLow= 1'b 1; expectedDLow2= 1'b 0; expectedDFalling= 1'b 0; expectedDFalling2= 1'b 1; 
			expectedTRising= 1'b 1; expectedTRising2= 1'b 0; expectedJKFalling=1'b 0; expectedJKFalling2= 1'b 1;
			expectedSRHigh= 1'b 1; expectedSRHigh2= 1'b 0; expectedSRRising= 1'b 1; expectedSRRising2= 1'b 0;				
		//Clock falls	
		#7 a= 1'b 1; d= 1'b 1; c= 1'b 0; b= 1'b 1; e= 1'b 0; 
			expectedDLow= 1'b 1; expectedDLow2= 1'b 0; expectedDFalling= 1'b 1; expectedDFalling2= 1'b 0; 
			expectedTRising= 1'b 1; expectedTRising2= 1'b 0; expectedJKFalling=1'b 1; expectedJKFalling2= 1'b 0;
			expectedSRHigh= 1'b 1; expectedSRHigh2= 1'b 0; expectedSRRising= 1'b 1; expectedSRRising2= 1'b 0;	
		//Clock rises	
		#10 a= 1'b 0; d= 1'b 0; c= 1'b 0; b= 1'b 0; e= 1'b 0; 
			expectedDLow= 1'b 1; expectedDLow2= 1'b 0; expectedDFalling= 1'b 1; expectedDFalling2= 1'b 0; 
			expectedTRising= 1'b 1; expectedTRising2= 1'b 0; expectedJKFalling=1'b 1; expectedJKFalling2= 1'b 0;
			expectedSRHigh= 1'b 1; expectedSRHigh2= 1'b 0; expectedSRRising= 1'b 1; expectedSRRising2= 1'b 0;		
		//Clock falls	
		#10 a= 1'b 0; d= 1'b 0; c= 1'b 1; b= 1'b 1; e= 1'b 1; 
			expectedDLow= 1'b 0; expectedDLow2= 1'b 1; expectedDFalling= 1'b 0; expectedDFalling2= 1'b 1; 
			expectedTRising= 1'b 0; expectedTRising2= 1'b 1; expectedJKFalling=1'b 0; expectedJKFalling2= 1'b 1;
			expectedSRHigh= 1'b 0; expectedSRHigh2= 1'b 1; expectedSRRising= 1'b 0; expectedSRRising2= 1'b 1;	
		#20 $finish; 
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simpleFlipFlop2);
	end
endmodule 