module test_simpleInOutputAndExtra3;
	
	reg [0:0] a, b, c, d;
	reg [3:0] e, f;
	wire [3:0] g;
	wire [7:0] h, i, j, m, o, p;
	wire [0:0] k, n;
	wire [1:0] l;
	reg [3:0] expectedPrio;
	reg [7:0] expectedExtInput, expectedExtZero, expectedExtOne, expectedOutSign, expectedExtOneWithout, expectedExtInputWithout;
	reg [0:0] expectedPrioEnable, expectedPrioGroup;
	reg [1:0] expectedExtBigger;
	
	simpleInOutputAndExtra3 testObj(.inPrioExt(a), .extraInputExt(b), .inPrio(c), .in2Prio(d), .in1Joystick10(e), .in2Joystick10(f), 
									.outPrio(g), .outExtInput(h), .outExtOne(i), .outExtZero(j), .enableOutput(k), .outExtBiggerInput(l), 
									.outExtInputWithoutInput(m), .groupOut(n), .outExtOneWithoutInput(o), .outExtSign(p));

	initial 
	begin	
		$display("Testen van de simpleInOutputAndExtra3.");
		#0 a= 1'b x; c= 1'b x; d= 1'b x; expectedPrio= 4'b zzzz; expectedPrioEnable= 1'b 1; expectedPrioGroup= 1'b 0;
			e= 4'b xxxx; f= 4'b xxxx; b= 1'b x; expectedExtInput= 8'b xxxxxxxx; expectedExtZero= 8'b 0000xxxx; expectedExtOne= 8'b 1111xxxx; 
			expectedOutSign= 8'b xxxxxxxx; expectedExtBigger= 2'b xx; expectedExtOneWithout= 8'b 1111zzzz; expectedExtInputWithout= 8'b xxxxzzzz;
		#10 a= 1'b 0; c= 1'b x; d= 1'b x; expectedPrio= 4'b zzzz; expectedPrioEnable= 1'b 0; expectedPrioGroup= 1'b 0;	
			e= 4'b xxxx; f= 4'b xxxx; b= 1'b 0; expectedExtInput= 8'b 0000xxxx; expectedExtZero= 8'b 0000xxxx; expectedExtOne= 8'b 1111xxxx; 
			expectedOutSign= 8'b xxxxxxxx; expectedExtBigger= 2'b xx; expectedExtOneWithout= 8'b 1111zzzz; expectedExtInputWithout= 8'b 0000zzzz;
		#10 a= 1'b 1; c= 1'b x; d= 1'b x; expectedPrio= 4'b zzzz; expectedPrioEnable= 1'b 1; expectedPrioGroup= 1'b 0;	
			e= 4'b xxxx; f= 4'b xxxx; b= 1'b 1; expectedExtInput= 8'b 1111xxxx; expectedExtZero= 8'b 0000xxxx; expectedExtOne= 8'b 1111xxxx; 
			expectedOutSign= 8'b xxxxxxxx; expectedExtBigger= 2'b xx; expectedExtOneWithout= 8'b 1111zzzz; expectedExtInputWithout= 8'b 1111zzzz;
		#10 a= 1'b x; c= 1'b 0; d= 1'b 0; expectedPrio= 4'b zzzz; expectedPrioEnable= 1'b 1; expectedPrioGroup= 1'b 0;	
			e= 4'b x0x0; f= 4'b xxxx; b= 1'b 1; expectedExtInput= 8'b 1111x0x0; expectedExtZero= 8'b 0000x0x0; expectedExtOne= 8'b 1111x0x0; 
			expectedOutSign= 8'b xxxxx0x0; expectedExtBigger= 2'b x0; expectedExtOneWithout= 8'b 1111zzzz; expectedExtInputWithout= 8'b 1111zzzz;
		#10 a= 1'b x; c= 1'b 1; d= 1'b 0; expectedPrio= 4'b 1101; expectedPrioEnable= 1'b 0; expectedPrioGroup= 1'b 1;	
			e= 4'b x0x0; f= 4'b xxxx; b= 1'b 0; expectedExtInput= 8'b 0000x0x0; expectedExtZero= 8'b 0000x0x0; expectedExtOne= 8'b 1111x0x0; 
			expectedOutSign= 8'b xxxxx0x0; expectedExtBigger= 2'b x0; expectedExtOneWithout= 8'b 1111zzzz; expectedExtInputWithout= 8'b 0000zzzz;
		#10 a= 1'b x; c= 1'b x; d= 1'b 1; expectedPrio= 4'b 1111; expectedPrioEnable= 1'b 0; expectedPrioGroup= 1'b 1;	
			e= 4'b 1010; f= 4'b xxxx; b= 1'b 1; expectedExtInput= 8'b 11111010; expectedExtZero= 8'b 00001010; expectedExtOne= 8'b 11111010; 
			expectedOutSign= 8'b 11111010; expectedExtBigger= 2'b 10; expectedExtOneWithout= 8'b 1111zzzz; expectedExtInputWithout= 8'b 1111zzzz;
		#10 a= 1'b x; c= 1'b 1; d= 1'b 1; expectedPrio= 4'b 1111; expectedPrioEnable= 1'b 0; expectedPrioGroup= 1'b 1;	
			e= 4'b x010; f= 4'b xxxx; b= 1'b 1; expectedExtInput= 8'b 1111x010; expectedExtZero= 8'b 0000x010; expectedExtOne= 8'b 1111x010; 
			expectedOutSign= 8'b xxxxx010; expectedExtBigger= 2'b 10; expectedExtOneWithout= 8'b 1111zzzz; expectedExtInputWithout= 8'b 1111zzzz;
		#10 a= 1'b 0; c= 1'b 1; d= 1'b 1; expectedPrio= 4'b zzzz; expectedPrioEnable= 1'b 0; expectedPrioGroup= 1'b 0;	
			e= 4'b 1110; f= 4'b xxxx; b= 1'b x; expectedExtInput= 8'b xxxx1110; expectedExtZero= 8'b 00001110; expectedExtOne= 8'b 11111110; 
			expectedOutSign= 8'b 11111110; expectedExtBigger= 2'b 10; expectedExtOneWithout= 8'b 1111zzzz; expectedExtInputWithout= 8'b xxxxzzzz;	
		#10 a= 1'b 0; c= 1'b 1; d= 1'b 1; expectedPrio= 4'b zzzz; expectedPrioEnable= 1'b 0; expectedPrioGroup= 1'b 0;	
			e= 4'b 1110; f= 4'b xxxx; b= 1'b z; expectedExtInput= 8'b zzzz1110; expectedExtZero= 8'b 00001110; expectedExtOne= 8'b 11111110; 
			expectedOutSign= 8'b 11111110; expectedExtBigger= 2'b 10; expectedExtOneWithout= 8'b 1111zzzz; expectedExtInputWithout= 8'b zzzzzzz;	
		#20 $finish;
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simpleInOutputAndExtra3);
	end
endmodule 