module test_simpleLargeMemoryAndShiftRegister3;

	reg [0:0] a, b, c, expectedOutNotPar, e, f;
	reg [1:0] g, h, i, j, k, l, expected0, expected1, expected2, expected3, expected4, expectedPar;
	wire [0:0] d;
	wire [1:0] m, n, o, p, q, r;
	
	
	simpleLargeMemoryAndShiftRegister3 testObj(.reset(a), .in2(b), .shift2(c), .outNotPar(d), .load(e), .shift1(f), 
			.in1(g), .par0(h), .par1(i), .par2(j), .par3(k), .par4(l), .out0(m), .out1(n), .out2(o), .out3(p), .out4(q), .outPar(r));
	
	initial 
	begin	
		$display("Testen van de simpleLargeMemoryAndShiftRegister3.");
		a= 1'b x; 
		b= 1'b 0; c= 1'b 0; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 0; g= 2'b 00; h= 2'b 00; i= 2'b 00; j= 2'b 00; k= 2'b 00; l= 2'b 00; 
		expected0= 2'b 00; expected1= 2'b 00; expected2= 2'b 00; expected3= 2'b 00; expected4= 2'b 00; expectedPar= 2'b 00; 
		//Clock rises
		#10 a= 1'b 0; 
		b= 1'b 0; c= 1'b 0; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 1; g= 2'b 01; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 01; expected1= 2'b 00; expected2= 2'b 00; expected3= 2'b 00; expected4= 2'b 00; expectedPar= 2'b 00; 
		//Counter falls 
		#10 a= 1'b 0; 
		b= 1'b x; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 1; g= 2'b 01; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 01; expected1= 2'b 00; expected2= 2'b 00; expected3= 2'b 00; expected4= 2'b 00; expectedPar= 2'b 00; 
		//Clock rises
		#10 a= 1'b 0; 
		b= 1'b x; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 1; g= 2'b 11; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 11; expected1= 2'b 01; expected2= 2'b 00; expected3= 2'b 00; expected4= 2'b 00; expectedPar= 2'b 00; 
		//Counter falls 
		#10 a= 1'b 0; 
		b= 1'b 0; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 1; g= 2'b 01; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 11; expected1= 2'b 01; expected2= 2'b 00; expected3= 2'b 00; expected4= 2'b 00; expectedPar= 2'b 00; 
		//Clock rises
		#10 a= 1'b 0; 
		b= 1'b x; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 1; g= 2'b 0x; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 0x; expected1= 2'b 11; expected2= 2'b 01; expected3= 2'b 00; expected4= 2'b 00; expectedPar= 2'b 00; 
		//Counter falls 
		#10 a= 1'b 0; 
		b= 1'b 1; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 1; g= 2'b 01; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 0x; expected1= 2'b 11; expected2= 2'b 01; expected3= 2'b 00; expected4= 2'b 00; expectedPar= 2'b 00; 
		//Clock rises
		#10 a= 1'b 0; 
		b= 1'b x; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 1; f= 1'b 1; g= 2'b 01; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b xx; 
		expected0= 2'b 10; expected1= 2'b 11; expected2= 2'b 00; expected3= 2'b 01; expected4= 2'b xx; expectedPar= 2'b xx; 
		//Counter falls 
		#10 a= 1'b 0; 
		b= 1'b x; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 1; g= 2'b 01; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 10; expected1= 2'b 11; expected2= 2'b 00; expected3= 2'b 01; expected4= 2'b xx; expectedPar= 2'b xx; 
		//Clock rises
		#10 a= 1'b 0; 
		b= 1'b x; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 1; f= 1'b 0; g= 2'b 11; h= 2'b 11; i= 2'b 10; j= 2'b 01; k= 2'b 11; l= 2'b 0x; 
		expected0= 2'b 11; expected1= 2'b 10; expected2= 2'b 01; expected3= 2'b 11; expected4= 2'b 0x; expectedPar= 2'b 0x; 
		//Counter falls 
		#10 a= 1'b 0; 
		b= 1'b 0; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 1; g= 2'b 01; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 11; expected1= 2'b 10; expected2= 2'b 01; expected3= 2'b 11; expected4= 2'b 0x; expectedPar= 2'b 0x; 
		//Clock rises
		#10 a= 1'b 0; 
		b= 1'b x; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 0; g= 2'b 11; h= 2'b 11; i= 2'b 10; j= 2'b 01; k= 2'b 11; l= 2'b 0x; 
		expected0= 2'b 11; expected1= 2'b 10; expected2= 2'b 01; expected3= 2'b 11; expected4= 2'b 0x; expectedPar= 2'b 0x; 
		//Clock falls
		#10 a= 1'b 0; 
		b= 1'b 1; c= 1'b 1; expectedOutNotPar= 1'b x; 
		e= 1'b 0; f= 1'b 0; g= 2'b 01; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 11; expected1= 2'b 10; expected2= 2'b 01; expected3= 2'b 11; expected4= 2'b 0x; expectedPar= 2'b 0x; 
		//Clock falls 
		#20 a= 1'b 0; 
		b= 1'b 1; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 1; g= 2'b 01; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 11; expected1= 2'b 10; expected2= 2'b 01; expected3= 2'b 11; expected4= 2'b 0x; expectedPar= 2'b 0x; 
		//Clock rises
		#10 a= 1'b 0; 
		b= 1'b x; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 1; g= 2'b 10; h= 2'b 11; i= 2'b 10; j= 2'b 01; k= 2'b 11; l= 2'b 0x; 
		expected0= 2'b 10; expected1= 2'b 11; expected2= 2'b 10; expected3= 2'b 01; expected4= 2'b 11; expectedPar= 2'b 11; 
		//Clock falls 
		#10 a= 1'b 0; 
		b= 1'b 1; c= 1'b 1; expectedOutNotPar= 1'b 1; 
		e= 1'b 0; f= 1'b 0; g= 2'b 01; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 10; expected1= 2'b 11; expected2= 2'b 10; expected3= 2'b 01; expected4= 2'b 11; expectedPar= 2'b 11; 
		//Clock falls
		#20 a= 1'b 0; 
		b= 1'b 1; c= 1'b 1; expectedOutNotPar= 1'b x; 
		e= 1'b 0; f= 1'b 0; g= 2'b 01; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 10; expected1= 2'b 11; expected2= 2'b 10; expected3= 2'b 01; expected4= 2'b 11; expectedPar= 2'b 11; 
		//Clock rises
		#10 a= 1'b 1; 
		b= 1'b 1; c= 1'b 1; expectedOutNotPar= 1'b 0; 
		e= 1'b 0; f= 1'b 0; g= 2'b 01; h= 2'b 10; i= 2'b 11; j= 2'b 00; k= 2'b 01; l= 2'b 00; 
		expected0= 2'b 00; expected1= 2'b 00; expected2= 2'b 00; expected3= 2'b 00; expected4= 2'b 00; expectedPar= 2'b 00; 
		
		#20 $finish; 
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simpleLargeMemoryAndShiftRegister3);
	end
endmodule 