module test_simpleOtherArithmetic2;
	
	reg [2:0] a, b;
	reg [5:0] i, expectedNegator;
	reg [4:0] k, expectedShift;
	reg expectedEqualComp, expectedGreaterComp, expectedLessComp, expectedEqual, expectedGreater, expectedLess, expectedFind, expectedComp; 
	reg [3:0] expectedAdd;
	wire c, d, e, f, g, h, m, o;
	wire [5:0] j;
	wire [4:0] l;
	wire[3:0] n;
	
	simpleOtherArithmetic2 testObj(.firstInputComparator(a), .secondInputComparator(b), .eq2Comp(c), .gr2Comp(d), .le2Comp(e), .eq(f), .gr(g), .le(h), .inputNegator(i), .outputNegator(j), 
									.firstInput(k), .outShift(l), .outFinder(m), .outAdder(n), .outComp(o));

	initial 
	begin	
		$display("Testen van de simpleOtherArithmetic2.");
		#0 a= 3'b 000; b= 3'b 000; expectedEqualComp= 1; expectedGreaterComp= 0; expectedLessComp= 0; expectedEqual= 1; expectedGreater= 0; expectedLess= 0; 
			i= 6'b 000000; expectedNegator= 6'b 000000; k= 5'b 00000; expectedShift= 5'b xxxxx; expectedComp= 1'b x; expectedAdd= 4'b xxxx; expectedFind= 1'b x;
		#10 a= 3'b 100; b= 3'b 100; expectedEqualComp= 1; expectedGreaterComp= 0; expectedLessComp= 0; expectedEqual= 1; expectedGreater= 0; expectedLess= 0;
			i= 6'b 111111; expectedNegator= 6'b 000001; k= 5'b 00001; expectedShift= 5'b xxxxx; expectedComp= 1'b x; expectedAdd= 4'b xxxx; expectedFind= 1'b x;
		#10 a= 3'b 1x0; b= 3'b 1x0; expectedEqualComp= 1'b x; expectedGreaterComp= 1'b x; expectedLessComp= 1'b x; expectedEqual= 1'b x; expectedGreater= 1'b x; expectedLess= 1'b x;
			i= 6'b 010101; expectedNegator= 6'b 101011; k= 5'b 00010; expectedShift= 5'b xxxxx; expectedComp= 1'b x; expectedAdd= 4'b xxxx; expectedFind= 1'b x;
		#10 a= 3'b 100; b= 3'b 1x0; expectedEqualComp= 1'b x; expectedGreaterComp= 1'b x; expectedLessComp= 1'b x; expectedEqual= 1'b x; expectedGreater= 1'b x; expectedLess= 1'b x;
			i= 6'b 1x0101; expectedNegator= 6'b 0x1011; k= 5'b 00110; expectedShift= 5'b xxxxx; expectedComp= 1'b x; expectedAdd= 4'b xxxx; expectedFind= 1'b x;
		#10 a= 3'b 1x0; b= 3'b 110; expectedEqualComp= 1'b x; expectedGreaterComp= 1'b x; expectedLessComp= 1'b x; expectedEqual= 1'b x; expectedGreater= 1'b x; expectedLess= 1'b x;
			i= 6'b 1xx110; expectedNegator= 6'b 0xx010; k= 5'b 10000; expectedShift= 5'b xxxxx; expectedComp= 1'b x; expectedAdd= 4'b xxxx; expectedFind= 1'b x;
		#10 a= 3'b 000; b= 3'b 010; expectedEqualComp= 0; expectedGreaterComp= 0; expectedLessComp= 1; expectedEqual= 0; expectedGreater= 0; expectedLess= 1;
			i= 6'b x00000; expectedNegator= 6'b x00000; k= 5'b 01010; expectedShift= 5'b xxxxx; expectedComp= 1'b x; expectedAdd= 4'b xxxx; expectedFind= 1'b x;
		#10 a= 3'b 010; b= 3'b 000; expectedEqualComp= 0; expectedGreaterComp= 1; expectedLessComp= 0; expectedEqual= 0; expectedGreater= 1; expectedLess= 0;
			i= 6'b x10101; expectedNegator= 6'b x01011; k= 5'b 00x00; expectedShift= 5'b xxxxx; expectedComp= 1'b x; expectedAdd= 4'b xxxx; expectedFind= 1'b x;
		#10 a= 3'b 100; b= 3'b 000; expectedEqualComp= 0; expectedGreaterComp= 0; expectedLessComp= 1; expectedEqual= 0; expectedGreater= 1; expectedLess= 0;
			i= 6'b 1x1x0x; expectedNegator= 6'b 0xxxxx; k= 5'b 0xx00; expectedShift= 5'b xxxxx; expectedComp= 1'b x; expectedAdd= 4'b xxxx; expectedFind= 1'b x;
		#10 a= 3'b 100; b= 3'b 110; expectedEqualComp= 0; expectedGreaterComp= 0; expectedLessComp= 1; expectedEqual= 0; expectedGreater= 0; expectedLess= 1;
			i= 6'b 1x1001; expectedNegator= 6'b 0x0111; k= 5'b 11000; expectedShift= 5'b xxxxx; expectedComp= 1'b x; expectedAdd= 4'b xxxx; expectedFind= 1'b x;
		#10 a= 3'b 111; b= 3'b 100; expectedEqualComp= 0; expectedGreaterComp= 1; expectedLessComp= 0; expectedEqual= 0; expectedGreater= 1; expectedLess= 0;
			i= 6'b 1x1xx1; expectedNegator= 6'b 0x0xx1; k= 5'b 1100x; expectedShift= 5'b xxxxx; expectedComp= 1'b x; expectedAdd= 4'b xxxx; expectedFind= 1'b x;
		#10 a= 3'b 1x0; b= 3'b 0xx; expectedEqualComp= 1'b x; expectedGreaterComp= 0; expectedLessComp= 1; expectedEqual= 1'b x; expectedGreater= 1; expectedLess= 0;
			i= 6'b 1x1xx0; expectedNegator= 6'b 0xxxx0; k= 5'b x0000; expectedShift= 5'b xxxxx; expectedComp= 1'b x; expectedAdd= 4'b xxxx; expectedFind= 1'b x;
		#10 a= 3'b 0xx; b= 3'b 1xx; expectedEqualComp= 1'b x; expectedGreaterComp= 1; expectedLessComp= 0; expectedEqual= 1'b x; expectedGreater= 0; expectedLess= 1;
			i= 6'b 1x0x01; expectedNegator= 6'b 0x1x11; k= 5'b xxxxx; expectedShift= 5'b xxxxx; expectedComp= 1'b x; expectedAdd= 4'b xxxx; expectedFind= 1'b x;
		#20;
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simpleOtherArithmetic2);
	end
endmodule 