module test_simpleOtherArithmetic3;
	
	reg [2:0] a;
	reg [4:0] b, expectedShiftLL, expectedShiftLR, expectedShiftAR, expectedRL, expectedRR;
	wire [4:0] c, d, e, f, g;
		
	simpleOtherArithmetic3 testObj(.distance(a), .inputShift(b), .outLL(c), .outLR(d), .outputAR(e), .outputRL(f), .outputRR(g));
	
	initial 
	begin	
		$display("Testen van de simpleOtherArithmetic3.");
		#0 a= 3'b 000; b= 5'b 10000; expectedShiftLL= 5'b 10000; expectedShiftLR= 5'b 10000; expectedShiftAR= 5'b 10000; 
			expectedRL= 5'b 10000; expectedRR= 5'b 10000; 
		#10 a= 3'b 0x0; b= 5'b xxxxx; expectedShiftLL= 5'b xxxxx; expectedShiftLR= 5'b xxxxx; expectedShiftAR= 5'b xxxxx; 
			expectedRL= 5'b xxxxx; expectedRR= 5'b xxxxx; 
		#10 a= 3'b xx0; b= 5'b 11111; expectedShiftLL= 5'b xxxxx; expectedShiftLR= 5'b xxxxx; expectedShiftAR= 5'b xxxxx; 
			expectedRL= 5'b xxxxx; expectedRR= 5'b xxxxx; 
		#10 a= 3'b 001; b= 5'b 10000; expectedShiftLL= 5'b 00000; expectedShiftLR= 5'b 01000; expectedShiftAR= 5'b 11000; 
			expectedRL= 5'b 00001; expectedRR= 5'b 01000; 
		#10 a= 3'b 001; b= 5'b 10110; expectedShiftLL= 5'b 01100; expectedShiftLR= 5'b 01011; expectedShiftAR= 5'b 11011; 
			expectedRL= 5'b 01101; expectedRR= 5'b 01011; 
		#10 a= 3'b 001; b= 5'b x0110; expectedShiftLL= 5'b 01100; expectedShiftLR= 5'b 0x011; expectedShiftAR= 5'b xx011; 
			expectedRL= 5'b 0110x; expectedRR= 5'b 0x011; 
		#10 a= 3'b 001; b= 5'b 1011x; expectedShiftLL= 5'b 011x0; expectedShiftLR= 5'b 01011; expectedShiftAR= 5'b 11011; 
			expectedRL= 5'b 011x1; expectedRR= 5'b x1011; 
		#10 a= 3'b 010; b= 5'b 1011x; expectedShiftLL= 5'b 11x00; expectedShiftLR= 5'b 00101; expectedShiftAR= 5'b 11101; 
			expectedRL= 5'b 11x10; expectedRR= 5'b 1x101; 
		#10 a= 3'b 010; b= 5'b xxxxx; expectedShiftLL= 5'b xxx00; expectedShiftLR= 5'b 00xxx; expectedShiftAR= 5'b xxxxx; 
			expectedRL= 5'b xxxxx; expectedRR= 5'b xxxxx; 
		#10 a= 3'b 011; b= 5'b 101x1; expectedShiftLL= 5'b x1000; expectedShiftLR= 5'b 00010; expectedShiftAR= 5'b 11110; 
			expectedRL= 5'b x1101; expectedRR= 5'b 1x110; 
		#10 a= 3'b 100; b= 5'b 011x1; expectedShiftLL= 5'b 10000; expectedShiftLR= 5'b 00000; expectedShiftAR= 5'b 00000; 
			expectedRL= 5'b 1011x; expectedRR= 5'b 11x10; 
		#10 a= 3'b 110; b= 5'b 010x1; expectedShiftLL= 5'b 00000; expectedShiftLR= 5'b 00000; expectedShiftAR= 5'b 00000; 
			expectedRL= 5'b 10x10; expectedRR= 5'b 1010x; 
		#10 a= 3'b 111; b= 5'b 111x1; expectedShiftLL= 5'b 00000; expectedShiftLR= 5'b 00000; expectedShiftAR= 5'b 11111; 
			expectedRL= 5'b 1x111; expectedRR= 5'b x1111; 
		#10 a= 3'b 111; b= 5'b 101x1; expectedShiftLL= 5'b 00000; expectedShiftLR= 5'b 00000; expectedShiftAR= 5'b 11111; 
			expectedRL= 5'b 1x110; expectedRR= 5'b x1101; 
		#10 a= 3'b 001; b= 5'b z1000; expectedShiftLL= 5'b 10000; expectedShiftLR= 5'b 0z100; expectedShiftAR= 5'b zz100; 
			expectedRL= 5'b 1000z; expectedRR= 5'b 0z100; 
		#20 $finish;
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simpleOtherArithmetic3);
	end
endmodule 