module test_simpleOtherArithmetic4;
	
	reg [5:0] a, j, k, l, m;
	wire [2:0] b, d, f, h;
	wire c, e, g, i; 
	reg [2:0] expectedOutLow1, expectedOutHigh1, expectedOutLow0, expectedOutHigh0;
	reg expectedFindLow1, expectedFindHigh1, expectedFindLow0, expectedFindHigh0;	
	reg [4:0] expectedAdd;
	wire [4:0] n;
	
	simpleOtherArithmetic4 testObj(.input3(a), .outLow1(b), .findLow1(c), .outHigh1(d), .findHigh1(e), .outLow0(f), .findLow0(g), .outHigh0(h), .findHigh0(i), 
									.first(j), .second(k), .third(l), .fourth(m), .outAdd(n));	

	initial 
	begin	
		$display("Testen van de simpleOtherArithmetic4.");
		#0 a= 6'b xxxxxx; expectedOutLow1= 3'b xxx; expectedFindLow1= 1'b x; expectedOutHigh1= 3'b xxx; expectedFindHigh1= 1'b x; 
			expectedOutLow0= 3'b xxx; expectedFindLow0= 1'b x; expectedOutHigh0= 3'b xxx; expectedFindHigh0= 1'b x; 
			j= 6'b 000000; k= 6'b 000000; l= 6'b 000000; m= 6'b 000000; expectedAdd= 5'b 00000;
		#10 a= 6'b x0000x; expectedOutLow1= 3'b xxx; expectedFindLow1= 1'b x; expectedOutHigh1= 3'b xxx; expectedFindHigh1= 1'b x; 
			expectedOutLow0= 3'b xxx; expectedFindLow0= 1'b x; expectedOutHigh0= 3'b xxx; expectedFindHigh0= 1'b x; 
			j= 6'b 100000; k= 6'b 001010; l= 6'b 000001; m= 6'b 011100; expectedAdd= 5'b 00111;
		#10 a= 6'b x1010x; expectedOutLow1= 3'b xxx; expectedFindLow1= 1'b x; expectedOutHigh1= 3'b xxx; expectedFindHigh1= 1'b x; 
			expectedOutLow0= 3'b xxx; expectedFindLow0= 1'b x; expectedOutHigh0= 3'b xxx; expectedFindHigh0= 1'b x; 		
			j= 6'b 111111; k= 6'b 111111; l= 6'b 111111; m= 6'b 111100; expectedAdd= 5'b 10110;
		#10 a= 6'b x00100; expectedOutLow1= 3'b 010; expectedFindLow1= 1'b 1; expectedOutHigh1= 3'b xxx; expectedFindHigh1= 1'b x; 
			expectedOutLow0= 3'b 000; expectedFindLow0= 1'b 1; expectedOutHigh0= 3'b xxx; expectedFindHigh0= 1'b x; 
			j= 6'b 11x111; k= 6'b 111111; l= 6'b 1111x1; m= 6'b 11110x; expectedAdd= 5'b 101xx;
		#10 a= 6'b 0001x0; expectedOutLow1= 3'b xxx; expectedFindLow1= 1'b x; expectedOutHigh1= 3'b 010; expectedFindHigh1= 1'b 1; 
			expectedOutLow0= 3'b 010; expectedFindLow0= 1'b 1; expectedOutHigh0= 3'b 000; expectedFindHigh0= 1'b 1; 
			j= 6'b 11x110; k= 6'b 111101; l= 6'b x111x1; m= 6'b 11010x; expectedAdd= 5'b 10xxx;
		#10 a= 6'b 010100; expectedOutLow1= 3'b 010; expectedFindLow1= 1'b 1; expectedOutHigh1= 3'b 100; expectedFindHigh1= 1'b 1; 
			expectedOutLow0= 3'b 000; expectedFindLow0= 1'b 1; expectedOutHigh0= 3'b 101; expectedFindHigh0= 1'b 1; 		
			j= 6'b x1x110; k= 6'b 111101; l= 6'b x111x1; m= 6'b 11010x; expectedAdd= 5'b xxxxx;
		#10 a= 6'b 000000; expectedOutLow1= 3'b 000; expectedFindLow1= 1'b 0; expectedOutHigh1= 3'b 000; expectedFindHigh1= 1'b 0; 
			expectedOutLow0= 3'b 000; expectedFindLow0= 1'b 1; expectedOutHigh0= 3'b 101; expectedFindHigh0= 1'b 1; 	
			j= 6'b 010110; k= 6'b 111101; l= 6'b 011101; m= 6'b 110100; expectedAdd= 5'b 01111;
		#10 a= 6'b 000x00; expectedOutLow1= 3'b xxx; expectedFindLow1= 1'b x; expectedOutHigh1= 3'b xxx; expectedFindHigh1= 1'b x; 
			expectedOutLow0= 3'b 000; expectedFindLow0= 1'b 1; expectedOutHigh0= 3'b 101; expectedFindHigh0= 1'b 1; 		
			j= 6'b 010110; k= 6'b 111101; l= 6'b 011101; m= 6'b 11010x; expectedAdd= 5'b xxxxx;
		#10 a= 6'b 111111; expectedOutLow1= 3'b 000; expectedFindLow1= 1'b 1; expectedOutHigh1= 3'b 101; expectedFindHigh1= 1'b 1; 
			expectedOutLow0= 3'b 000; expectedFindLow0= 1'b 0; expectedOutHigh0= 3'b 000; expectedFindHigh0= 1'b 0; 
			j= 6'b 0x0xx0; k= 6'b 000000; l= 6'b 00xx00; m= 6'b xx0x0x; expectedAdd= 5'b 0xxxx;
		#10 a= 6'b 111x11; expectedOutLow1= 3'b 000; expectedFindLow1= 1'b 1; expectedOutHigh1= 3'b 101; expectedFindHigh1= 1'b 1; 
			expectedOutLow0= 3'b xxx; expectedFindLow0= 1'b x; expectedOutHigh0= 3'b xxx; expectedFindHigh0= 1'b x; 	
			j= 6'b 111011; k= 6'b 00101x; l= 6'b 100101; m= 6'b 110110; expectedAdd= 5'b 0111x;
		#10 a= 6'b 01xx01; expectedOutLow1= 3'b 000; expectedFindLow1= 1'b 1; expectedOutHigh1= 3'b 100; expectedFindHigh1= 1'b 1; 
			expectedOutLow0= 3'b 001; expectedFindLow0= 1'b 1; expectedOutHigh0= 3'b 101; expectedFindHigh0= 1'b 1; 	
			j= 6'b 111011; k= 6'b 00101x; l= 6'b 100101; m= 6'b 111111; expectedAdd= 5'b 1000x;
		#10 a= 6'b 01xx01; expectedOutLow1= 3'b 000; expectedFindLow1= 1'b 1; expectedOutHigh1= 3'b 100; expectedFindHigh1= 1'b 1; 
			expectedOutLow0= 3'b 001; expectedFindLow0= 1'b 1; expectedOutHigh0= 3'b 101; expectedFindHigh0= 1'b 1; 	
			j= 6'b 111011; k= 6'b 00101z; l= 6'b 100101; m= 6'b 111111; expectedAdd= 5'b 1000x;	
		#20 $finish;
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simpleOtherArithmetic4);
	end
endmodule 