module test_simplePlexer2;

	reg [2:0] a;
	reg [10:0] b;
	reg [1:0] c, expectedAfterDmx2, expectedAfterSel, expectedAfterMux, expectedAfterNot, expectedAfterDmx1;
	reg expectedAfterDecOutput2, expectedAfterDecOutput0;
	wire [1:0] d, f, h, i, j;
	wire e, g;
	
	simplePlexer2 testObj(.SelSelect(a), .SelInput(b), .DmxMuxInput(c), .afterDmx2(d), .DecOutput2(e), .afterSel(f), .DecOutput0(g), .afterMux(h), .afterNot(i), .afterDmx1(j));
	
	initial 
	begin	
		$display("Testen van de simplePlexer2.");
		#0 a= 3'b xxx; b= 11'b xxxxxxxxxxx; c= 2'b xx; expectedAfterMux= 2'b zz; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b zz; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 0; b= 11'b xxxxxxxxxx0; c= 2'b xx; expectedAfterMux= 2'b zz; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b x0; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 0; b= 11'b xxxxxxxxx1x; c= 2'b xx; expectedAfterMux= 2'b zz; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b 1x; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 010; b= 11'b xxxxxxxx010; c= 2'b xx; expectedAfterMux= 2'b zz; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b xx; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 001; b= 11'b xxxxxxxx010; c= 2'b xx; expectedAfterMux= 2'b zz; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b x0; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 101; b= 11'b 11000000000; c= 2'b xx; expectedAfterMux= 2'b zz; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b 01; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 110; b= 11'b 11000000000; c= 2'b xx; expectedAfterMux= 2'b zz; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b 00; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 111; b= 11'b 11000000000; c= 2'b xx; expectedAfterMux= 2'b zz; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b 00; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 011; b= 11'b 11010000010; c= 2'b xx; expectedAfterMux= 2'b 10; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b 10; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 000; b= 11'b 11010000010; c= 2'b xx; expectedAfterMux= 2'b 10; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b 10; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 100; b= 11'b 11110000010; c= 2'b 0x; expectedAfterMux= 2'b 0x; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b 11; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 100; b= 11'b 11110000010; c= 2'b 00; expectedAfterMux= 2'b 00; expectedAfterDecOutput0= 1'b 1; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b 11; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 100; b= 11'b 11110000010; c= 2'b 01; expectedAfterMux= 2'b 01; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b z; expectedAfterSel= 2'b 11; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#10 a= 3'b 100; b= 11'b 11110000010; c= 2'b 11; expectedAfterMux= 2'b 11; expectedAfterDecOutput0= 1'b z; expectedAfterDecOutput2= 1'b 1; expectedAfterSel= 2'b 11; expectedAfterDmx1= 2'b zz; expectedAfterDmx2= 2'b zz; expectedAfterNot= 2'b zz; 
		#20;
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simplePlexer2);
	end
endmodule 