module test_simplePlexer3;

	reg [1:0] a, expectedOutputSel;
	reg [7:0] b;
	reg c, expectedOutputDmx0, expectedOutputDec0, expectedOutputDec3, expectedOutputDmx1;
	wire d, f, g, h;
	wire [1:0] e;
	
	simplePlexer3 testObj(.selectSel(a), .inputSel(b), .inputDmx(c), .outputDmx0(d), .outputSel(e), .outputDec0(f), .outputDec3(g), .outputDmx1(h));
	
	initial 
	begin	
		$display("Testen van de simplePlexer3.");
		#0 a= 2'b xx; b= 8'b xxxxxxxx; c= 1'b x; expectedOutputSel= 2'b zz; expectedOutputDmx0= 1'b z; expectedOutputDec0= 1'b z; expectedOutputDec3= 1'b z; expectedOutputDmx1= 1'b z; 
		#10 a= 2'b xx; b= 8'b xxxxxxxx; c= 1'b x; expectedOutputSel= 2'b zz; expectedOutputDmx0= 1'b z; expectedOutputDec0= 1'b z; expectedOutputDec3= 1'b z; expectedOutputDmx1= 1'b z; 
		#10 a= 2'b 0x; b= 8'b xxxxxxxx; c= 1'b x; expectedOutputSel= 2'b zz; expectedOutputDmx0= 1'b z; expectedOutputDec0= 1'b z; expectedOutputDec3= 1'b z; expectedOutputDmx1= 1'b z; 
		#10 a= 2'b 00; b= 8'b xxxxxxxx; c= 1'b x; expectedOutputSel= 2'b xx; expectedOutputDmx0= 1'b z; expectedOutputDec0= 1'b z; expectedOutputDec3= 1'b z; expectedOutputDmx1= 1'b z; 
		#10 a= 2'b 00; b= 8'b xxxxxxx0; c= 1'b x; expectedOutputSel= 2'b x0; expectedOutputDmx0= 1'b z; expectedOutputDec0= 1'b z; expectedOutputDec3= 1'b z; expectedOutputDmx1= 1'b z; 
		#10 a= 2'b 00; b= 8'b x1x1xxx0; c= 1'b x; expectedOutputSel= 2'b x0; expectedOutputDmx0= 1'b z; expectedOutputDec0= 1'b z; expectedOutputDec3= 1'b z; expectedOutputDmx1= 1'b z; 
		#10 a= 2'b 10; b= 8'b x1110xx0; c= 1'b x; expectedOutputSel= 2'b 11; expectedOutputDmx0= 1'b x; expectedOutputDec0= 1'b 0; expectedOutputDec3= 1'b 1; expectedOutputDmx1= 1'b z; 
		#10 a= 2'b 11; b= 8'b 01110xx0; c= 1'b x; expectedOutputSel= 2'b 01; expectedOutputDmx0= 1'b x; expectedOutputDec0= 1'b 0; expectedOutputDec3= 1'b 0; expectedOutputDmx1= 1'b z; 
		#10 a= 2'b 11; b= 8'b 01110xx0; c= 1'b 0; expectedOutputSel= 2'b 01; expectedOutputDmx0= 1'b 0; expectedOutputDec0= 1'b 0; expectedOutputDec3= 1'b 0; expectedOutputDmx1= 1'b z; 
		#10 a= 2'b 11; b= 8'b 01110xx0; c= 1'b 1; expectedOutputSel= 2'b 01; expectedOutputDmx0= 1'b 1; expectedOutputDec0= 1'b 0; expectedOutputDec3= 1'b 0; expectedOutputDmx1= 1'b z; 
		#10 a= 2'b 01; b= 8'b 011100x0; c= 1'b 1; expectedOutputSel= 2'b 00; expectedOutputDmx0= 1'b z; expectedOutputDec0= 1'b 1; expectedOutputDec3= 1'b 0; expectedOutputDmx1= 1'b 1; 
		#10 a= 2'b 01; b= 8'b 011100x0; c= 1'b 0; expectedOutputSel= 2'b 00; expectedOutputDmx0= 1'b z; expectedOutputDec0= 1'b 1; expectedOutputDec3= 1'b 0; expectedOutputDmx1= 1'b 0; 
		#20;
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0,test_simplePlexer3);
	end
endmodule 