module test_simplePullResistor3;

	reg [0:0] a, b, e, expectedNot, expectedOut1, expectedOut2, expectedOut3, expectedDmx, expectedBuf;
	reg [2:0] c, d, expectedCol;
	reg [4:0] expectedEmpty;
	wire [0:0] f, g, h, i, j, l;
	wire [2:0] k;
	wire [4:0] m;
	
	simplePullResistor3 testObj(.inNot(a), .in3(b), .inCol1(c), .inCol2(d), .inBuf(e), .outNot(f), .out1(g), .out2(h), .out3(i), .outDmx(j), .outCol(k), .outBuf(l), .outEmpty(m));
	
	initial 
	begin	
		$display("Testen van de simplePullResistor3.");
		#0 a= 1'b 0; expectedNot= 1'b 1; b= 1'b 0; expectedOut1= 1'b 0; expectedOut2= 1'b 0; expectedOut3= 1'b 0; c= 3'b 000; d= 3'b 000; expectedCol= 3'b 000; e= 1'b 0; expectedBuf= 1'b 0; expectedDmx= 1'b 0; expectedEmpty= 5'b 00000;
		#10 a= 1'b 1; expectedNot= 1'b 0; b= 1'b 1; expectedOut1= 1'b 1; expectedOut2= 1'b 1; expectedOut3= 1'b 1; c= 3'b 010; d= 3'b 000; expectedCol= 3'b 0x0; e= 1'b 1; expectedBuf= 1'b 1; expectedDmx= 1'b 0; expectedEmpty= 5'b 00000;
		#10 a= 1'b x; expectedNot= 1'b x; b= 1'b x; expectedOut1= 1'b x; expectedOut2= 1'b x; expectedOut3= 1'b x; c= 3'b x1z; d= 3'b 000; expectedCol= 3'b xxx; e= 1'b x; expectedBuf= 1'b x; expectedDmx= 1'b 0; expectedEmpty= 5'b 00000;
		#10 a= 1'b z; expectedNot= 1'b 1; b= 1'b z; expectedOut1= 1'b 1; expectedOut2= 1'b 1; expectedOut3= 1'b 1; c= 3'b zzz; d= 3'b 1zz; expectedCol= 3'b xxx; e= 1'b z; expectedBuf= 1'b x; expectedDmx= 1'b 0; expectedEmpty= 5'b 00000;
		#10 a= 1'b z; expectedNot= 1'b 1; b= 1'b z; expectedOut1= 1'b 1; expectedOut2= 1'b 1; expectedOut3= 1'b 1; c= 3'b 1zz; d= 3'b 1zz; expectedCol= 3'b 1xx; e= 1'b z; expectedBuf= 1'b x; expectedDmx= 1'b 0; expectedEmpty= 5'b 00000;
		
		#20 $finish; 
		
	end
	
	initial
	begin
		$dumpfile("test.lxt");
		$dumpvars(0, test_simplePullResistor3);
	end
endmodule 