module bitSelectorBits8Output2(out0, in0, in1);
	output reg [1:0] out0; 
	input [7:0] in0; 
	//The select line 
	input[1:0] in1; 
	initial
	begin
		out0 = 2'b zz;
	end
	always @(in0 or in1)
	begin
		//Given an input of several bits, this will divide it into several equal-sized groups and output the group selected by the select line 
		if (in1 === 0) 
		begin 
			out0 = in0[1:0]; 
		end 
		else if (in1 === 1) 
		begin 
			out0 = in0[3:2]; 
		end 
		else if (in1 === 2) 
		begin 
			out0 = in0[5:4]; 
		end 
		else if (in1 === 3) 
		begin 
			out0 = in0[7:6]; 
		end 
		else 
		begin 
			//When the select line isn't a number, we assign to the output a floating signal
			out0 = 2'b zz; 
 		end 
	end
endmodule