module comparatorBits3Typecomplement(out0, out1, out2, in0, in1);
	output reg [0:0] out0, out1, out2; 
	input [2:0] in0, in1; 
	always @(in0 or in1)
	begin
		//If the operands are equal and not floating
		if (^in0 !== 1'b x & ^in1 !== 1'b x & in0 === in1)
		begin
			out0 = 1; 
			out1 = 0; 
			out2 = 0;
		end
		//If the operands are equal, but have a floating bit
		else if ((^in0 === 1'b x | ^in1 === 1'b x) & in0 === in1)
		begin
			out0 = 1'b x; 
			out1 = 1'b x; 
			out2 = 1'b x;
		end
		//The operands are not equal
		else
		begin
			out0 = 1'b x; 
			//If the operands don't have a floating bit, the output0 = 0
			if (^in0 !== 1'b x & ^in1 !== 1'b x) 
			begin
				out0 = 0;
			end
			//Calculate the less and greater than (take into account that this is 2's complement) 
			//If the sign is different, the biggest operand will be the non-negative
			if (in0[2] !== in1[2] | in0[2] === 1'b x | in1[2] === 1'b x | in0[2] === 1'b z | in1[2] === 1'b z)
			begin
				out1 = in0[2] < in1[2];
			end
			//If they are of equal sign, we just need to find the first bit they differ at or the first bit that is equal to x
			else if (in0[1] !== in1[1] | in0[1] === 1'b x | in1[1] === 1'b x | in0[2] === 1'b z | in1[2] === 1'b z)
			begin
				out1 = in0[1] > in1[1];
			end
			else if (in0[0] !== in1[0] | in0[0] === 1'b x | in1[0] === 1'b x | in0[2] === 1'b z | in1[2] === 1'b z)
			begin
				out1 = in0[0] > in1[0];
			end
			//The less than is the opposite of the greater than 
			 out2 = ~out1; 
		end
	end
endmodule