module counterTyperisingActionstay(out0, out1, in0, in1, in2, in3, in4, in5);
	output reg [3:0] out0; 
	input [3:0] in0; 
	input [0:0] in1, in2, in3, in4;
	//The in5 stores the maximum value
	input [3:0] in5;
	output reg [0:0] out1;
	//The clock input is equal to in1 and has to be a wire
	wire in1;
	initial
	begin
		out0 = 0;
		out1 = 0;
	end
	always @(posedge in1)
	begin
		//We can only change the output if reset is different from 1
		if (in2 !== 1'b 1)
		begin
			//If we should increment the counter, but we reached the maximum value or if we should load the input, but the input is bigger than the maximum
			if ((in4 !== 1'b 1 & in3 !== 1'b 0 & out0 === in5) | (in4 === 1'b 1 & in3 === 1'b 0 & in0 > in5))
			begin
				//The counter's value remains the same
				out0 = out0;
			end
			//If we should decrement the counter, but we reached the minimum value
			else if (in4 === 1'b 1 & in3 !== 1'b 0 & out0 == 4'b 0)
			begin
				//The counter's value remains the same
				out0 = out0;
			end
			else if (in4 !== 1'b 1 & in3 !== 1'b 0)
			begin
				out0 = out0+1;
			end
			else if (in4 === 1'b 1 & in3 !== 1'b 0)
			begin
				out0 = out0-1;
			end
			else if (in4 === 1'b 1 & in3 === 1'b 0)
			begin
				out0 = (^in0 !== 1'b x) ? in0 : out0;
			end
			//If the next step decrements the counter and we are at the minimum
			if (in4 === 1'b 1 & in3 !== 1'b 0)
			begin
				out1 = (out0 === 4'b 0) ? 1'b 1 : 1'b 0;
			end
			//Else if we are at the maximum
			else
			begin
				out1 = (out0 === in5) ? 1'b 1 : 1'b 0;
			end
		end
	end
	always @(in2)
	begin
		//If the reset input is on, the counters value is pinned to 0
		if (in2 === 1'b 1)
		begin
			out0 = 4'b 0;
			out1 = 1'b 0;
		end
	end
	always @(in4 or in3)
	begin
		//If the next step decrements the counter and we are at the minimum
		if (in4 === 1'b 1 & in3 !== 1'b 0)
		begin
			out1 = (out0 === 4'b 0) ? 1'b 1 : 1'b 0;
		end
		//If we are at the maximum
		else
		begin
			out1 = (out0 === in5) ? 1'b 1 : 1'b 0;
		end
	end
endmodule