module dFlipFlopTypefalling(out0, out1, in0, in1, in2, in3, in4);
	output reg [0:0] out0, out1; 
	input [0:0] in0, in1, in2, in3, in4; 
	//The clock input is equal to in1 and has to be a wire
	wire in1;
	initial
	begin
		out0 = 0;
		out1 = 1;
	end
	always @(negedge in1)
	begin
		//We can only change the output if reset and set are both different from 1 and the enable input is different from 0
		if (in2 !== 1'b 1 & in3 !== 1'b 0 & in4 !== 1'b 1)
		begin
			//When the clock triggers, the value remembered by the flip-flop becomes the value of the D input
			out0 = (in0 !== 1'b x) ? in0 : out0;
			out1 = ~out0;
		end
	end
	always @(in2 or in4)
	begin
		//If the reset input is on, the flip-flop's value is pinned to 0
		if (in2 === 1'b 1)
		begin
			out0 = 1'b 0;
			out1 = 1'b 1;
		end
		//When the set input is on, the flip-flop's value is pinned to 1
		else if (in4 === 1'b 1)
		begin
			out0 = 1'b 1;
			out1 = 1'b 0;
		end
	end
endmodule