module decoderBits1Select2(out0, out1, out2, out3, in0);
	output reg [0:0] out0, out1, out2, out3; 
	input [1:0] in0; 
	//The not chosen register
	reg [0:0] notChosenReg; 
	initial
	begin
		out0 = 1'b z;
		out1 = 1'b z;
		out2 = 1'b z;
		out3 = 1'b z;
	end
	always @(in0)
	begin
		//Emits 1 on exactly one output; which output is 1 depends on the current value received through the select line 
		if (^in0 !== 1'b x & ^in0 !== 1'b z)
		begin 
			//The unselected outputs should be zero, because the select is a number 
			notChosenReg = 0;
		end 
		else 
		begin 
			//The unselected outputs should be floating, because the select is also floating 
			notChosenReg = 1'b z;
		end
		out0 = (in0 === 0) ? 1: notChosenReg;
		out1 = (in0 === 1) ? 1: notChosenReg;
		out2 = (in0 === 2) ? 1: notChosenReg;
		out3 = (in0 === 3) ? 1: notChosenReg;
	end
endmodule