module decoderBits1Select2Floating(out0, out1, out2, out3, in0);
	output reg [0:0] out0, out1, out2, out3; 
	input [1:0] in0; 
	initial
	begin
		out0 = 1'b z;
		out1 = 1'b z;
		out2 = 1'b z;
		out3 = 1'b z;
	end
	always @(in0)
	begin
		//Emits 1 on exactly one output; which output is 1 depends on the current value received through the select line 
		//The unselected outputs should be floating 
		out0 = (in0 === 0) ? 1: 1'b z;
		out1 = (in0 === 1) ? 1: 1'b z;
		out2 = (in0 === 2) ? 1: 1'b z;
		out3 = (in0 === 3) ? 1: 1'b z;
	end
endmodule