module demultiplexerBits1Select1(out0, out1, in0, in1);
	output reg [0:0] out0, out1; 
	input [0:0] in0; 
	//The select line 
	input[0:0] in1; 
	//The not chosen register
	reg [0:0] notChosenReg; 
	initial
	begin
		out0 = 1'b z;
		out1 = 1'b z;
	end
	always @(in0 or in1)
	begin
		//Copies the input onto exactly one of the outputs; which of these outputs is specified via the current value received through the select line 
		if (^in1 !== 1'b x & ^in1 !== 1'b z)
		begin 
			//The unselected outputs should be zero, because the select is a number 
			notChosenReg = 0;
		end 
		else 
		begin 
			//The unselected outputs should be floating, because the select is also floating 
			notChosenReg = 1'b z;
		end
		out0 = (in1 === 0) ? in0: notChosenReg;
		out1 = (in1 === 1) ? in0: notChosenReg;
	end
endmodule