module dividerBits8(out0, out1, in0, in1, in2);
	output reg [7:0] out0, out1; 
	input [7:0] in0, in1, in2; 
	//The temporary registers are the double of the normal registers
	reg [15:0] tmp, tmp1; 
	reg [7:0] tmpIn1; 
	always @(in0 or in1 or in2)
	begin
		//If the divisor is 0, then no division is performed
		if (in1 === 0) 
		begin 
			tmpIn1 = 1;
		end
		else
		begin
			tmpIn1 = in1; 
		end
		//If either of the operands contains some floating bits, then the component's outputs will be entirely floating
		if (^in0 === 1'b x | ^in1 === 1'b x | ^in2 === 1'b x) 
		begin 
			out0 = 8'b xxxxxxxx;
			out1 = 8'b xxxxxxxx;
		end 
		else
		begin
			tmp = {in2, in0}; 
			tmp1 = tmp / tmpIn1; 
			out0 = tmp1[7:0];
			out1 = tmp % tmpIn1;
		end
	end
endmodule