//The gate that combines the module defined below into a multy bit width
module notOneInputOnGateBits2Inputs2(out0, in0, in1);
	output wire [1:0] out0; 
	input [1:0] in0, in1; 
	wire [0:0] tmp0, tmp1;
	//Use gates that are defined for width 1 bit
	notOneInputOnInputs2 a0(tmp0, in0[0:0], in1[0:0]);
	notOneInputOnInputs2 a1(tmp1, in0[1:1], in1[1:1]);
	//Combine the 1 widht bits into a multy width bit
	assign out0 = {tmp1, tmp0};
endmodule

//Defines the module for width 1
module notOneInputOnInputs2(out0, in0, in1);
	output reg [0:0] out0; 
	input [0:0] in0, in1; 
	integer sum;
	always @(in0 or in1)
	begin
		//We sum the inputs, so that we can later on check whether this sum is equal to 1 or not 
		sum = in0 + in1;
		if (sum == 1) 
		begin 
			out0 = 1'b 0; 
		end 
		else if (sum == 0 || sum > 1) 
		begin 
			out0 = 1'b 1; 
		end 
		else 
		begin 
			out0 = 1'b x; 
		end 
	end
endmodule