module priorityEncoderInput16(out0, out1, out2, in0, in1, in2, in3, in4, in5, in6, in7, in8, in9, in10, in11, in12, in13, in14, in15, in16);
	output reg [3:0] out0; 
	input [0:0] in0, in1, in2, in3, in4, in5, in6, in7, in8, in9, in10, in11, in12, in13, in14, in15, in16; 
	//The enable and group output
	output reg [0:0] out1, out2; 
	always @(in0 or in1 or in2 or in3 or in4 or in5 or in6 or in7 or in8 or in9 or in10 or in11 or in12 or in13 or in14 or in15 or in16)
	begin
		//We initialize the output and the enable output (if there is an input whose value is 1, these outputs will be changed
		out0 = 4'b zzzz;
		out1 = 1'b 1; 
		//If the enable input is 0
		if (in16 == 1'b 0)
		begin
			out0 = 4'b zzzz;
			out1 = 1'b 0; 
			out2 = 1'b 0;
		end
		//Determine the indices of the inputs whose values are 1, and emit the highest index
		else if (in15 === 1'b 1)
		begin
			out0 = 15;
			out1 = 1'b 0;
		end
		else if (in14 === 1'b 1)
		begin
			out0 = 14;
			out1 = 1'b 0;
		end
		else if (in13 === 1'b 1)
		begin
			out0 = 13;
			out1 = 1'b 0;
		end
		else if (in12 === 1'b 1)
		begin
			out0 = 12;
			out1 = 1'b 0;
		end
		else if (in11 === 1'b 1)
		begin
			out0 = 11;
			out1 = 1'b 0;
		end
		else if (in10 === 1'b 1)
		begin
			out0 = 10;
			out1 = 1'b 0;
		end
		else if (in9 === 1'b 1)
		begin
			out0 = 9;
			out1 = 1'b 0;
		end
		else if (in8 === 1'b 1)
		begin
			out0 = 8;
			out1 = 1'b 0;
		end
		else if (in7 === 1'b 1)
		begin
			out0 = 7;
			out1 = 1'b 0;
		end
		else if (in6 === 1'b 1)
		begin
			out0 = 6;
			out1 = 1'b 0;
		end
		else if (in5 === 1'b 1)
		begin
			out0 = 5;
			out1 = 1'b 0;
		end
		else if (in4 === 1'b 1)
		begin
			out0 = 4;
			out1 = 1'b 0;
		end
		else if (in3 === 1'b 1)
		begin
			out0 = 3;
			out1 = 1'b 0;
		end
		else if (in2 === 1'b 1)
		begin
			out0 = 2;
			out1 = 1'b 0;
		end
		else if (in1 === 1'b 1)
		begin
			out0 = 1;
			out1 = 1'b 0;
		end
		else if (in0 === 1'b 1)
		begin
			out0 = 0;
			out1 = 1'b 0;
		end
		//The group output is always the opposite of the enable output (when enable is on)
		if (in16 !== 1'b 0)
		begin
			out2 = ~out1;
		end
	end
endmodule