module randomTyperising(out0, in0, in1, in2, in3);
	output reg [3:0] out0; 
	input [0:0] in0; 
	input [0:0] in1, in2, in3;
	//The clock input is equal to in1 and has to be a wire
	wire in1;
	initial
	begin
		out0 = $random % 4;
	end
	always @(posedge in1)
	begin
		//We can only change the output if reset is different from 1 and the enable input is different from 0
		if (in2 !== 1'b 1 & in3 !== 1'b 0)
		begin
			out0 = $random % 4;
		end
	end
	always @(in2)
	begin
		//If the reset input is on, the pseudorandom sequence resets to its initial seed
		if (in2 === 1'b 1)
		begin
			out0 = $random % 4;
		end
	end
endmodule