module registerMemoryTypefalling(out0, in0, in1, in2, in3);
	output reg [3:0] out0; 
	input [3:0] in0; 
	input [0:0] in1, in2, in3;
	//The clock input is equal to in1 and has to be a wire
	wire in1;
	initial
	begin
		out0 = 0;
	end
	always @(negedge in1)
	begin
		//We can only change the output if reset is different from 1 and the enable input is different from 0
		if (in2 !== 1'b 1 & in3 !== 1'b 0)
		begin
			//If the input has floating bits in its signal, we should ignore the input
			out0 = (^in0 !== 1'b x) ? in0 : out0;
		end
	end
	always @(in2)
	begin
		//If the reset input is on, the registers value is pinned to 0
		if (in2 === 1'b 1)
		begin
			out0 = 4'b 0;
		end
	end
endmodule