module registerMemoryTypehigh(out0, in0, in1, in2, in3);
	output reg [7:0] out0; 
	input [7:0] in0; 
	input [0:0] in1, in2, in3;
	//The clock input is equal to in1 and has to be a wire
	wire in1;
	initial
	begin
		out0 = 0;
	end
	always @(in1 or in2 or in3)
	begin
		//If the reset input is on, the registers value is pinned to 0
		if (in2 === 1'b 1)
		begin
			out0 = 8'b 0;
		end
		//If the enable input is on and the clock is high
		else if (in3 !== 1'b 0 & in1 ===1'b 1)
		begin
			//If the input has floating bits in its signal, we should ignore the input
			out0 = (^in0 !== 1'b x) ? in0 : out0;
		end
	end
endmodule