module shiftRegisterParallelTyperisingNumber5(out0, out1, out2, out3, out4, out5, in0, in1, in2, in3, in4, in5, in6, in7, in8, in9);
	output reg [1:0] out0, out1, out2, out3, out4, out5; 
	input [1:0] in0; 
	//The extra input (clock, reset, shift, load)
	input[0:0] in1, in2, in3, in4;
	//The clock input is equal to in1 and has to be a wire
	wire in1;
	//The parallelInputs (we read from them if load is on
	input [1:0] in5, in6, in7, in8, in9;
	reg [1:0] tmp0, tmp1, tmp2, tmp3, tmp4;
	initial
	begin
		out0 = 2'b 0;
		tmp0 = 2'b 0;
		out1 = 2'b 0;
		tmp1 = 2'b 0;
		out2 = 2'b 0;
		tmp2 = 2'b 0;
		out3 = 2'b 0;
		tmp3 = 2'b 0;
		out4 = 2'b 0;
		tmp4 = 2'b 0;
		out5 = 2'b 0;
	end
	always @(posedge in1)
	begin
		//We can only shift the register if reset is different from 1 and the shift input is different from 0 and we don't need to load the inputs
		if (in2 !== 1'b 1 & in3 !== 1'b 0 & in4 !== 1'b 1)
		begin
			tmp4 = tmp3;
			out5 = tmp4;
			tmp3 = tmp2;
			out4 = tmp3;
			tmp2 = tmp1;
			out3 = tmp2;
			tmp1 = tmp0;
			out2 = tmp1;
			tmp0 = in0;
			out1 = tmp0;
			out0 = tmp4;
		end
		//If the load input is high, we know that we need to read the extra inputs
		else if (in2 !== 1'b 1 & in4 === 1'b 1)
		begin
			out0 = in9;
			tmp0 = in5;
			out1 = in5;
			tmp1 = in6;
			out2 = in6;
			tmp2 = in7;
			out3 = in7;
			tmp3 = in8;
			out4 = in8;
			tmp4 = in9;
			out5 = in9;
		end
	end
	always @(in2)
	begin
		//If the reset input is on
		if (in2 === 1'b 1)
		begin
			out0 = 2'b 0;
			tmp0 = 2'b 0;
			out1 = 2'b 0;
			tmp1 = 2'b 0;
			out2 = 2'b 0;
			tmp2 = 2'b 0;
			out3 = 2'b 0;
			tmp3 = 2'b 0;
			out4 = 2'b 0;
			tmp4 = 2'b 0;
			out5 = 2'b 0;
		end
	end
endmodule