module shifterBits5TypeaDirectionr(out0, in0, in1);
	output reg [4:0] out0; 
	input [4:0] in0; 
	//The extra input (distance)
	input[2:0] in1; 
	always @(in0 or in1)
	begin
		//If the distance is not a number 
		if (^in1 === 1'b x)
		begin
			out0 = 5'b xxxxx;
		end
		//We don't need to shift
		else if (in1 == 0)
		begin
			out0 = in0;
		end
		//All bits in data are shifted down dist places, with the upper dist places filled with repetitions of whatever the uppermost bit in data
		else if (in1 == 1)
		begin
			if (in0[4] == 1)
			begin
				out0 = {1'b 1, in0[4:1]};
			end
			else if (in0[4] == 0)
			begin
				out0 = {1'b 0, in0[4:1]};
			end
			else if (in0[4] === 1'b z)
			begin
				out0 = {1'b z, in0[4:1]};
			end
			else
			begin
				out0 = {1'b x, in0[4:1]};
			end
		end
		else if (in1 == 2)
		begin
			if (in0[4] == 1)
			begin
				out0 = {2'b 11, in0[4:2]};
			end
			else if (in0[4] == 0)
			begin
				out0 = {2'b 0, in0[4:2]};
			end
			else if (in0[4] === 1'b z)
			begin
				out0 = {2'b zz, in0[4:2]};
			end
			else
			begin
				out0 = {2'b xx, in0[4:2]};
			end
		end
		else if (in1 == 3)
		begin
			if (in0[4] == 1)
			begin
				out0 = {3'b 111, in0[4:3]};
			end
			else if (in0[4] == 0)
			begin
				out0 = {3'b 0, in0[4:3]};
			end
			else if (in0[4] === 1'b z)
			begin
				out0 = {3'b zzz, in0[4:3]};
			end
			else
			begin
				out0 = {3'b xxx, in0[4:3]};
			end
		end
		else if (in1 == 4)
		begin
			if (in0[4] == 1)
			begin
				out0 = {4'b 1111, in0[4:4]};
			end
			else if (in0[4] == 0)
			begin
				out0 = {4'b 0, in0[4:4]};
			end
			else if (in0[4] === 1'b z)
			begin
				out0 = {4'b zzzz, in0[4:4]};
			end
			else
			begin
				out0 = {4'b xxxx, in0[4:4]};
			end
		end
		//If the distance is too big
		else
		begin
			if (in0[4] == 1)
			begin
				out0 = 5'b 11111;
			end
			else if (in0[4] == 0)
			begin
				out0 = 5'b 0;
			end
			else 
			begin
				out0 = 5'b xxxxx;
			end
		end
	end
endmodule