module shifterBits5TypelDirectionl(out0, in0, in1);
	output reg [4:0] out0; 
	input [4:0] in0; 
	//The extra input (distance)
	input[2:0] in1; 
	always @(in0 or in1)
	begin
		//If the distance is not a number 
		if (^in1 === 1'b x)
		begin
			out0 = 5'b xxxxx;
		end
		//We don't need to shift
		else if (in1 == 0)
		begin
			out0 = in0;
		end
		//All bits in data are shifted up dist places, with the bottom dist places filled with 0's
		else if (in1 == 1)
		begin
			out0 = {in0[3:0], 1'b 0};
		end
		else if (in1 == 2)
		begin
			out0 = {in0[2:0], 2'b 0};
		end
		else if (in1 == 3)
		begin
			out0 = {in0[1:0], 3'b 0};
		end
		else if (in1 == 4)
		begin
			out0 = {in0[0:0], 4'b 0};
		end
		//If the distance is too big
		else
		begin
			out0 = 5'b 0; 
		end
	end
endmodule