module shifterBits5TyperDirectionr(out0, in0, in1);
	output reg [4:0] out0; 
	input [4:0] in0; 
	//The extra input (distance)
	input[2:0] in1; 
	always @(in0 or in1)
	begin
		//If the distance is not a number 
		if (^in1 === 1'b x)
		begin
			out0 = 5'b xxxxx;
		end
		//We don't need to shift
		else if (in1 == 0 | in1 == 5)
		begin
			out0 = in0;
		end
		//All bits in data are shifted up dist places, with the top dist places wrapped around into the bottom
		else if (in1 == 1 | in1 == 6)
		begin
			out0 = {in0[0:0], in0[4:1]};
		end
		else if (in1 == 2 | in1 == 7)
		begin
			out0 = {in0[1:0], in0[4:2]};
		end
		else if (in1 == 3)
		begin
			out0 = {in0[2:0], in0[4:3]};
		end
		else if (in1 == 4)
		begin
			out0 = {in0[3:0], in0[4:4]};
		end
	end
endmodule