module simpleAbstractRegisterAndRandom2(highRegInput, input4long, enableInput, resetInput, outHighReg, outRandom, outRandom2, outFallingReg);
	input [7:0] highRegInput;
	input [3:0] input4long;
	input [0:0] enableInput;
	input [0:0] resetInput;
	reg [0:0] clockje;
	output [7:0] outHighReg;
	output [3:0] outRandom;
	output [3:0] outRandom2;
	output [3:0] outFallingReg;
	wire [3:0]wire1;
	wire [0:0]wire2;
	wire [3:0]wire3;
	wire [3:0]wire4;
	wire [7:0]wire5;
	wire [3:0]wire6;
	assign outHighReg = wire5;
	assign outRandom = wire4;
	assign outRandom2 = wire3;
	assign outFallingReg = wire6;
	assign wire1 = 4'd 8;
	assign wire2 = 1'd 0;
	randomTypefalling random2(.in0(wire1), .in1(clockje), .in2(resetInput), .in3(enableInput), .out0(wire3)); 
	randomTyperising random(.in0(wire2), .in1(clockje), .in2(resetInput), .in3(enableInput), .out0(wire4)); 
	registerMemoryTypehigh highReg(.in0(highRegInput), .in1(clockje), .in2(resetInput), .in3(enableInput), .out0(wire5)); 
	registerMemoryTypefalling fallingReg(.in0(input4long), .in1(clockje), .in2(resetInput), .in3(enableInput), .out0(wire6)); 
	initial 
	begin
		clockje = 0;
	end
	always 
	begin
		#10 clockje = 1; 
		#10 clockje = 0; 
	end
endmodule
