module simpleBaseGate(twoBitInput, endingOutput, afterControlBuf, afterOddXor, afterControlInv, afterNand);
	input [1:0] twoBitInput;
	localparam [1:0] constant1 = 'h 2;
	reg [0:0] clockje;
	output [1:0] endingOutput;
	output [1:0] afterControlBuf;
	output [1:0] afterOddXor;
	output [1:0] afterControlInv;
	output [1:0] afterNand;
	wire [1:0]wire1;
	wire [1:0]wire2;
	wire [1:0]wire3;
	wire [1:0]wire4;
	wire [1:0]wire5;
	assign endingOutput = wire5;
	assign afterControlBuf = wire3;
	assign afterOddXor = wire4;
	assign afterControlInv = wire1;
	assign afterNand = wire2;
	controlledInverterGateBits2 controlInv(wire1, constant1, clockje); //logisimName: controlInv
	assign wire2 = ~(twoBitInput & constant1); //logisimName: littleNand
	controlledBufferGateBits2 controlBuf(wire3, twoBitInput, clockje); //logisimName: controlBuf
	assign wire4 = wire1 ^ wire2 ^ twoBitInput; //logisimName: oddXor
	notOneInputOnGateBits2Inputs2 oneInputXnor(wire5, wire3, wire4); //logisimName: oneInputXnor
	initial 
	begin
		clockje = 0;
	end
	always 
	begin
		#1 clockje = 1; 
		#5 clockje = 0; 
	end
endmodule
