module simpleLargeMemoryAndShiftRegister4(store, clearl, sel, storeLoad, data, address, asynch, synch, separate, rom);
	input [0:0] store;
	input [0:0] clearl;
	input [0:0] sel;
	input [0:0] storeLoad;
	input [2:0] data;
	input [1:0] address;
	reg [0:0] clockj;
	//A rom memory 
	reg [0:0] largeMem0 [0:3];
	parameter largeMem1File0 = "ram_file.txt";
	integer i;
	reg [2:0] largeMem1TmpReg0;
	//A ram memory 
	reg [2:0] largeMem1 [0:3];
	parameter largeMem2File0 = "ram_file.txt";
	reg [2:0] largeMem2TmpReg0;
	//A ram memory 
	reg [2:0] largeMem2 [0:3];
	parameter largeMem3File0 = "ram_file.txt";
	reg [0:0] largeMem3TmpReg0;
	//A ram memory 
	reg [0:0] largeMem3 [0:3];
	output [0:0] asynch;
	output [2:0] synch;
	output [2:0] separate;
	output [0:0] rom;
	wire [0:0]wire1;
	wire [2:0]wire2;
	wire [2:0]wire3;
	wire [2:0]wire4;
	wire [0:0]wire5;
	wire [2:0]wire6;
	wire [0:0]wire7;
	assign asynch = wire5;
	assign synch = wire3;
	assign separate = wire6;
	assign rom = wire7;
	assign wire1 =  ~storeLoad; //logisimName: gate0
	controlledBufferGateBits3 gate1(wire2, data, storeLoad); //logisimName: gate1
	//If the select input is on we read from the right address the value
	assign wire7 = (sel !== 1'b 0) ? largeMem0[address] : 1'b z; 
	//We read from the right address the value
	assign wire6 = (sel !== 1'b 0 & wire1 !== 1'b 0) ? largeMem1[address] : 3'b zzz;
	//We read from the right address the value
	assign wire4 = (sel !== 1'b 0 & wire1 !== 1'b 0) ? largeMem2[address] : 3'b zzz;
	//We read from the right address the value
	assign wire5 = (sel !== 1'b 0 & wire1 !== 1'b 0) ? largeMem3[address] : 1'b z;
	assign wire3 = wire2;
	assign wire3 = wire4;
	initial 
	begin
		clockj = 0;
		//rom_file.txt is memory file (if you have multiple files you can change this name to the right one (the file should contain the content of the rom))
		 $readmemb("rom_file.txt", largeMem0);
		largeMem1TmpReg0 = 3'b 111;
		//ram_file.txt is memory file (if you have want to change this file from another file you can do this using "defparam" (the file should contain the content of the ram))
		 $readmemb(largeMem1File0, largeMem1);
		largeMem2TmpReg0 = 3'b 111;
		//ram_file.txt is memory file (if you have want to change this file from another file you can do this using "defparam" (the file should contain the content of the ram))
		 $readmemb(largeMem2File0, largeMem2);
		largeMem3TmpReg0 = 1'b 1;
		//ram_file.txt is memory file (if you have want to change this file from another file you can do this using "defparam" (the file should contain the content of the ram))
		 $readmemb(largeMem3File0, largeMem3);
	end
	always 
	begin
		#10 clockj = 1; 
		#10 clockj = 0; 
	end
	//When we need to store the data input into the ram
	always @(posedge clockj)
	begin
		//Clear should be off and ram should be enabled
		if (sel !== 1'b 0 & clearl !== 1'b 1)
		begin
			largeMem1TmpReg0 = (^data !== 1'b x) ? data : 3'b 111;
			largeMem1[address] = (wire1 === 1'b 0 & store !== 1'b 0) ? largeMem1TmpReg0 : largeMem1[address];
		end
	end
	always @(clearl)
	begin
		//Clear the memory
		if (clearl=== 1'b 1)
		begin
			for (i = 0; i < 4; i = i+1)
			begin
				largeMem1[i] = 3'b 0;
			end
		end
	end
	//When we need to store the data input into the ram
	always @(posedge clockj)
	begin
		//Clear should be off and ram should be enabled
		if (sel !== 1'b 0 & clearl !== 1'b 1)
		begin
			largeMem2TmpReg0 = (^wire2 !== 1'b x) ? wire2 : 3'b 111;
			largeMem2[address] = (wire1 === 1'b 0) ? largeMem2TmpReg0 : largeMem2[address];
		end
	end
	always @(clearl)
	begin
		//Clear the memory
		if (clearl=== 1'b 1)
		begin
			for (i = 0; i < 4; i = i+1)
			begin
				largeMem2[i] = 3'b 0;
			end
		end
	end
	//When we need to store the data input into the ram
	always @(wire1 | address)
	begin
		//Clear should be off and ram should be enabled
		if (sel !== 1'b 0 & clearl !== 1'b 1)
		begin
			largeMem3[address] = (wire1 === 1'b 0) ? largeMem3TmpReg0 : largeMem3[address];
		end
	end
	always @(clearl)
	begin
		//Clear the memory
		if (clearl=== 1'b 1)
		begin
			for (i = 0; i < 4; i = i+1)
			begin
				largeMem3[i] = 1'b 0;
			end
		end
	end
endmodule
