module srFlipFlopTypehigh(out0, out1, in0, in1, in2, in3, in4, in5);
	output reg [0:0] out0, out1; 
	input [0:0] in0, in1, in2, in3, in4, in5; 
	//The clock input is equal to in1 and has to be a wire
	wire in1;
	initial
	begin
		out0 = 0;
		out1 = 1;
	end
	always @(in1 or in2 or in3 or in4 or in5)
	begin
		//If the reset input is on, the flip-flop's value is pinned to 0
		if (in2 === 1'b 1)
		begin
			out0 = 1'b 0;
			out1 = 1'b 1;
		end
		//When the set input is on, the flip-flop's value is pinned to 1
		else if (in4 === 1'b 1)
		begin
			out0 = 1'b 1;
			out1 = 1'b 0;
		end
		//If the enable input is on and the clock is high
		else if (in3 !== 1'b 0 & in1 ===1'b 1)
		begin
			//When the clock triggers, the value remembered by the flip-flop remains the same if the S and R inputs are both 1 or 0
			//If they are different, then the value becomes 1 if the first input is 1
			if (in5 === 1'b 1)
			begin
				out0 = 1'b 1;
			end
			//If they are different, then the value becomes 0 if the second input is 1
			else if (in0 === 1'b 1)
			begin
				out0 = 1'b 0;
			end
			out1 = ~out0; 
		end
	end
endmodule