#!/usr/bin/env python3

from translator.intermediateBuilder.annotated.annotatedDisplay import AnnotatedDisplay

class Annotated7SegmentDisplay(AnnotatedDisplay):
	""" Annotated7SegmentDisplay is the annotated version of the 7 segment display """
	
	def __init__(self, display, coordinates):	
		""" Constructor """
		AnnotatedDisplay.__init__(self, display, coordinates)	
		#The saved coordinates are input coordinates
		self.inputCoordinates = [coordinates]
	
	def findExtraCoordinates(self):
		""" Overwrites the parent function (but has the same meaning) """
		#Because the display can't change facing or size, the input coordinates places are well defined (and easy to calculate)
		#The extra 3 inputs that lie on the upper part of the display
		for i in range(1, 4):
			self.inputCoordinates.append((self.coordinates[0]+10*i, self.coordinates[1]))
		#The extra 4 inputs that lie on the lower part of the display
		for i in range(4):
			self.inputCoordinates.append((self.coordinates[0]+10*i, self.coordinates[1]+60))