#!/usr/bin/env python3

from translator.intermediateBuilder.annotated.annotatedMemory import AnnotatedMemory
from translator.intermediateBuilder.input import Input

class AnnotatedAbstractRegister(AnnotatedMemory):
	""" AnnotatedAbstractRegister is the annotated version of the abstract register """
	
	def __init__(self, abreg, coordinates):
		""" Constructor """
		AnnotatedMemory.__init__(self, abreg, coordinates)	
		self.inputCoordinate = (coordinates[0]-30, coordinates[1])
		self.resetInputCoordinate = (coordinates[0]-10, coordinates[1]+20)
		self.clockInputCoordinate = (coordinates[0]-20, coordinates[1]+20)
		self.extraInputCoordinate = (coordinates[0]-30, coordinates[1]+10)
		
	def getInputCoordinates(self, list):
		""" Overwrites the parent function (but has the same meaning) """
		AnnotatedMemory.getInputCoordinates(self, list)
		list.append(self.extraInputCoordinate)	
		
	def setInputRight(self, coordinate, annotatedConnection, inputsFound, extraInfo):	
		""" Overwrites the parent function (but has the same meaning) """	
		if coordinate == self.extraInputCoordinate:
			input = Input(annotatedConnection.connection)
			self.node.extraInputWire = input		
		else:
			AnnotatedMemory.setInputRight(self, coordinate, annotatedConnection, inputsFound, extraInfo)					
	
	def bindMemoryWithCompExtraCoordinates(self, annotatedComp, annotatedConnectionList, inputsFound, connectedInputs):
		""" Overwrites the parent function (but has the same meaning) """	
		annotatedComp.bindCompWithComp(self.extraInputCoordinate, self, annotatedConnectionList, inputsFound, connectedInputs)	

	def bindMemoryWithInputWiresExtraCoordinates(self, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs):
		""" Overwrites the parent function (but has the same meaning) """	
		self.bindWithInputWires(self.extraInputCoordinate, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs)		