#!/usr/bin/env python3

from translator.intermediateBuilder.annotated.annotatedDisplay import AnnotatedDisplay
from translator.intermediateBuilder.input import Input

class AnnotatedHexDigitDisplay(AnnotatedDisplay):
	""" AnnotatedHexDigitDisplay is the annotated version of the hex segment display """
	
	def __init__(self, display, coordinates):
		""" Constructor """
		AnnotatedDisplay.__init__(self, display, coordinates)	
		self.pointInputCoordinate = (coordinates[0]+10, coordinates[1])

	def getInputCoordinates(self, list):		
		""" Overwrites the parent function (but has the same meaning) """
		list.append(self.coordinates)
		list.append(self.pointInputCoordinate)

	def setInputRight(self, coordinate, annotatedConnection, inputsFound, extraInfo):		
		""" Overwrites the parent function (but has the same meaning) """					
		if coordinate == self.pointInputCoordinate:
			input = Input(annotatedConnection.connection)
			self.node.pointInputWire = input		
		else:
			input = Input(annotatedConnection.connection)
			self.node.numberInputWire = input	

	def bindWithInputWiresOrComp(self, annotatedComponentList, annotatedConnectionList):			
		""" Overwrites the parent function (but has the same meaning) """
		connectedInputs = []
		inputsFound = []
		self.bindDisplayWithComp(annotatedComponentList, annotatedConnectionList, inputsFound, connectedInputs)
		self.bindDisplayWithInputWires(annotatedConnectionList, inputsFound, connectedInputs)
		self.node.inputWires = inputsFound

	def bindDisplayWithComp(self, annotatedComponentList, annotatedConnectionList, inputsFound, connectedInputs):				
		""" Overwrites the parent function (but has the same meaning) """	
		for annotatedList in annotatedComponentList:
			for annotatedComp in annotatedList:
				if annotatedComp == self:
					continue
				annotatedComp.bindCompWithComp(self.coordinates, self, annotatedConnectionList, inputsFound, connectedInputs)	
				annotatedComp.bindCompWithComp(self.pointInputCoordinate, self, annotatedConnectionList, inputsFound, connectedInputs)	

	def bindDisplayWithInputWires(self, annotatedConnectionList, inputsFound, connectedInputs):	
		""" Overwrites the parent function (but has the same meaning) """
		for annotatedConnection in annotatedConnectionList:	
			self.bindWithInputWires(self.coordinates, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs)	
			self.bindWithInputWires(self.pointInputCoordinate, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs)	