#!/usr/bin/env python3

from translator.intermediateBuilder.annotated.annotatedMemory import AnnotatedMemory
from translator.intermediateBuilder.input import Input

class AnnotatedLargeMemory(AnnotatedMemory):
	""" AnnotatedLargeMemory is the annotated version of the ram or rom """
	
	def __init__(self, mem, coordinates):
		""" Constructor """
		AnnotatedMemory.__init__(self, mem, coordinates)	
		#We can set the input and selectcoordinates
		self.inputCoordinate = (coordinates[0]-140, coordinates[1])
		self.selectInputCoordinate = (coordinates[0]-90, coordinates[1]+40)	

	def getInputCoordinates(self, list):		
		""" Overwrites the parent function (but has the same meaning) """
		list.extend([self.inputCoordinate, self.selectInputCoordinate])	

	def setInputRight(self, coordinate, annotatedConnection, inputsFound, extraInfo):				
		""" Overwrites the parent function (but has the same meaning) """				
		if coordinate == self.selectInputCoordinate:
			input = Input(annotatedConnection.connection)
			self.node.selectInputWire = input		
		else:
			AnnotatedMemory.setInputRight(self, coordinate, annotatedConnection, inputsFound, extraInfo)					

	def bindMemoryWithCompExtraCoordinates(self, annotatedComp, annotatedConnectionList, inputsFound, connectedInputs):	
		""" Overwrites the parent function (but has the same meaning) """	
		annotatedComp.bindCompWithComp(self.selectInputCoordinate, self, annotatedConnectionList, inputsFound, connectedInputs)	

	def bindMemoryWithInputWiresExtraCoordinates(self, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs):
		""" Overwrites the parent function (but has the same meaning) """
		self.bindWithInputWires(self.selectInputCoordinate, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs)	