#!/usr/bin/env python3

from translator.intermediateBuilder.annotated.annotatedDisplay import AnnotatedDisplay

class AnnotatedLedMatrix(AnnotatedDisplay):
	""" AnnotatedLedMatrix is the annotated version of the led matrix """
	
	def __init__(self, display, coordinates):
		""" Constructor """
		AnnotatedDisplay.__init__(self, display, coordinates)	
		#The saved coordinates are input coordinates
		self.inputCoordinates = [coordinates]

	def findExtraCoordinates(self):
		""" Overwrites the parent function (but has the same meaning) """
		#Because the led matrix can't change facing, the input coordinates places only depend on the number of input coordinates (only the x-coordinates can vary)
		for i in range(self.node.numberOfInputs):
			self.inputCoordinates.append((self.coordinates[0]+10*i, self.coordinates[1]))
	