#!/usr/bin/env python3

from translator.intermediateBuilder.annotated.annotatedBase import AnnotatedBase

class AnnotatedOutputBase(AnnotatedBase):
	""" AnnotatedOutputBase is the annotated version of an input base """
	
	def getInputCoordinates(self, list):
		""" Overwrites the parent function (but has the same meaning) """
		list.append(self.coordinates)

	def getOutputCoordinates(self, list):	
		""" Overwrites the parent function (but has the same meaning) """	
		return	#An output or probe base doesn't have an ouput pin 

	def bindOutput(self, annotatedConnectionList, annotatedComponentList, inputList, wiresToDelete, wiresToInsert, collide, faultList, circuitName=""):			
		""" Overwrites the parent function (but has the same meaning) """	
		return	#An output or probe base doesn't have outputs
		
	def bindCompWithComp(self, coordinate, annotatedComp, annotatedConnectionList, inputsFound, connectedInputs=[], extraInfo= None):			
		""" Overwrites the parent function (but has the same meaning) """			
		return	#An output or probe base doesn't have outputs

	def bindWithInputWiresOrComp(self, annotatedComponentList, annotatedConnectionList):		
		""" Overwrites the parent function (but has the same meaning) """	
		inputsFound = []
		self.bindBaseWithComp(annotatedComponentList, annotatedConnectionList, inputsFound)
		self.bindBaseWithInputWires(annotatedConnectionList, inputsFound)
		#There can only be one input into a base (even when we have colliding wires, there will always be only 1 wire into the base,
		#because the colliding wires are joined into 1 wire, so there will only be one wire into this base)
		self.node.inputWire = (len(inputsFound) > 0 and inputsFound[0])	or None
		
	def bindBaseWithComp(self, annotatedComponentList, annotatedConnectionList, inputsFound):	
		""" Binds the output base with other nodes that lie immediately next to the output base  """
		for annotatedList in annotatedComponentList:
			for annotatedComp in annotatedList:
				if annotatedComp == self:
					continue
				annotatedComp.bindCompWithComp(self.coordinates, self, annotatedConnectionList, inputsFound)
	
	def bindBaseWithInputWires(self, annotatedConnectionList, inputsFound):					
		""" Binds the output base with its connected input wires  """		
		for annotatedConnection in annotatedConnectionList:
			self.bindWithInputWires(self.coordinates, annotatedConnection, annotatedConnectionList, inputsFound)	