#!/usr/bin/env python3

from translator.intermediateBuilder.annotated.annotatedMemory import AnnotatedMemory
from translator.intermediateBuilder.input import Input

class AnnotatedRandom(AnnotatedMemory):
	""" AnnotatedRandom is the annotated version of the random """
	
	def __init__(self, abreg, coordinates):
		""" Constructor """
		AnnotatedMemory.__init__(self, abreg, coordinates)	
		#We can set the reset, enable and clock coordinates right
		self.resetInputCoordinate = (coordinates[0]-20, coordinates[1]+20)
		self.clockInputCoordinate = (coordinates[0]-30, coordinates[1]-10)
		self.enableInputCoordinate = (coordinates[0]-30, coordinates[1]+10)

	def getInputCoordinates(self, list):		
		""" Overwrites the parent function (but has the same meaning) """
		list.extend([self.clockInputCoordinate, self.enableInputCoordinate, self.resetInputCoordinate])	

	def setInputRight(self, coordinate, annotatedConnection, inputsFound, extraInfo):			
		""" Overwrites the parent function (but has the same meaning) """					
		if coordinate == self.enableInputCoordinate:
			input = Input(annotatedConnection.connection)
			self.node.enableInputWire = input		
		else:
			AnnotatedMemory.setInputRight(self, coordinate, annotatedConnection, inputsFound, extraInfo)					

	def bindMemoryWithCompExtraCoordinates(self, annotatedComp, annotatedConnectionList, inputsFound, connectedInputs):	
		""" Overwrites the parent function (but has the same meaning) """	
		annotatedComp.bindCompWithComp(self.enableInputCoordinate, self, annotatedConnectionList, inputsFound, connectedInputs)	
	
	def bindMemoryWithInputWiresExtraCoordinates(self, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs):
		""" Overwrites the parent function (but has the same meaning) """	
		self.bindWithInputWires(self.enableInputCoordinate, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs)	