#!/usr/bin/env python3

from translator.intermediateBuilder.annotated.annotatedArithmetic import AnnotatedArithmetic
from translator.intermediateBuilder.input import Input

class AnnotatedShifter (AnnotatedArithmetic):
	""" AnnotatedShifter is the annotated version of the shifter """
	
	def __init__(self, arithmetic, coordinates):
		""" Constructor """
		#Calculate the input coordinate and give it to the init of the parent
		inputCoordinate = (coordinates[0]-40, coordinates[1]-10)
		AnnotatedArithmetic.__init__(self, arithmetic, coordinates, inputCoordinate)
		self.distanceInputCoordinate = (coordinates[0]-40, coordinates[1]+10)

	def getInputCoordinates(self, list):		
		""" Overwrites the parent function (but has the same meaning) 	""" 
		AnnotatedArithmetic.getInputCoordinates(self, list)
		list.append(self.distanceInputCoordinate)

	def setInputRight(self, coordinate, annotatedConnection, inputsFound, extraInfo):			
		""" Overwrites the parent function (but has the same meaning) 	""" 					
		if coordinate == self.distanceInputCoordinate:
			input = Input(annotatedConnection.connection)
			self.node.distanceInputWire = input		
		else:
			#If it wasn't an extra input we found, we call the parent function (because this means we found a normal input)
			AnnotatedArithmetic.setInputRight(self, coordinate, annotatedConnection, inputsFound, extraInfo)		

	def bindArithmeticWithComp(self, annotatedComponentList, annotatedConnectionList, inputsFound, connectedInputs):	
		""" Overwrites the parent function (but has the same meaning) 	""" 
		for annotatedList in annotatedComponentList:
			for annotatedComp in annotatedList:
				if annotatedComp == self:
					continue
				annotatedComp.bindCompWithComp(self.inputCoordinate, self, annotatedConnectionList, inputsFound, connectedInputs)	
				annotatedComp.bindCompWithComp(self.distanceInputCoordinate, self, annotatedConnectionList, inputsFound, connectedInputs)	

	def bindArithmeticWithInputWires(self, annotatedConnectionList, inputsFound, connectedInputs):	
		""" Overwrites the parent function (but has the same meaning) 	""" 
		for annotatedConnection in annotatedConnectionList:	
			self.bindWithInputWires(self.inputCoordinate, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs)	
			self.bindWithInputWires(self.distanceInputCoordinate, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs)						