#!/usr/bin/env python3

from translator.intermediateBuilder.annotated.annotatedFlipFlop import AnnotatedFlipFlop
from translator.intermediateBuilder.input import Input

class AnnotatedTwoInputFlipFlop(AnnotatedFlipFlop):
	""" AnnotatedOneInputFlipFlop is the annotated version of a flipflop with two inputs """
	
	def __init__(self, flipflop, coordinates):
		""" Constructor """
		AnnotatedFlipFlop.__init__(self, flipflop, coordinates)	
		self.secondInputCoordinate = (coordinates[0]-40, coordinates[1])
		self.clockInputCoordinate = (coordinates[0]-40, coordinates[1]+10)

	def getInputCoordinates(self, list):		
		""" Overwrites the parent function (but has the same meaning) """	
		AnnotatedFlipFlop.getInputCoordinates(self, list)
		list.append(self.secondInputCoordinate)

	def setInputRight(self, coordinate, annotatedConnection, inputsFound, extraInfo):			
		""" Overwrites the parent function (but has the same meaning) """						
		if coordinate == self.secondInputCoordinate:
			input = Input(annotatedConnection.connection)
			self.node.secondInputWire = input		
		else:
			AnnotatedFlipFlop.setInputRight(self, coordinate, annotatedConnection, inputsFound, extraInfo)		
	
	def bindMemoryWithCompExtraCoordinates(self, annotatedComp, annotatedConnectionList, inputsFound, connectedInputs):	
		""" Overwrites the parent function (but has the same meaning) """	
		annotatedComp.bindCompWithComp(self.enableInputCoordinate, self, annotatedConnectionList, inputsFound, connectedInputs)	
		annotatedComp.bindCompWithComp(self.setInputCoordinate, self, annotatedConnectionList, inputsFound, connectedInputs)	
		annotatedComp.bindCompWithComp(self.secondInputCoordinate, self, annotatedConnectionList, inputsFound, connectedInputs)	
	
	def bindMemoryWithInputWiresExtraCoordinates(self, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs):
		""" Overwrites the parent function (but has the same meaning) """	
		self.bindWithInputWires(self.enableInputCoordinate, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs)	
		self.bindWithInputWires(self.setInputCoordinate, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs)	
		self.bindWithInputWires(self.secondInputCoordinate, annotatedConnection, annotatedConnectionList, inputsFound, connectedInputs)	