#!/usr/bin/env python3

from translator.intermediateBuilder.arithmeticWithoutCarry import ArithmeticWithoutCarry
from translator.intermediateBuilder.node import Node

class BitFinder(ArithmeticWithoutCarry):
	""" The Bit Finder takes a multi-bit input and determines the index of a bit, where the index is computed by counting from 0 as the lowest-order bit """
	
	def __init__(self):
		""" Constructor """
		ArithmeticWithoutCarry.__init__(self)	
		self.presentOutputWire = None 
		self.type = ("low", 1)
	
	def bindOutputWithComp(self, wire, infoTuple):		
		""" Overwrites the parent function (but has the same meaning) """
		#If the normal bool is true, we know we need to assign the output to the normal output
		if infoTuple[2]:
			self.outputWire.connections.append(wire)
		else:
			self.presentOutputWire.connections.append(wire)	

	def getAllElementsViaOuputConnected(self):			
		""" Overwrites the parent function (but has the same meaning) """
		list = []
		outputWires = [self.outputWire, self.presentOutputWire]
		for output in outputWires:
			if output != None:
				for wire in output.connections:
					list.append(wire)
		return list

	def setExtraOutput(self, originalWire, newWire):		
		""" Overwrites the parent function (but has the same meaning) """
		if originalWire in self.outputWire.connections:
			self.outputWire.connections.append(newWire)	
		else:
			self.presentOutputWire.connections.append(newWire)			
