#!/usr/bin/env python3

from translator.intermediateBuilder.arithmeticNode import ArithmeticNode
from translator.intermediateBuilder.node import Node

class CarryArithmetic(ArithmeticNode):
	""" A generic class for the substractor, adder, divider and multiplier
	They all have a second input and a carry in and out """
	
	def __init__(self):
		""" Constructor """
		ArithmeticNode.__init__(self)	
		self.secondInputWire = None
		#The carry in or borrow in or dividend upper
		self.extraInputWire = None
		#The carry out or borrow out or remainder
		self.extraOutputWire = None

	def bindOutputWithComp(self, wire, infoTuple):
		""" Overwrites the parent function (but has the same meaning) """
		#If the normal bool is true, we know we need to assign the output to the normal output
		if infoTuple[2]:
			self.outputWire.connections.append(wire)
		else:
			self.extraOutputWire.connections.append(wire)			

	def getAllElementsViaOuputConnected(self):	
		""" Overwrites the parent function (but has the same meaning) """
		list = []
		outputWires = [self.outputWire, self.extraOutputWire]
		for output in outputWires:
			if output != None:
				for wire in output.connections:
					list.append(wire)				
		return list

	def setExtraOutput(self, originalWire, newWire):		
		""" Overwrites the parent function (but has the same meaning) """
		if originalWire in self.outputWire.connections:
			self.outputWire.connections.append(newWire)	
		else:
			self.extraOutputWire.connections.append(newWire)		
