#!/usr/bin/env python3

from translator.intermediateBuilder.arithmeticWithoutCarry import ArithmeticWithoutCarry

class Comparator(ArithmeticWithoutCarry):
	""" Comparator compares two values, either as unsigned values or as two's-complement values, depending on the Numeric Type """
	
	def __init__(self):
		""" Constructor """
		ArithmeticWithoutCarry.__init__(self)	
		self.greaterOutputWire = None 
		self.lessOutputWire = None 
		self.secondInputWire = None
		self.numericType = "complement" 

	def bindOutputWithComp(self, wire, infoTuple):
		""" Overwrites the parent function (but has the same meaning) """
		if infoTuple[2] == "normal":
			self.outputWire.connections.append(wire)
		elif infoTuple[2] == "less":
			self.lessOutputWire.connections.append(wire)		
		elif infoTuple[2] == "greater":
			self.greaterOutputWire.connections.append(wire)			

	def getAllElementsViaOuputConnected(self):
		""" Overwrites the parent function (but has the same meaning) """
		list = []
		outputWires = [self.outputWire, self.lessOutputWire, self.greaterOutputWire]
		for output in outputWires:
			if output != None:
				for wire in output.connections:
					list.append(wire)						
		return list

	def setExtraOutput(self, originalWire, newWire):
		""" Overwrites the parent function (but has the same meaning) """
		if originalWire in self.outputWire.connections:
			self.outputWire.connections.append(newWire)	
		elif originalWire in self.greaterOutputWire.connections:
			self.greaterOutputWire.connections.append(newWire)	
		else:
			self.lessOutputWire.connections.append(newWire)	
