#!/usr/bin/env python3

from translator.intermediateBuilder.abstractRegister import AbstractRegister

class Counter(AbstractRegister):
	""" The counter holds a single value, whose value is emitted on the output
	Each time the clock input triggers, the value in the counter may update based on the extra inputs """
	
	def __init__(self):
		""" Constructor """
		AbstractRegister.__init__(self)	
		self.loadInputWire = None
		self.carryOutputWire = None
		self.maxValue = "0xff"
		self.actionOverflow = "wrap"

	def bindOutputWithComp(self, wire, infoTuple):		
		""" Overwrites the parent function (but has the same meaning) """
		#If the normal bool is true, we know we need to assign the output to the normal output
		if infoTuple[2]:
			self.outputWire.connections.append(wire)
		else:
			self.carryOutputWire.connections.append(wire)		

	def getAllElementsViaOuputConnected(self):
		""" Overwrites the parent function (but has the same meaning) """
		list = []
		outputWires = [self.outputWire, self.carryOutputWire]
		for output in outputWires:
			if output != None:
				for wire in output.connections:
					list.append(wire)					
		return list		

	def setExtraOutput(self, originalWire, newWire):		
		""" Overwrites the parent function (but has the same meaning) """
		if originalWire in self.outputWire.connections:
			self.outputWire.connections.append(newWire)	
		else:
			self.carryOutputWire.connections.append(newWire)			
