#!/usr/bin/env python3

from  translator.intermediateBuilder.plexerNode import PlexerNode

class Decoder(PlexerNode):
	""" Decoder emits 1 on exactly one output; which output is 1 depends on the current value received through the input """
	
	def __init__(self):
		""" Constructor """
		PlexerNode.__init__(self)
		self.threeState = False

	def bindOutputWithComp(self, wire, infoTuple):	
		""" Overwrites the parent function (but has the same meaning) """
		#We extend because there could be already wires assigned to the output
		self.outputWire.connections.append((wire, infoTuple[2]))	

	def getAllElementsViaOuputConnected(self):		
		""" Overwrites the parent function (but has the same meaning) """
		list = []
		if self.outputWire != None and isinstance(self.outputWire.end, Node):
			list.append(self.outputWire.end)
		if self.lessOutputWire != None and isinstance(self.lessOutputWire.end, Node):
			list.append(self.lessOutputWire.end)
		if self.greaterOutputWire != None and isinstance(self.greaterOutputWire.end, Node):
			list.append(self.greaterOutputWire.end)			
		return list		

	def getAllElementsViaOuputConnected(self):		
		""" Overwrites the parent function (but has the same meaning) """
		list = []
		if self.outputWire != None:
			for wire in self.outputWire.connections:
				list.append(wire[0])				
		return list				
		
	def setExtraOutput(self, originalWire, newWire):		
		""" Overwrites the parent function (but has the same meaning) """
		for outputTuple in self.outputWire.connections:
			if originalWire == outputTuple[0]:
				number = outputTuple[1]
		self.outputWire.connections.append((newWire, number))			
