#!/usr/bin/env python3

from  translator.intermediateBuilder.plexerNode import PlexerNode

class Demultiplexer(PlexerNode):
	""" Demultiplexer copies the input onto exactly one of the outputs; 
	which of these outputs is specified via the current value received through the select input """
	
	def __init__(self):
		""" Constructor """
		PlexerNode.__init__(self)
		self.threeState = False
		self.inputWire = None

	def bindOutputWithComp(self, wire, infoTuple):		
		""" Overwrites the parent function (but has the same meaning) """
		#We need to remember the output Number
		self.outputWire.connections.append((wire, infoTuple[2]))

	def getAllElementsViaOuputConnected(self):		
		""" Overwrites the parent function (but has the same meaning) """
		list = []
		if self.outputWire != None:
			for wire in self.outputWire.connections:
				list.append(wire[0])				
		return list				

	def setExtraOutput(self, originalWire, newWire):		
		""" Overwrites the parent function (but has the same meaning) """
		for outputTuple in self.outputWire.connections:
			if originalWire == outputTuple[0]:
				number = outputTuple[1]
		self.outputWire.connections.append((newWire, number))				
