#!/usr/bin/env python3

from translator.intermediateBuilder.memoryNode import MemoryNode

class FlipFlop(MemoryNode):
	""" Each flip-flop stores a single bit of data """
	
	def __init__(self):
		""" Constructor """
		MemoryNode.__init__(self, 1)	
		self.enableInputWire = None
		self.setInputWire = None
		self.complementOutputWire = None

	def bindOutputWithComp(self, wire, infoTuple):
		""" Overwrites the parent function (but has the same meaning) """
		#If the normal bool is true, we know we need to assign the output to the normal output
		if infoTuple[2]:
			self.outputWire.connections.append(wire)
		else:
			self.complementOutputWire.connections.append(wire)	

	def getAllElementsViaOuputConnected(self):			
		""" Overwrites the parent function (but has the same meaning) """
		list = []
		outputWires = [self.outputWire, self.complementOutputWire]
		for output in outputWires:
			if output != None:
				for wire in output.connections:
					list.append(wire)						
		return list			

	def setExtraOutput(self, originalWire, newWire):	
		""" Overwrites the parent function (but has the same meaning) """
		if originalWire in self.node.outputWire.connections:
			self.outputWire.connections.append(newWire)	
		else:
			self.complementOutputWire.connections.append(newWire)		