#!/usr/bin/env python3

from translator.intermediateBuilder.node import Node

class GateNode(Node):
	""" A generic class for the gate nodes (all of which have a single output whose value is dictated entirely by the current inputs) """	
	
	def __init__(self, dataBits = 1):
		""" Constructor """
		Node.__init__(self, dataBits)	
		self.inputWires = []
		self.out = None

	def isNegatedGate(self):		
		""" For example Nand, Nor, ... are negated, the rest isn't """
		return False	

	def isBiggerGate(self):
		""" A xor or xnor gate is a bigger gate, the rest is not bigger """
		return False
