#All the keywords of verilog (you can't use these as names)
keyWordList = [ "always", "end", "ifnone", "or", "rpmos", "tranif1", "and", "endcase", "initial", "output", "rtran", "tri", "assign", "endmodule", 
				"inout", "parameter", "rtranif0", "tri0", "begin", "endfunction", "input", "pmos", "rtranif1", "tri1", "buf", "endprimitive", "integer", 
				"posedge", "scalared", "triand", "bufif0", "endspecify", "join", "primitive", "small", "trior", "bufif1", "endtable", "large", "pull0", 
				"specify", "trireg", "case", "endtask", "macromodule", "pull1", "specparam", "vectored", "casex", "event", "medium", "pullup", "strong0", 
				"wait", "casez", "for", "module", "pulldown", "strong1", "wand", "cmos", "force", "nand", "rcmos", "supply0", "weak0", "deassign", "forever", 
				"negedge", "real", "supply1", "weak1", "default", "for", "nmos", "realtime", "table", "i", "while", "defparam", "function", "nor", "reg", "task", 
				"wire", "disable", "highz0", "not", "release", "time", "wor", "edge", "highz1", "notif0", "repeat", "tran", "xnor", "else", "if", "notif1", 
				"rnmos", "tranif0", "xor", "localparam" ]	

def validName(name, proposedName, startingNumber, nameList, isWire= False):	
	""" Test whether a name is valid, if it is not it will return a valid name (and the returned name is added to the used name list)
	It wil try to use the proposed name if the real name isn't good enough (Verilog doesn't like names that are equal to a keyword or a name that has special signs) """
	name = name.replace(" ", "")
	if not name.isidentifier() or name in keyWordList or name in nameList or name == "" or (name[:4] == "wire" and name[4:].isdigit() and not isWire):
		count = startingNumber
		newName = proposedName + str(count)
		while newName in nameList:
			count += 1
			newName = proposedName + str(count)
		name = newName
	#This name is now in use, so if there is another component with this name this component will need another name
	nameList.append(name)		
	return name		

def sub(a, b):	
	""" Subtracts the two parameters (This function can be passed as a parameter (for calculateStartingPoint)) """
	return a-b

def add(a, b):
	""" Adds the two parameters (This function can be passed as a parameter (for calculateStartingPoint)) """	
	return a+b	

def returnA(a, b):	
	""" Returns the first parameter (This function can be passed as a parameter (for calculateStartingPoint)) """	
	return a

def deleteElementsFromElementList(elementsToBeDeleted, elementList):	
	""" We delete the elementsToBeDeleted from the list """
	for elementToBeDeleted in elementsToBeDeleted:
		elementList.remove(elementToBeDeleted)    

def getInputList(annotatedComponentList):		
	""" Will return all the input coordinates of all the components """
	inputList = []
	for annotatedComponents in annotatedComponentList:
		for annotatedComponent in annotatedComponents:
			annotatedComponent.getInputCoordinates(inputList)
	return inputList		

def getOutputList(annotatedComponentList):
	""" Will return all the ouput coordinates of all the components """
	outputList = []
	for annotatedComponents in annotatedComponentList:
		for annotatedComponent in annotatedComponents:
			annotatedComponent.getOutputCoordinates(outputList)
	return outputList	