#!/usr/bin/env python3

from translator.intermediateBuilder.node import Node

class ImportedCircuitNode(Node):
	""" An imported circuit (subcircuit), if you want to build smaller circuits that you can use multiple times as a module nested within larger circuits  """
	
	def __init__(self, circuit):
		""" Constructor """
		Node.__init__(self, None)	
		#A list of input wires with their respective bases
		self.inputWires = []
		#The circuit that is being imported (a reference)
		self.referencedCircuit = circuit 

	def bindOutputWithComp(self, wire, infoTuple):		
		""" Overwrites the parent function (but has the same meaning) """
		#We need to remember the output base
		self.outputWire.connections.append((wire, infoTuple[2]))		

	def getAllElementsViaOuputConnected(self):		
		""" Overwrites the parent function (but has the same meaning) """
		list = []
		if self.outputWire != None:
			for wire in self.outputWire.connections:
				list.append(wire[0])					
		return list					

	def setExtraOutput(self, originalWire, newWire):		
		""" Overwrites the parent function (but has the same meaning) """
		for outputTuple in self.outputWire.connections:
			if originalWire == outputTuple[0]:
				reference = outputTuple[1]
		self.outputWire.connections.append((newWire, reference))			