#!/usr/bin/env python3

class IntermediateTree():
	""" The intermediate tree (of the logisim file). It is an abstract tree (created by makeIntermediateTree of intermediateBuilder) """
	
	def __init__(self, circuitList):
		""" Constructor """
		self.circuitList = circuitList

	def traverse(self, visitor, startFresh= True):
			
		""" Traverses the tree and visits every node while using the visitor parameter """	
		#If we want to start fresh, we clean the visitors element
		if startFresh:
			visitor.__init__()
		for circuit in self.circuitList:
			visitor.visit(circuit)
			#The translation visitor is based upon the fact that nodes are visited before connections
			for node in circuit.nodeList:
				visitor.visit(node)
			for wire in circuit.connectionList:
				visitor.visit(wire)
