#!/usr/bin/env python3

from translator.intermediateBuilder.baseNode import BaseNode

class JoystickBase(BaseNode):
	""" The joystick produces 2 output signals """
	
	def __init__(self):
		""" Constructor """
		BaseNode.__init__(self, 4)	
		self.secondOutputWire = None
		self.color = "#ff0000"

	def bindOutputWithComp(self, wire, infoTuple):		
		""" Overwrites the parent function (but has the same meaning) """
		#If the normal bool is true, we know we need to assign the output to the normal output
		if infoTuple[2]:
			self.outputWire.connections.append(wire)
		else:
			self.secondOutputWire.connections.append(wire)	

	def getAllElementsViaOuputConnected(self):			
		""" Overwrites the parent function (but has the same meaning) """
		list = []
		outputWires = [self.outputWire, self.secondOutputWire]
		for output in outputWires:
			if output != None:
				for wire in output.connections:
					list.append(wire)				
		return list			

	def setExtraOutput(self, originalWire, newWire):		
		""" Overwrites the parent function (but has the same meaning) """
		if originalWire in self.node.outputWire.connections:
			self.outputWire.connections.append(newWire)	
		else:
			self.secondOutputWire.connections.append(newWire)			