#!/usr/bin/env python3

from translator.intermediateBuilder.element import Element

class Node(Element):
	""" A generic class """	
	
	def __init__(self, dataBits, name = ""):
		""" Constructor """
		Element.__init__(self, name)	
		self.bits = dataBits
		self.outputWire = None

	def bindOutputWithComp(self, wire, infoTuple):					
		""" Binds the output of the comp that was directly connected to another components input """
		self.outputWire.connections.append(wire)

	def getAllElementsViaOuputConnected(self):		
		""" Overwrites the parent function (but has the same meaning) """
		list = []
		if self.outputWire != None:
			for wire in self.outputWire.connections:
				list.append(wire)
		return list

	def setExtraOutput(self, originalWire, newWire):		
		""" Adds a wire to the output, because we found an extra input connected to this output """
		self.outputWire.connections.append(newWire)	