#!/usr/bin/env python3

from translator.intermediateBuilder.element import Element
from translator.intermediateBuilder.node import Node
from translator.intermediateBuilder.helperFunctions import deleteElementsFromElementList

class Splitter(Element):
	""" The splitter creates a correspondence between a multi-bit value and several separate subsets of those bits """
	
	def __init__(self):
		""" Constructor """
		Element.__init__(self, "")
		self.start = []
		self.end = []
		self.bits = 2

	def getAllElementsViaOuputConnected(self):			
		""" Overwrites the parent function (but has the same meaning) """
		list = []
		for wire in self.start[1].connections:
			list.append(wire)
		for outputTuples in self.end[1]:
			for wire in outputTuples[1].connections:
				list.append(wire)
		return list

	def setExtraOutput(self, originalWire, newWire):		
		""" Adds a wire to the output, because we found an extra input connected to this output """
		for startWire in self.start[1].connections:
			if originalWire == startWire:
				self.start[1].connections.append(newWire)
				return
		for endTuple in self.end[1]:
			for endWire in endTuple[1].connections:
				if originalWire == endWire:
					endTuple[1].connections.append(newWire)
					return			
