from translator.visitor.DEVSlibrary.Gates import *

class AND(Gates):
	""" The AND class, this is an AND gate in Logisims """
	def __init__(self, bitSize, delay, inputs, outputs, outChange, negateList):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		# The negate list is needed to make a unique name
		printNegateList = ""
		for i in negateList:
			printNegateList += "d" + str(i)
		bitlist = []
		for i in range(len(inputs)):
			bitlist.append(bitSize)
		Gates.__init__(self, bitSize, "AND" + "b" + str(bitSize) +"c" + str(outChange) + "i" + str(len(inputs)) + "n" + str(printNegateList), delay, inputs, outputs, bitlist)
		self.out = outChange
		self.negate = negateList

		self.outbitlist = [bitSize]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = deepcopy(self.state)\n"
		string += "\t\tif str(state) == 'active':\n"
		for i in self.negate:
			string += negateInput(i, 3)
		string += "\t\t\toutValue = 'b'\n"
		string += "\t\t\tfor i in range(len(state."
		string += self.inputs[0]
		string += ")):\n"
		string += "\t\t\t\tif "
		for i in range(len(self.inputs)):
			if i != 0:
				string += " and "
			string += "state."
			string += self.inputs[i]
			string += "[i] == '1'"
		string += ":\n"
		string += "\t\t\t\t\toutValue += '1'\n"
		string += "\t\t\t\telif "
		for i in range(len(self.inputs)):
			if i != 0:
				string += " or "
			string += "state."
			string += self.inputs[i]
			string += "[i] == '0'"
		string += ":\n"
		string += "\t\t\t\t\toutValue += '0'\n"
		string += "\t\t\t\telif "
		for i in range(len(self.inputs)):
			if i != 0:
				string += " or "
			string += "state."
			string += self.inputs[i]
			string += "[i] == 'E' or "
			string += "state." + self.inputs[i] + "[i] == 'x' "
		string += ":\n"
		string += "\t\t\t\t\toutValue += 'E'\n"
		string += "\t\t\t\telse:\n"
		string += "\t\t\t\t\toutValue += '0'\n"
		if self.out != "01":
			string += outChanger(self.out, "outValue", 3);
		string += "\t\t\tself.poke(self."
		string += self.outputs[0]
		string += ", outValue)\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
