from translator.visitor.DEVSlibrary.Model import *

class Arithmetic(Model):
	""" The Arithmetic class, this is the base of all standard operations in logisim"""
	def __init__(self, bitSize, name, delay, inputs, outputs, bitlist):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		Model.__init__(self, bitSize, name, delay, inputs, outputs, bitlist)

	def bitArithmetic(self, in1, in2, carryIn, operator, tabs):
		# Start by checking both for x or E, since this does not allow normal procedures...
		string = ""
		string += setTabs(tabs) + "# HELPER: Bit arithmetic\n"
		string += setTabs(tabs) + "carryIn = " + str(carryIn) + "\n"
		# Start checking for strange input
		if operator == '/':
			# Just modify the ports to make use of the basic elements
			string += setTabs(tabs) + in2 + " = '0' * len(" + in1 + ") + " + in2 + "\n"
			string += setTabs(tabs) + in1 + " = carryIn + " + in1 + "\n"
		string += setTabs(tabs) + "correct = len(" + in1 + ")\n"
		string += setTabs(tabs) + "for i in range(len(" + in1 + ")):\n"
		string += setTabs(tabs+1) + "if (i == 0) and (" + in1 + "[-i] != '1' and " + in1 + "[-i] != '0'):\n"
		string += setTabs(tabs+2) + "correct = correct-1\n"
		string += setTabs(tabs+2) + "fail = " + in1 + "[-i]\n"
		string += setTabs(tabs+1) + "elif (i == 0) and (" + in2 + "[-i] != '1' and " + in2 + "[-i] != '0'):\n"
		string += setTabs(tabs+2) + "correct = correct-1\n"
		string += setTabs(tabs+2) + "fail = " + in2 + "[-i]\n"
		string += setTabs(tabs+1) + "elif (" + in1 + "[-i] != '1' and " + in1 + "[-i] != '0'):\n"
		string += setTabs(tabs+2) + "correct = i-1\n"
		string += setTabs(tabs+2) + "fail = " + in1 + "[-i]\n"
		string += setTabs(tabs+2) + "break\n"
		string += setTabs(tabs+1) + "elif (" + in2 + "[-i] != '1' and " + in2 + "[-i] != '0'):\n"
		string += setTabs(tabs+2) + "correct = i-1\n"
		string += setTabs(tabs+2) + "fail = " + in2 + "[-i]\n"
		string += setTabs(tabs+2) + "break\n"
		if operator == '*':
			string += setTabs(tabs+1) + "elif (i == 0) and (" + carryIn + "[-i] != '1' and " + carryIn + "[-i] != '0'):\n"
			string += setTabs(tabs+2) + "correct = correct-1\n"
			string += setTabs(tabs+2) + "fail = " + carryIn + "[-i]\n"
			string += setTabs(tabs+1) + "elif (" + carryIn + "[-i] != '1' and " + carryIn + "[-i] != '0'):\n"
			string += setTabs(tabs+2) + "correct = i-1\n"
			string += setTabs(tabs+2) + "fail = " + carryIn + "[-i]\n"
			string += setTabs(tabs+2) + "break\n"

		# When multiplying and an x is found as first fail, it is possible for a preceding E to take over...
		if operator == '*':
			string += setTabs(tabs) + "if correct != len(" + str(in1) + ") and fail == 'x':\n"
			string += setTabs(tabs+1) + "correctE = 0\n"
			string += setTabs(tabs+1) + "for i in range(len(" + in1 + ")):\n"
			string += setTabs(tabs+2) + "if (i == 0) and (" + in1 + "[-i] == 'E'):\n"
			string += setTabs(tabs+3) + "correctE = len(" + in1 + ")-1\n"
			string += setTabs(tabs+2) + "elif (i == 0) and (" + in2 + "[-i] == 'E' ):\n"
			string += setTabs(tabs+3) + "correctE = len(" + in1 + ")-1\n"
			string += setTabs(tabs+2) + "elif (" + in1 + "[-i] == 'E'):\n"
			string += setTabs(tabs+3) + "correctE = i-1\n"
			string += setTabs(tabs+3) + "break\n"
			string += setTabs(tabs+2) + "elif (" + in2 + "[-i] == 'E'):\n"
			string += setTabs(tabs+3) + "correctE = i-1\n"
			string += setTabs(tabs+3) + "break\n"
			string += setTabs(tabs+2) + "elif (i == 0) and (" + carryIn + "[-i] == 'E'):\n"
			string += setTabs(tabs+3) + "correctE = len(" + in1 + ")-1\n"
			string += setTabs(tabs+2) + "elif (" + carryIn + "[-i] == 'E'):\n"
			string += setTabs(tabs+3) + "correctE = i-1\n"
			string += setTabs(tabs+3) + "break\n"

		if operator == '*':
			string += setTabs(tabs) + "if correct != len(" + in1 + ") and fail != 'E' and (" + in1 + "[-correct-1] == 'E' or " + in2 + "[-correct-1] == 'E' or " + carryIn + "[-correct-1] == 'E'):\n"
			string += setTabs(tabs+1) + "fail = 'E'\n"
		else:
			string += setTabs(tabs) + "if correct != len(" + in1 + ") and fail != 'E' and (" + in1 + "[-correct-1] == 'E' or " + in2 + "[-correct-1] == 'E'):\n"
			string += setTabs(tabs+1) + "fail = 'E'\n"
		if operator == '-':
			string += setTabs(tabs) + "if correct != len(" + in1 + ") and fail != 'E' and (" + in2 + "[-correct-1] == 'x'):\n"
			string += setTabs(tabs+1) + "fail = 'E'\n"
		string += setTabs(tabs) + "length = len(" + in1 + ")\n"
		string += setTabs(tabs) + "out = ''\n"
		if operator == '+' or operator == '-':
			string += setTabs(tabs) + "if carryIn == 'E':\n"
			string += setTabs(tabs+1) + "correct = 0\n"
			string += setTabs(tabs+1) + "fail = 'E'\n"
		string += setTabs(tabs) + "toFill = length - correct\n"
		if operator != "*":
			string += setTabs(tabs) + "for i in range(toFill):\n"
			string += setTabs(tabs+1) + "out += fail\n"
		string += setTabs(tabs) + "if correct != 0:\n"
		string += setTabs(tabs+1) + "bitstring1 = " + in1 + "[-correct:]\n"
		string += setTabs(tabs+1) + "bitstring2 = " + in2 + "[-correct:]\n"
		if operator == '*':
			string += setTabs(tabs+1) + "bitstring3 = " + carryIn + "[-correct:]\n"
		# These elements don't need anything special, just bitwise addition is possible with two's complement encoding
		string += setTabs(tabs+1) + "int1 = int(bitstring1, 2)\n"
		string += setTabs(tabs+1) + "int2 = int(bitstring2, 2)\n"
		if operator == '*':
			string += setTabs(tabs+1) + "int3 = int(bitstring3, 2)\n"
		return string
