from translator.visitor.DEVSlibrary.Arithmetic import *

class BitAdder(Arithmetic):
	""" A BitAdder, this is a Bit Adder in Logisim """
	def __init__(self, bitSize, delay, inputs, outputs):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		for i in inputs:
			bitlist.append(bitSize)
		Arithmetic.__init__(self, bitSize, "BitAdder" + "b" + str(bitSize) + "i" + str(len(inputs)), delay, inputs, outputs, bitlist)
		from math import log
		from math import ceil
		outputlength = ceil(log(len(self.inputs) * self.bitSize + 1, 2))
		self.outbitlist = [outputlength]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\tlower = 0\n"
		string += "\t\t\tupper = 0\n"
		for i in self.inputs:
			string += "\t\t\tinp = state." + i + "\n"
			string += "\t\t\tfor i in inp:\n"
			string += "\t\t\t\tif i == '1':\n"
			string += "\t\t\t\t\tlower += 1\n"
			string += "\t\t\t\t\tupper += 1\n"
			string += "\t\t\t\telif i == 'x' or i == 'E':\n"
			string += "\t\t\t\t\tupper += 1\n"
		string += "\t\t\tbinlower = bin(lower)[2:]\n"
		string += "\t\t\tbinupper = bin(upper)[2:]\n"
		string += padBits("binlower", self.outbitlist[0], 3)
		string += padBits("binupper", self.outbitlist[0], 3)
		string += "\t\t\tresult = ''\n"
		string += "\t\t\tnoError = True\n"
		string += "\t\t\tfor i in range(" + str(self.outbitlist[0]) + "):\n"
		string += "\t\t\t\tif (binlower[i] == binupper[i]) and noError:\n"
		string += "\t\t\t\t\tresult += binlower[i]\n"
		string += "\t\t\t\telse:\n"
		string += "\t\t\t\t\tresult += 'E'\n"
		string += "\t\t\t\t\tnoError = False\n"
		string += "\t\t\tself.poke(self." + self.outputs[0] + ", 'b' + str(result))\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
