from translator.visitor.DEVSlibrary.Arithmetic import *

class BitFinder(Arithmetic):
	""" The BitFinder class, this is a Bit finder in logisim """
	def __init__(self, bitSize, delay, inputs, outputs, findType):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		bitlist.append(bitSize)
		Arithmetic.__init__(self, bitSize, "BitFinder" + "b" + str(bitSize) + "f" + str(findType[0]) + str(findType[1]), delay, inputs, outputs, bitlist)
		self.type = findType
		from math import log
		from math import ceil
		outputlength = ceil(log(self.bitSize, 2))
		self.outbitlist = [outputlength, 1]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\tinp = state." + str(self.inputs[0]) + "\n"
		string += "\t\t\tbit = " + str(self.type[1]) + "\n"
		string += "\t\t\tfound = False\n"
		string += "\t\t\tresult = 0\n"
		string += "\t\t\tfor i in "
		if self.type[0] == "low":
			string += "reversed("
		string += "range(len(inp))"
		if self.type[0] == "low":
			string += ")"
		string += ":\n"
		string += "\t\t\t\tif inp[i] == str(bit):\n"
		string += "\t\t\t\t\tresult = i\n"
		string += "\t\t\t\t\tfound = True\n"
		string += "\t\t\t\t\tbreak\n"
		string += "\t\t\t\tif inp[i] == 'x' or inp[i] == 'E':\n"
		string += "\t\t\t\t\tresult = -1\n"
		string += "\t\t\t\t\tbreak\n"
		string += "\t\t\tif result == -1:\n"
		string += "\t\t\t\tresult = 'E' * " + str(self.outbitlist[0]) + "\n"
		string += "\t\t\t\tfound = 'E'\n"
		string += "\t\t\telse:\n"
		string += "\t\t\t\tresult = bin(" + str(self.bitSize) + " - 1 - result)[2:]\n"
		string += padBits("result", self.outbitlist[0], 4)
		string += "\t\t\t\tif found:\n"
		string += "\t\t\t\t\tfound = '1'\n"
		string += "\t\t\t\telse:\n"
		string += "\t\t\t\t\tfound = '0'\n"
		string += "\t\t\t\t\tresult = '0' * " + str(self.outbitlist[0]) + "\n"
		string += "\t\t\tself.poke(self." + self.outputs[0] + ", 'b' + str(result))\n"
		string += "\t\t\tself.poke(self." + self.outputs[1] + ", 'b' + str(found))\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
