from translator.visitor.DEVSlibrary.Helpers import *

class BitMerger(Helpers):
	""" The Bitmerger, this doesn't have an equivalent in logisim.

	It can best be compared to a splitter with all 1-bit outputs and in incremental order."""
	def __init__(self, bitSize):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		inputs = []
		for i in range(bitSize):
			inputs.append("inputWire" + str(i))
			bitlist.append(1)
		outputs = ["outputWire"]
		Helpers.__init__(self, bitSize, "BitMerger" + "b" + str(bitSize), 0, inputs, outputs, bitlist)

		self.outbitlist = [bitSize]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\toutputState = ''\n"
		for i in self.inputs:
			string += "\t\t\toutputState = str(state." + str(i) + ") + outputState\n"
		string += "\t\t\tself.poke(self." + (self.outputs[0]) + ", 'b' + outputState)\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
