from translator.visitor.DEVSlibrary.Plexers import *
from math import ceil
from math import floor

def selecter(outName, inputs, tabs, inBits, outputBits, selectBits):
	""" The real work for the selecting """
	string = ""
	string += setTabs(tabs) + "# Selecter\n"
	string += setTabs(tabs) + "groups = 2 ** " + str(selectBits) + "\n"
	string += setTabs(tabs) + "if 'E' in state." + inputs[1] + ":\n"
	string += setTabs(tabs+1) + "outValue = 'x' * " + str(outputBits) + "\n"
	string += setTabs(tabs) + "elif 'x' in state." + inputs[1] + ":\n"
	string += setTabs(tabs+1) + "outValue = 'x' * " + str(outputBits) + "\n"
	string += setTabs(tabs) + "else:\n"
	string += setTabs(tabs+1) + "desiredGroup = int(" + str(toSelf(toState(inputs[1]))) + ", 2)\n"
	string += setTabs(tabs+1) + "groupLength = " + str(outputBits) + "\n"
	extraBits = (2 ** selectBits) * outputBits - inBits
	string += setTabs(tabs+1) + "inputString = '" + "0" * extraBits + "' + " + str(toSelf(toState(inputs[0]))) + "\n"
	string += setTabs(tabs+1) + "begin = desiredGroup * groupLength + 1\n" 
	string += setTabs(tabs+1) + "end = begin + groupLength - 1\n" 
	string += setTabs(tabs+1) + "if begin == end:\n"
	string += setTabs(tabs+2) + outName + " = str(inputString[-begin])\n"
	string += setTabs(tabs+1) + "else:\n"
	string += setTabs(tabs+2) + "begin = len(inputString) - end\n"
	string += setTabs(tabs+2) + "end = begin + groupLength\n"
	string += setTabs(tabs+2) + outName + " = str(inputString[begin:end])\n"
	string += setTabs(tabs) + "# End\n"
	return string
	

class BitSelecter(Plexers):
	""" The BitSelecter class, this is a Bit selecter in logisim """
	def __init__(self, bitSize, delay, inputs, outputs, outputBits, selectBits):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = [bitSize, selectBits]
		Plexers.__init__(self, bitSize, "BitSelecter" + "b" + str(bitSize) + "i" + str(len(inputs)) + "ob" + str(outputBits) + "s" + str(selectBits), delay, inputs, outputs, bitlist)
		self.outputBits = outputBits
		self.selectBits = selectBits
		self.outbitlist = [outputBits]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += selecter("outValue", self.inputs, 3, self.bitSize, self.outputBits, self.selectBits)
		string += "\t\t\tself.poke(self."
		string += self.outputs[0]
		string += ", 'b' + outValue)\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
