from translator.visitor.DEVSlibrary.Helpers import *

class BitShredder(Helpers):
	""" The BitShredder class, this doesn't have an equivalent in Logisim.

	It can best be compared to a splitter with all 1-bit inputs, putting it all on one big output, in incremental order."""
	def __init__(self, bitSize):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = [bitSize]
		inputs = ["inputWire"]
		outputs = []
		for i in range(bitSize):
			outputs.append("outputWire" + str(i))
		Helpers.__init__(self, bitSize, "Shredder" + "b" + str(bitSize), 0, inputs, outputs, bitlist)

		self.outbitlist = []
		for i in range(bitSize):
			self.outbitlist.append(1)

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		for i in range(len(self.outputs)):
			string += "\t\t\tself.poke(self." + str(self.outputs[i]) + ", 'b' + state." + str(self.inputs[0]) + "[" + str(-i-1) + "])\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
