from translator.visitor.DEVSlibrary.Arithmetic import *

class Comparator(Arithmetic):
	def __init__(self, bitSize, delay, inputs, outputs, numberType):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		for i in range(len(inputs)):
			bitlist.append(bitSize)
		Arithmetic.__init__(self, bitSize, "Comparator" + "b" + str(bitSize) + "i" + str(len(inputs)) + "t" + str(numberType), delay, inputs, outputs, bitlist)
		self.numberType = numberType
		self.outbitlist = [1, 1, 1]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\tin1 = state." + self.inputs[0] + "\n"
		string += "\t\t\tin2 = state." + self.inputs[1] + "\n"
		string += "\t\t\tresult = '='\n"
		string += "\t\t\tdone = False\n"
		if self.numberType == 'complement':
			string += "\t\t\tif in1[0] == '0' and in2[0] == '1':\n"
			string += "\t\t\t\tresult = '>'\n"
			string += "\t\t\t\tdone = True\n"
			string += "\t\t\telif in1[0] == '1' and in2[0] == '0':\n"
			string += "\t\t\t\tresult = '<'\n"
			string += "\t\t\t\tdone = True\n"
		string += "\t\t\tif not done:\n"
		string += "\t\t\t\tfor i in range(len(in1)):\n"
		string += "\t\t\t\t\tif in1[i] == 'E' or in2[i] == 'E':\n"
		string += "\t\t\t\t\t\tresult = 'E'\n"
		string += "\t\t\t\t\t\tbreak\n"
		string += "\t\t\t\t\tif in1[i] == 'x' or in2[i] == 'x':\n"
		string += "\t\t\t\t\t\tresult = 'x'\n"
		string += "\t\t\t\t\t\tbreak\n"
		string += "\t\t\t\t\tif in1[i] == '0' and in2[i] == '1':\n"
		string += "\t\t\t\t\t\tresult = '<'\n"
		string += "\t\t\t\t\t\tbreak\n"
		string += "\t\t\t\t\tif in1[i] == '1' and in2[i] == '0':\n"
		string += "\t\t\t\t\t\tresult = '>'\n"
		string += "\t\t\t\t\t\tbreak\n"

		# Set the values
		string += "\t\t\tif result == '=':\n"
		string += "\t\t\t\tsmallerThen = '0'\n"
		string += "\t\t\t\tequalTo = '1'\n"
		string += "\t\t\t\tlargerThen = '0'\n"
		string += "\t\t\telif result == '<':\n"
		string += "\t\t\t\tsmallerThen = '1'\n"
		string += "\t\t\t\tequalTo = '0'\n"
		string += "\t\t\t\tlargerThen = '0'\n"
		string += "\t\t\telif result == '>':\n"
		string += "\t\t\t\tsmallerThen = '0'\n"
		string += "\t\t\t\tequalTo = '0'\n"
		string += "\t\t\t\tlargerThen = '1'\n"
		string += "\t\t\telif result == 'E':\n"
		string += "\t\t\t\tsmallerThen = 'E'\n"
		string += "\t\t\t\tequalTo = 'E'\n"
		string += "\t\t\t\tlargerThen = 'E'\n"
		string += "\t\t\telif result == 'x':\n"
		string += "\t\t\t\tsmallerThen = 'x'\n"
		string += "\t\t\t\tequalTo = 'x'\n"
		string += "\t\t\t\tlargerThen = 'x'\n"
		string += "\t\t\tself.poke(self." + self.outputs[0] + ", 'b' + str(largerThen))\n"
		string += "\t\t\tself.poke(self." + self.outputs[1] + ", 'b' + str(equalTo))\n"
		string += "\t\t\tself.poke(self." + self.outputs[2] + ", 'b' + str(smallerThen))\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
