from translator.visitor.DEVSlibrary.Memory import *

class Counter(Memory):
	def __init__(self, bitSize, delay, inputs, outputs, trigger, maxSize, overflow):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		bitlist.append(bitSize)
		for i in range(len(inputs) - 1):
			bitlist.append(1)
		Memory.__init__(self, bitSize, "Counter" + "b" + str(bitSize) + "i" + str(len(inputs)) + "t" + str(trigger) + "o" + str(overflow) + "m" + str(maxSize), delay, inputs, outputs, bitlist, trigger, 2)
		self.maxSize = int(maxSize[2:], 16)
		self.overflow = overflow
		self.outbitlist = [bitSize, 1]

	def extraExtTransition(self, opt):
		string = ""
		string += "\t\tstate.memory = self.state.memory\n"
		string += "\t\tif state." + self.inputs[4] + " == '1':\n"
		string += "\t\t\tstate.memory = 0\n"
		string += "\t\telif state.triggered:\n"
		string += "\t\t\tif state." + self.inputs[3] + " == '1' and state." + self.inputs[1] + " == '0':\n"
		# Load = 1, Count = 0: Load value from data
		string += "\t\t\t\tgoodinput = True\n"
		string += "\t\t\t\tfor j in state." + self.inputs[0] + ":\n"
		string += "\t\t\t\t\tif j != '0' and j != '1':\n"
		string += "\t\t\t\t\t\tgoodinput = False\n"
		string += "\t\t\t\tif goodinput and int(state." + self.inputs[0] + ", 2) <= " + str(self.maxSize) + ":\n"
		string += "\t\t\t\t\tstate.memory = int(state." + self.inputs[0] + ", 2)\n"
		string += "\t\t\t\telif goodinput:\n"
		string += "\t\t\t\t\tstate.memory = " + str(self.maxSize) + "\n"
		string += "\t\t\t\telse:\n"
		string += "\t\t\t\t\tstate.memory = 0\n"

		string += "\t\t\telif (state." + self.inputs[3] + " == '1') and (state." + self.inputs[1] + " != '0'):\n"
		# Load = 1, Count = 1: Decrement counter
		string += "\t\t\t\tstate.memory -= 1\n"

		string += "\t\t\telif (state." + self.inputs[3] + " != '1') and (state." + self.inputs[1] + " == '0'):\n"
		# Load = 0, Count = 0: No change
		string += "\t\t\t\tpass\n"

		string += "\t\t\telif (state." + self.inputs[3] + " != '1') and (state." + self.inputs[1] + " != '0'):\n"
		# Load = 0, Count = 1: Increment counter
		string += "\t\t\t\tstate.memory += 1\n"

		# If the counter goes out of bounds, this has to be corrected
		string += "\t\tif state.memory < 0:\n"
		# When decreasing, continue doesn't do anything special
		if self.overflow == "wrap":
			string += "\t\t\tstate.memory = " + str(self.maxSize) + "\n"
		elif self.overflow == "continue":
			string += "\t\t\tstate.memory = " + str(self.bitSize ** 2 - 1) + "\n"
		elif self.overflow == "stay":
			string += "\t\t\tstate.memory = 0\n"
		elif self.overflow == "load":
			string += "\t\t\tgoodinput = True\n"
			string += "\t\t\tfor j in state." + self.inputs[0] + ":\n"
			string += "\t\t\t\tif j != '0' and j != '1':\n"
			string += "\t\t\t\t\tgoodinput = False\n"
			string += "\t\t\tif goodinput:\n"
			string += "\t\t\t\tstate.memory = int(state." + self.inputs[0] + ", 2)\n"
			string += "\t\t\telse:\n"
			string += "\t\t\t\tstate.memory = 0\n"
			string += "\t\t\tif state.memory > " + str(self.maxSize) + ":\n"
			string += "\t\t\t\tstate.memory = " + str(self.maxSize) + "\n"
			"""
			string += "\t\t\t\telif state.memory < 0:\n"
			string += "\t\t\t\t\tstate.memory = 0\n"
			"""

		string += "\t\telif state.memory > " + str(self.maxSize) + ":\n"
		if self.overflow == "wrap":
			string += "\t\t\tstate.memory = 0\n"
		elif self.overflow == "stay":
			string += "\t\t\tstate.memory = " + str(self.maxSize) + "\n"
		elif self.overflow == "load":
			string += "\t\t\tgoodinput = True\n"
			string += "\t\t\tfor j in state." + self.inputs[0] + ":\n"
			string += "\t\t\t\tif j != '0' and j != '1':\n"
			string += "\t\t\t\t\tgoodinput = False\n"
			string += "\t\t\tif goodinput:\n"
			string += "\t\t\t\tstate.memory = int(state." + self.inputs[0] + ", 2)\n"
			string += "\t\t\telse:\n"
			string += "\t\t\t\tstate.memory = 0\n"
			string += "\t\t\tif state.memory > " + str(self.maxSize) + ":\n"
			string += "\t\t\t\tstate.memory = " + str(self.maxSize) + "\n"
		elif self.overflow == "continue":
			string += "\t\t\tif state.memory >= " + str(self.bitSize ** 2) + ":\n"
			string += "\t\t\t\tstate.memory = 0\n"
		return string

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\toverflow = '0'\n"
			
		# Carry out bits
		# An overflow when decreasing
		string += "\t\t\tif (self.state.memory == 0) and (state." + self.inputs[3] + " == '1') and (state." + self.inputs[1] + " != '0'):\n"
		string += "\t\t\t\toverflow = '1'\n"

		# An overflow when increasing
		string += "\t\t\telif (self.state.memory == " + str(self.maxSize) + ") and (state." + self.inputs[3] + " != '1') and (state." + self.inputs[1] + " != '0'):\n"
		string += "\t\t\t\toverflow = '1'\n"

		# Strange behaviour...
		string += "\t\t\telif (self.state.memory == " + str(self.maxSize) + ") and ((state." + self.inputs[3] + " != '1') or (state." + self.inputs[1] + " == '0')):\n"
		string += "\t\t\t\toverflow = '1'\n"

		string += "\t\t\tresult = bin(self.state.memory)[2:]\n"
		string += padBits("result", self.bitSize, 3)
		string += "\t\t\tself.poke(self." + self.outputs[0] + ", 'b' + str(result))\n"
		string += "\t\t\tself.poke(self." + self.outputs[1] + ", 'b' + str(overflow))\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
