from translator.visitor.DEVSlibrary.Plexers import *

def decode(outputs, inputs, disable, disableSignal, tabs, selectBits, threeState):
	""" Does the real work for the decoder """
	if threeState == True:
		noOutput = 'x'
	else:
		noOutput = '0'
	select = toSelf(toState(inputs[0]))
	if disable:
		enable = toSelf(toState(inputs[1]))

	string = setTabs(tabs) + "# DECODE \n"
	if disable:
		string += setTabs(tabs) + "if " + enable + " == '0':\n"
		for output in outputs:
			string += setTabs(tabs+1) + "self.poke(" + toSelf(output) + ", 'b" + disableSignal + "')\n"
		string += setTabs(tabs+1) + "return\n"
		string += setTabs(tabs) + "elif " + enable + " == 'E':\n"
		for output in outputs:
			string += setTabs(tabs+1) + "self.poke(" + toSelf(output) + ", 'bE')\n"
		string += setTabs(tabs+1) + "return\n"
	string += setTabs(tabs) + "if 'E' in " + select + ":\n"
	for output in outputs:
		string += setTabs(tabs+1) + "self.poke(" + toSelf(output) + ", 'bE')\n"
	string += setTabs(tabs+1) + "return\n"
	string += setTabs(tabs) + "if 'x' in " + select + ":\n"
	for output in outputs:
		string += setTabs(tabs+1) + "self.poke(" + toSelf(output) + ", 'bx')\n"
	string += setTabs(tabs+1) + "return\n"
	"""
	string += setTabs(tabs) + "for i in range(len(" + select + ")):\n"
	string += setTabs(tabs+1) + "if " + select + "[i] == 'E' or " + select + "[i] == 'x':\n"
	for output in outputs:
		string += setTabs(tabs+2) + "self.poke(" + toSelf(output) + ", 'bE')\n"
	string += setTabs(tabs+2) + "return\n"
	"""
	string += "\n"
	for i in range(2 ** selectBits):
		string += setTabs(tabs)
		if i != 0:
			string += "el"
		string += "if " + select + " == '" + str(toBits(i, selectBits)) + "':\n"
		for outputNr in range(len(outputs)):
			output = outputs[outputNr]
			if outputNr == i:
				string += setTabs(tabs+1) + "self.poke(" + toSelf(output) + ", 'b1')\n"
			else:
				string += setTabs(tabs+1) + "self.poke(" + toSelf(output) + ", 'b" + noOutput + "')\n"
		string += setTabs(tabs+1) + "return\n"

	string += setTabs(tabs) + "# END\n"
	return string
	

class Decoder(Plexers):
	def __init__(self, bitSize, delay, inputs, outputs, disableSignal, disable, selectBits, threeState):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		# These are outputs!
		#for i in range(2**selectBits):
			#bitlist.append(bitSize)
		bitlist.append(selectBits)
		if disable:
			bitlist.append(1)
		Plexers.__init__(self, bitSize, "Decoder" + "b" + str(bitSize) + "i" + str(len(inputs)) + "ds" + str(disableSignal) + "d" + str(disable) + "sb" + str(selectBits) + "ts" + str(threeState), delay, inputs, outputs, bitlist)
		self.disable = disable
		if disableSignal == "floating":
			self.disableSignal = "x"
		else:
			self.disableSignal = disableSignal
		self.selectBits = selectBits
		self.threeState = threeState

		self.outbitlist = []
		for i in self.outputs:
			self.outbitlist.append(1)

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += decode(self.outputs, self.inputs, self.disable, self.disableSignal, 3, self.selectBits, self.threeState)
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
