from translator.visitor.DEVSlibrary.Plexers import *

def demultiplex(outputs, inputs, disable, disableSignal, tabs, selectBits, bitSize, threeState):
	""" Does the real work for the demultiplexing """
	if threeState == True:
		noOutput = 'x'
	else:
		noOutput = '0'
	select = inputs[1]
	if disable:
		enable = inputs[2]

	string = setTabs(tabs) + "# DEMULTIPLEX \n"
	if disable:
		string += setTabs(tabs) + "if " + toSelf(toState(enable)) + " == '0':\n"
		for output in outputs:
			string += setTabs(tabs+1) + "self.poke(" + toSelf(output) + ", 'b" + disableSignal * bitSize + "')\n"
		string += setTabs(tabs+1) + "return\n"
		string += setTabs(tabs) + "elif " + toSelf(toState(enable)) + " == 'E':\n"
		for output in outputs:
			string += setTabs(tabs+1) + "self.poke(" + toSelf(output) + ", 'b" + 'E' * bitSize + "')\n"
		string += setTabs(tabs+1) + "return\n"
	string += setTabs(tabs) + "if 'E' in " + toSelf(toState(select)) + ":\n"
	for output in outputs:
		string += setTabs(tabs+1) + "self.poke(" + toSelf(output) + ", 'b" + 'E' * bitSize + "')\n"
	string += setTabs(tabs+1) + "return\n"
	string += setTabs(tabs) + "if 'x' in " + toSelf(toState(select)) + ":\n"
	for output in outputs:
		string += setTabs(tabs+1) + "self.poke(" + toSelf(output) + ", 'b" + 'x' * bitSize + "')\n"
	string += setTabs(tabs+1) + "return\n"
	"""
	string += setTabs(tabs) + "for i in range(len(" + toSelf(toState(select)) + ")):\n"
	string += setTabs(tabs+1) + "if " + toSelf(toState(select)) + "[i] == 'E' or " + toSelf(toState(select)) + "[i] == 'x':\n"
	for output in outputs:
		string += setTabs(tabs+2) + "self.poke(" + toSelf(output) + ", 'b" + 'E' * bitSize + "')\n"
	string += setTabs(tabs+2) + "return\n"
	"""
	string += "\n"
	for i in range(2 ** selectBits):
		string += setTabs(tabs)
		if i != 0:
			string += "el"
		string += "if " + toSelf(toState(select)) + " == '" + str(toBits(i, selectBits)) + "':\n"
		for outputNr in range(len(outputs)):
			output = outputs[outputNr]
			if outputNr == i:
				string += setTabs(tabs+1) + "self.poke(" + toSelf(output) + ", 'b' + str(" + str(toSelf(toState(inputs[0]))) + "))\n"
			else:
				string += setTabs(tabs+1) + "self.poke(" + toSelf(output) + ", 'b" + noOutput * bitSize + "')\n"
	string += setTabs(tabs+1) + "return\n"
	string += setTabs(tabs) + "# END\n"
	return string
	

class Demultiplexer(Plexers):
	def __init__(self, bitSize, delay, inputs, outputs, disableSignal, disable, selectBits, threeState):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = [bitSize, selectBits]
		if disable:
			bitlist.append(1)
		Plexers.__init__(self, bitSize, "Demultiplexer" + "b" + str(bitSize) + "i" + str(len(inputs)) + "ds" + str(disableSignal) + "d" + str(disable) + "sb" + str(selectBits) + "ts" + str(threeState) , delay, inputs, outputs, bitlist)
		self.disable = disable
		if disableSignal == "floating":
			self.disableSignal = "x"
		else:
			self.disableSignal = disableSignal
		self.selectBits = selectBits
		self.threeState = threeState

		self.outbitlist = []
		for i in self.outputs:
			self.outbitlist.append(bitSize)

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += demultiplex(self.outputs, self.inputs, self.disable, self.disableSignal, 3, self.selectBits, self.bitSize, self.threeState)
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
