from translator.visitor.DEVSlibrary.Model import *
from translator.visitor.DEVSlibrary.Arithmetic import *

class Divider(Arithmetic):
	def __init__(self, bitSize, delay, inputs, outputs):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = [bitSize, bitSize]
		if len(inputs) > 2:
			bitlist.append(bitSize)
		Arithmetic.__init__(self, bitSize, "Divide" + "b" + str(bitSize) + "i" + str(len(inputs)) + "o" + str(len(outputs)), delay, inputs, outputs, bitlist)
		self.outbitlist = [bitSize, bitSize]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		if len(self.inputs) > 2:
			string += "\t\t\textra = " + toState(self.inputs[2]) + "\n"
			string += "\t\t\tif extra == '" + 'x' * self.bitSize + "':\n"
			string += "\t\t\t\textra = '" + '0' * self.bitSize + "'\n"
		else:
			string += "\t\t\textra = '" + '0' * self.bitSize + "'\n"
		string += self.bitDivide(toState(self.inputs[0]), toState(self.inputs[1]), "extra",  3)
		string += "\t\t\tself.poke(self." + self.outputs[0] + ", out)\n"
		if len(self.outputs) > 1:
			string += "\t\t\tself.poke(self." + self.outputs[1] + ", carryOut)\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string

	def bitDivide(self, in1, in2, carryIn, tabs):
		""" Does the real work for the division """
		string = setTabs(tabs) + "originalBitsize = len(" + in1 + ")\n"
		string += setTabs(tabs) + "new1 = deepcopy(" + str(in1) + ")\n"
		string += setTabs(tabs) + "new2 = deepcopy(" + str(in2) + ")\n"
		string += self.bitArithmetic("new1", "new2", carryIn, "/", tabs)
		string += setTabs(tabs) + "if correct != len(new1):\n"
		string += setTabs(tabs+1) + "if 'E' in " + str(in1) + " or 'E' in " + str(in2) + " or 'E' in " + str(carryIn) + ":\n"
		string += setTabs(tabs+2) + "fail = 'E'\n"
		string += setTabs(tabs+1) + "out = 'b' + fail * originalBitsize\n"
		string += setTabs(tabs+1) + "carryOut = 'b' + fail * originalBitsize\n"
		string += setTabs(tabs) + "else:\n"
		string += setTabs(tabs+1) + "if int2 == 0:\n"
		string += setTabs(tabs+2) + "result = int1\n"
		string += setTabs(tabs+2) + "remainder = 0\n"
		string += setTabs(tabs+1) + "else:\n"
		string += setTabs(tabs+2) + "result = int1 / int2\n"
		string += setTabs(tabs+2) + "remainder = int1 % int2\n"
		string += setTabs(tabs+1) + "bitresult = bin(result)[2:]\n"
		string += setTabs(tabs+1) + "bitremainder = bin(remainder)[2:]\n"
		#string += setTabs(tabs+1) + "bitresult = '0' * (len(" + in1 + ") - len(bitresult)) + bitresult\n"
		string += setTabs(tabs+1) + "while len(bitresult) < len(new1):\n"
		string += setTabs(tabs+2) + "bitresult = '0' + bitresult\n"
		string += setTabs(tabs+1) + "while len(bitremainder) < len(new1):\n"
		string += setTabs(tabs+2) + "bitremainder = '0' + bitremainder\n"
		#string += setTabs(tabs+1) + "bitremainder = '0' * (originalBitsize - len(bitremainder)) + bitremainder\n"
		#string += setTabs(tabs+1) + "out = 'b' + bitresult[-originalBitsize:]\n"
		string += setTabs(tabs+1) + "out = 'b' + bitresult[-originalBitsize:]\n"
		string += setTabs(tabs+1) + "carryOut = 'b' + bitremainder[-originalBitsize:]\n"
		return string
