from translator.visitor.DEVSlibrary.Memory import *

class FlipFlop(Memory):
	def __init__(self, bitSize, delay, inputs, outputs, type, trigger):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		for i in inputs:
			bitlist.append(bitSize)
		Memory.__init__(self, bitSize, str(type) + "FlipFlop" + "b" + str(bitSize) + "i" + str(len(inputs)) + "t" + str(trigger), delay, inputs, outputs, bitlist, trigger, 1)
		self.type = type
		self.outbitlist = [bitSize, bitSize]

	def extraExtTransition(self, opt):
		string = ""
		string += "\t\tif state." + self.inputs[4] + " == '1':\n"
		string += "\t\t\tstate.memory = 0\n"
		string += "\t\telif state." + self.inputs[2] + " == '1':\n"
		string += "\t\t\tstate.memory = 1\n"
		string += "\t\telif state." + self.inputs[3] + " != '0' and state.triggered:\n"
		string += "\t\t\tif state." + self.inputs[0] + " == '1':\n"
		if self.type == "D":
			string += "\t\t\t\tstate.memory = 1\n"
		elif self.type == "T":
			string += "\t\t\t\tif self.state.memory == 1:\n"
			string += "\t\t\t\t\tstate.memory = 0\n"
			string += "\t\t\t\telif self.state.memory == 0:\n"
			string += "\t\t\t\t\tstate.memory = 1\n"
		elif self.type == "JK":
			# Now K == 1
			string += "\t\t\t\tif state." + self.inputs[5] + " == '1':\n"
			# Both are 1
			string += "\t\t\t\t\tif self.state.memory == 1:\n"
			string += "\t\t\t\t\t\tstate.memory = 0\n"
			string += "\t\t\t\t\telif self.state.memory == 0:\n"
			string += "\t\t\t\t\t\tstate.memory = 1\n"
			string += "\t\t\t\telif state." + self.inputs[5] + " == '0':\n"
			# J = 0, K = 1, so set to 0
			string += "\t\t\t\t\tstate.memory = 0\n"
		elif self.type == "SR":
			# Now R = 1
			string += "\t\t\t\tif state." + self.inputs[5] + " == '1':\n"
			# Both are 1, logisim doesn't do anything in this case
			string += "\t\t\t\t\tpass\n"
			string += "\t\t\t\telif state." + self.inputs[5] + " == '0':\n"
			# S = 0, R = 1, so set to 0
			string += "\t\t\t\t\tstate.memory = 0\n"

		string += "\t\t\telif state." + self.inputs[0] + " == '0':\n"
		if self.type == "D":
			string += "\t\t\t\tstate.memory = 0\n"
		elif self.type == "T":
			string += "\t\t\t\tpass\n"
		elif self.type == "JK":
			# Now K == 0
			string += "\t\t\t\tif state." + self.inputs[5] + " == '1':\n"
			string += "\t\t\t\t\tstate.memory = 1\n"
		elif self.type == "SR":
			# R == 0
			string += "\t\t\t\tif state." + self.inputs[5] + " == '1':\n"
			# R = 0, S = 1
			string += "\t\t\t\t\tstate.memory = 1\n"

		return string

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\tresult = str(self.state.memory)\n"
		string += "\t\t\tif result == '0':\n"
		string += "\t\t\t\tcomplresult = '1'\n"
		string += "\t\t\telif result == '1':\n"
		string += "\t\t\t\tcomplresult = '0'\n"
		string += "\t\t\telse:\n"
		string += "\t\t\t\tcomplresult = 'E'\n"
		string += "\t\t\tself.poke(self." + self.outputs[0] + ", 'b' + str(result))\n"
		string += "\t\t\tself.poke(self." + self.outputs[1] + ", 'b' + str(complresult))\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
