from translator.visitor.DEVSlibrary.helper import *

class InteractiveModule:
	def write(self, inputs, outputs, mainCircuit):
		""" Generates all code """
		string = "# All necessary imports, the same for all models\n"
		string += "import sys\n"
		string += "import os.path\n"
		string += "# This line will import pyDEVS\n"
		string += "sys.path.append(os.path.expanduser('" + getConfig("main", "importPath") + "'))\n"
		string += "import pydevs\n"
		string += "from pydevs.devs_exceptions import *\n"
		string += "from pydevs.infinity import *\n"
		string += "from pydevs.DEVS import *\n"
		string += "from random import uniform\n"
		string += "from random import randint\n"
		string += "\n"

		string += "class interactive(CoupledDEVS):\n"
		string += "\tdef __init__(self, name=None):\n"
		string += "\t\tCoupledDEVS.__init__(self, name=name)\n"
		string += "\t\t# The elements\n"
		string += "\t\t# Just to be sure...\n"
		string += "\t\tfrom interactiveInput import interactiveInput\n"
		string += "\t\tself.interactiveInput = self.addSubModel(interactiveInput(name='input'))\n"
		string += "\t\tfrom interactiveOutput import interactiveOutput\n"
		string += "\t\tself.interactiveOutput = self.addSubModel(interactiveOutput(name='output'))\n"
		string += "\t\tfrom " + str(mainCircuit) + " import " + str(mainCircuit) + "\n"
		string += "\t\tself.main = self.addSubModel(" + str(mainCircuit) + "(name='main'))\n"
		string += "\t\t# The connections \n"
		for i in inputs:
			string += "\t\tself.connectPorts(self.interactiveInput." + str(i) + ", self.main." + str(i) + ")\n"
		for i in outputs:
			string += "\t\tself.connectPorts(self.main." + str(i) + ", self.interactiveOutput." + str(i) + ")\n"
		
		string += "\n"

		string += "\tdef select(self, immList):\n"
		string += "\t\tfor i in immList:\n"
		string += "\t\t\tif i.name == 'output':\n"
		string += "\t\t\t\treturn i\n"
		string += "\t\treturn immList[0]\n"
		return string

