from translator.visitor.DEVSlibrary.Helpers import *

class Merger(Helpers):
	""" The Merger class, this doesn't have an equivalent in logisim.

	This is a model that will take a number of inputs and will try to merge these on one single line. This can thus be used to solve colliding wires."""
	def __init__(self, bitSize, delay, inputs, outputs):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		for i in range(len(inputs)):
			bitlist.append(bitSize)

		Helpers.__init__(self, bitSize, "Merger" + "b" + str(bitSize) + "i" + str(len(inputs)), delay, inputs, outputs, bitlist)
		self.outbitlist = [bitSize]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\toutValue = 'b'\n"
		string += "\t\t\tfor i in range(" + str(self.bitSize) + "):\n"
		string += "\t\t\t\tnewVal = 'x'\n"
		for j in range(len(self.inputs)):
			string += "\t\t\t\tif ((state." + self.inputs[j] + "[i] == newVal) or (newVal == 'x')):\n"
			string += "\t\t\t\t\tnewVal = state." + self.inputs[j] + "[i]\n"
			string += "\t\t\t\telif state." + self.inputs[j] + "[i] == 'x':\n"
			string += "\t\t\t\t\tpass\n"
			string += "\t\t\t\telse:\n"
			string += "\t\t\t\t\toutValue += 'E'\n"
			string += "\t\t\t\t\tcontinue\n"
		string += "\t\t\t\toutValue += newVal\n"
		string += "\t\t\tself.poke(self."
		string += self.outputs[0]
		string += ", outValue)\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
