from translator.visitor.DEVSlibrary.Plexers import *

def multiplex(outName, inputs, disable, disableSignal, tabs, selectBits, bitSize):
	""" The real work for the multiplexing """
	if "selectLine" not in inputs:
		string = ""
		string += setTabs(tabs) + outName + " = '" + "x" * bitSize + "'\n"
		return string
	select = toSelf(toState(inputs[2 ** selectBits]))
	if disable:
		enable = toSelf(toState(inputs[2 ** selectBits  + 1]))

	string = setTabs(tabs) + "# MULTIPLEX \n"
	if disable:
		string += setTabs(tabs) + "if " + enable + " == '0':\n"
		string += setTabs(tabs+1) + outName + " = '" + disableSignal * bitSize + "'\n"
		string += setTabs(tabs) + "elif " + enable + " == 'E':\n"
		string += setTabs(tabs+1) + outName + " = '" + "E" * bitSize + "'\n"
		string += setTabs(tabs) + "else:\n"
		tabs += 1
	string += setTabs(tabs) + "if 'E' in " + select + ":\n"
	string += setTabs(tabs+1) + outName + " = '" + "E" * bitSize + "'\n"
	string += setTabs(tabs) + "elif 'x' in " + select + ":\n"
	string += setTabs(tabs+1) + outName + " = '" + "x" * bitSize + "'\n"

	for i in range(2 ** selectBits):
		string += setTabs(tabs)
		string += "elif " + select + " == '" + str(toBits(i, selectBits)) + "':\n"
		string += setTabs(tabs+1) + outName + " = " + toSelf(toState(inputs[i])) + "\n"
	string += setTabs(tabs) + "# END\n"
	return string
	

class Multiplexer(Plexers):
	def __init__(self, bitSize, delay, inputs, outputs, disableSignal, disable, selectBits):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		for i in range(2**selectBits):
			bitlist.append(bitSize)
		bitlist.append(selectBits)
		if disable:
			bitlist.append(1)
		Plexers.__init__(self, bitSize, "Multiplexer" + "b" + str(bitSize) + "i" + str(len(inputs)) + "ds" + str(disableSignal) + "d" + str(disable) + "sb" + str(selectBits), delay, inputs, outputs, bitlist)
		self.disable = disable
		if disableSignal == "floating":
			self.disableSignal = "x"
		else:
			self.disableSignal = disableSignal
		self.selectBits = selectBits
		self.outbitlist = [bitSize]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += multiplex("outValue", self.inputs, self.disable, self.disableSignal, 3, self.selectBits, self.bitSize)
		string += "\t\t\tself.poke(self."
		string += self.outputs[0]
		string += ", 'b' + str(outValue))\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
