from translator.visitor.DEVSlibrary.Model import *
from translator.visitor.DEVSlibrary.Arithmetic import *

class Multiplier(Arithmetic):
	def __init__(self, bitSize, delay, inputs, outputs):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = [bitSize, bitSize]
		if len(inputs) > 2:
			bitlist.append(bitSize)
		Arithmetic.__init__(self, bitSize, "Mult" + "b" + str(bitSize) + "i" + str(len(inputs)) + "o" + str(len(outputs)), delay, inputs, outputs, bitlist)
		self.outbitlist = [bitSize, bitSize]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		if len(self.inputs) > 2:
			string += "\t\t\textra = " + toState(self.inputs[2]) + "\n"
			string += "\t\t\tif extra == '" + 'x' * self.bitSize + "':\n"
			string += "\t\t\t\textra = '" + '0' * self.bitSize + "'\n"
		else:
			string += "\t\t\textra = '" + '0' * self.bitSize + "'\n"
		string += self.bitMultiply(toState(self.inputs[0]), toState(self.inputs[1]), "extra",  3)
		string += "\t\t\tself.poke(self." + self.outputs[0] + ", out)\n"
		if len(self.outputs) > 1:
			string += "\t\t\tself.poke(self." + self.outputs[1] + ", carryOut)\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string


	def bitMultiply(self, in1, in2, carryIn, tabs):
		""" The real work for the multiplication """
		string = self.bitArithmetic(in1, in2, carryIn, "*", tabs)
		string += setTabs(tabs+1) + "result = int1 * int2 + int3\n"
		string += setTabs(tabs+1) + "bitresult = (bin(result))[2:]\n"
		string += setTabs(tabs+1) + "for i in range(correct - len(bitresult)):\n"
		string += setTabs(tabs+2) + "bitresult = '0' + bitresult\n"
		string += setTabs(tabs+1) + "out += bitresult\n"
		string += setTabs(tabs) + "if correct != len(" + in1 + "):\n"
		string += setTabs(tabs+1) + "out = out[-correct:]\n"
		string += setTabs(tabs) + "if (len(out) == 0) or (correct != len(" + in1 + ")):\n"
		string += setTabs(tabs+1) + "padBit = fail\n"
		string += setTabs(tabs) + "elif (len(out) > 0) and (out[0] == '0' or out[0] == '1'):\n"
		string += setTabs(tabs+1) + "padBit = '0'\n"
		string += setTabs(tabs) + "else:\n"
		string += setTabs(tabs+1) + "padBit = out[0]\n"
		string += setTabs(tabs) + "if correct != len(" + in1 + ") and fail == 'x' and correctE != 0:\n"
		string += setTabs(tabs+1) + "while len(out) < correctE:\n"
		string += setTabs(tabs+2) + "out = 'x' + out\n"
		string += setTabs(tabs+2) + "padBit = 'E'\n"
		string += setTabs(tabs) + "while len(out) < 2 * len(" + in1 + "):\n"
		string += setTabs(tabs+1) + "out = padBit + out\n"
		string += setTabs(tabs) + "carryOut = 'b' + out[0:len(" + in1 + ")]\n"
		string += setTabs(tabs) + "out = 'b' + out[len(" + in1 + "):2*len(" + in1 + ")]\n"
		# output = in1 <operator> in2 <operator> carryIn
		# carryOut = overflow of output
		return string
