from translator.visitor.DEVSlibrary.Arithmetic import *

class Negator(Arithmetic):
	def __init__(self, bitSize, delay, inputs, outputs):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = [bitSize]
		Arithmetic.__init__(self, bitSize, "Negate" + "b" + str(bitSize) + "i" + str(len(inputs)) + "o" + str(len(outputs)), delay, inputs, outputs, bitlist)
		self.outbitlist = [bitSize]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\tinpVal = " + toState(self.inputs[0]) + "\n"
		string += "\t\t\tnegate = False\n"
		string += "\t\t\tunknown = False\n"
		string += "\t\t\terror = False\n"
		string += "\t\t\tout = ''\n"

		string += "\t\t\tfor i in reversed(inpVal):\n"
		# Negate
		string += "\t\t\t\tif negate:\n"
		string += "\t\t\t\t\tif i == '1':\n"
		string += "\t\t\t\t\t\tout = '0' + out\n"
		string += "\t\t\t\t\telif i == '0':\n"
		string += "\t\t\t\t\t\tout = '1' + out\n"
		string += "\t\t\t\t\telif i == 'x':\n"
		string += "\t\t\t\t\t\tout = 'x' + out\n"
		string += "\t\t\t\t\telif i == 'E':\n"
		string += "\t\t\t\t\t\tout = 'E' + out\n"

		# Error fixed
		string += "\t\t\t\telif i == '1' and error:\n"
		string += "\t\t\t\t\tout = 'E' + out\n"
		string += "\t\t\t\t\terror = False\n"
		string += "\t\t\t\t\tnegate = True\n"

		# Unkown fixed
		string += "\t\t\t\telif i == '1' and unknown:\n"
		string += "\t\t\t\t\tout = 'x' + out\n"
		string += "\t\t\t\t\tunknown = False\n"
		string += "\t\t\t\t\tnegate = True\n"

		# Found inverter bit
		string += "\t\t\t\telif i == '1':\n"
		string += "\t\t\t\t\tnegate = True\n"
		string += "\t\t\t\t\tout = '1' + out\n"

		# Error state
		string += "\t\t\t\telif error:\n"
		string += "\t\t\t\t\tout = 'E' + out\n"

		# Start of error
		string += "\t\t\t\telif (i == 'E'):\n"
		string += "\t\t\t\t\terror = True\n"
		string += "\t\t\t\t\tout = 'E' + out\n"

		# Unkown state
		string += "\t\t\t\telif unknown:\n"
		string += "\t\t\t\t\tout = 'x' + out\n"

		# Start of unknown
		string += "\t\t\t\telif (i == 'x'):\n"
		string += "\t\t\t\t\tunknown = True\n"
		string += "\t\t\t\t\tout = 'x' + out\n"

		# Just copy
		string += "\t\t\t\telif not negate:\n"
		string += "\t\t\t\t\tout = i + out\n"

		string += "\t\t\tself.poke(self." + self.outputs[0] + ", 'b' + out)\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
		"""
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\tinpVal = " + toState(self.inputs[0]) + "\n"
		string += "\t\t\tnegate = False\n"
		string += "\t\t\tunknown = False\n"
		string += "\t\t\tout = ''\n"
		string += "\t\t\tfor i in reversed(inpVal):\n"
		string += "\t\t\t\tif (i == '1') and (unknown):\n"
		string += "\t\t\t\t\tout = pad + out\n"
		string += "\t\t\t\t\tnegate = True\n"
		string += "\t\t\t\t\tunknown = False\n"
		string += "\t\t\t\telif (i == '1') and not negate:\n"
		string += "\t\t\t\t\tnegate = True\n"
		string += "\t\t\t\t\tout = i + out\n"
		string += "\t\t\t\telif (i != '1') and (unknown):\n"
		string += "\t\t\t\t\tout = pad + out\n"
		string += "\t\t\t\telif (i == 'x' or i == 'E') and not negate:\n"
		string += "\t\t\t\t\tunknown = True\n"
		string += "\t\t\t\t\tpad = i\n"
		string += "\t\t\t\t\tout = pad + out\n"
		string += "\t\t\t\telif (i == 'x' or i == 'E') and negate:\n"
		string += "\t\t\t\t\tout = i + out\n"
		string += "\t\t\t\telif not negate:\n"
		string += "\t\t\t\t\tout = i + out\n"
		string += "\t\t\t\telif negate:\n"
		string += "\t\t\t\t\tif i == '1':\n"
		string += "\t\t\t\t\t\tout = '0' + out\n"
		string += "\t\t\t\t\telif i == '0':\n"
		string += "\t\t\t\t\t\tout = '1' + out\n"
		string += "\t\t\t\telse:\n"
		string += "\t\t\t\t\t# Nothing to do\n"
		string += "\t\t\t\t\tpass\n"
		string += "\t\t\tself.poke(self." + self.outputs[0] + ", 'b' + out)\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
		"""
