from translator.visitor.DEVSlibrary.Plexers import *

def prioenc(outName, inputs, disable, disableSignal, tabs, bitSize):
	""" The real work for the Priority encoder """
	if disable:
		enable = (inputs[2 ** bitSize])

	string = setTabs(tabs) + "# PRIORITY ENCODER \n"
	if disable:
		string += setTabs(tabs) + "if " + toState(enable) + " == '0':\n"
		string += setTabs(tabs+1) + outName + " = '" + disableSignal * bitSize + "'\n"
		string += setTabs(tabs+1) + "nonOne = '0'\n"
		string += setTabs(tabs+1) + "groupSelect = '0'\n"
		string += setTabs(tabs) + "else:\n"
		tabs = tabs + 1

	string += setTabs(tabs) + "found = False\n"
	for i in range(2 ** bitSize):
		string += setTabs(tabs)
		string += "if " + toSelf(toState(inputs[i])) + " == '1':\n"
		string += setTabs(tabs+1) + "found = True\n"
		string += setTabs(tabs+1) + outName + " = '" + toBits(i, bitSize) + "'\n"
	string += setTabs(tabs) + "# END\n"
	string += setTabs(tabs) + "if not found:\n"
	string += setTabs(tabs+1) + "nonOne = '1'\n"
	string += setTabs(tabs+1) + "groupSelect = '0'\n"
	string += setTabs(tabs+1) + outName + " = '" + 'x' * bitSize + "'\n"
	string += setTabs(tabs) + "else:\n"
	string += setTabs(tabs+1) + "nonOne = '0'\n"
	string += setTabs(tabs+1) + "groupSelect = '1'\n"
	return string
	

class PriorityEncoder(Plexers):
	def __init__(self, bitSize, delay, inputs, outputs, disableSignal, disable):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		for i in range(len(inputs)):
			bitlist.append(1)
		Plexers.__init__(self, bitSize, "PriorityEncoder" + "b" + str(bitSize) + "i" + str(len(inputs)) + "ds" + str(disableSignal) + "d" + str(disable), delay, inputs, outputs, bitlist)
		self.disable = disable
		if disableSignal == "floating":
			self.disableSignal = "x"
		else:
			self.disableSignal = disableSignal
		self.outbitlist = [bitSize, 1, 1]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += prioenc("outValue", self.inputs, self.disable, self.disableSignal, 3, self.bitSize)
		string += "\t\t\tself.poke(self."
		string += self.outputs[0]
		string += ", 'b' + str(outValue))\n"
		string += "\t\t\tself.poke(self." + self.outputs[1] + ", 'b' + str(nonOne))\n"
		string += "\t\t\tself.poke(self." + self.outputs[2] + ", 'b' + str(groupSelect))\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
