from translator.visitor.DEVSlibrary.Helpers import *

class PullResistor(Helpers):
	""" The PullResistor class, this doesn't have a real equivalent in logisim.

	This is an artefact from the wire directions. This model just fills in the floating values, the placement of this element is so that this fixes the wire direction."""
	def __init__(self, bitSize, delay, inputs, outputs, direction):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		# Normally, a pull resistor would be 0 delay, however it is possible to give it a delay for generality
		bitlist = [bitSize]
		Model.__init__(self, bitSize, "Pull" + "b" + str(bitSize) + "d" + str(direction), delay, inputs, outputs, bitlist)
		if(direction == 'X'):
			# It seems that X was used to indicate an error, however we use E
			direction = 'E'
		self.direction = direction
		self.outbitlist = [bitSize]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\toutValue = 'b'\n"
		string += "\t\t\tfor i in range(" + str(self.bitSize) + "):\n"
		string += "\t\t\t\tif state." + self.inputs[0] + "[i] == 'x':\n"
		string += "\t\t\t\t\toutValue += '" + self.direction + "'\n"
		string += "\t\t\t\telse:\n"
		string += "\t\t\t\t\toutValue += self.state." + self.inputs[0] + "[i]\n"
		string += "\t\t\tself.poke(self."
		string += self.outputs[0]
		string += ", outValue)\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
