from translator.visitor.DEVSlibrary.Memory import *

class ROM(Model):
	def __init__(self, count, bitSize, delay, inputs, outputs, dataBit, contents):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		bitlist.append(bitSize)
		bitlist.append(1)

		self.dataBit = dataBit
		Model.__init__(self, bitSize, "ROM" + str(count), delay, inputs, outputs, bitlist)
		self.outbitlist = [bitSize]

		# Write the contents to a file for easy editing
		file = open(getConfig("main", "destination") + str(self.name) + '.txt', 'w')
		for line in contents:
			printline = line + '\n'
			file.write(printline)
		file.close()

	def generateClassBase(self):
		""" Generates the basic constructor for the constructed Model """
		string = Model.generateClassBase(self)
		string += "\t\t# Change the filename to the desired content, filenames are ROM module dependent\n"
		string += "\t\tfile = open('" + str(getConfig("main", "destination")) + str(self.name) + ".txt', 'r')\n"
		string += "\t\tself.memory = []\n"
		string += "\t\tfor line in file:\n"
		# Strip of the newline
		string += "\t\t\tnormalLine = line[:-1]\n"
		# Convert to decimal in memory to save space
		string += "\t\t\tif normalLine.count('*') > 0:\n"
		string += "\t\t\t\t[count, value] = normalLine.split('*')\n"
		string += "\t\t\t\tdecimal = int(value, 16)\n"
		string += "\t\t\t\tfor i in range(count):\n"
		string += "\t\t\t\t\tself.addToMemory(decimal)\n"
		string += "\t\t\telse:\n"
		string += "\t\t\t\tdecimal = int(normalLine, 16)\n"
		string += "\t\t\t\tself.addToMemory(decimal)\n"
		string += "\n\n"
		string += "\tdef addToMemory(self, decimal):\n"
		string += "\t\tif decimal >= " + str(2 ** self.dataBit) + ":\n"
		string += "\t\t\traise DEVSException('Too big data value given: ' + str(decimal) + ' given, maximum is ' + str(" + str(2 ** self.dataBit - 1) + "))\n"
		string += "\t\tif len(self.memory) >= " + str(2 ** self.bitSize) + ":\n"
		string += "\t\t\traise DEVSException('Too much values given: maximum of ' + str(" + str(2 ** self.bitSize)+ "))\n"
		string += "\t\tself.memory.append(decimal)\n"
		return string

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\tif state." + self.inputs[1] + " == '0':\n"
		string += "\t\t\t\tself.poke(self." + self.outputs[0] + ", 'b' + str('x' * " + str(self.bitSize) + "))\n"
		string += "\t\t\telse:\n"
		string += "\t\t\t\tif 'x' in state." + self.inputs[0] + " or 'E' in state." + self.inputs[0] + ":\n"
		# No poke
		string += "\t\t\t\t\treturn\n"
		string += "\t\t\t\taddress = int(state." + self.inputs[0] + ", 2)\n"
		string += "\t\t\t\tif address < len(self.memory):\n"
		string += "\t\t\t\t\tresult = str(bin(self.memory[address])[2:])\n"
		string += "\t\t\t\telse:\n"
		string += "\t\t\t\t\tresult = str(0)\n"
		string += padBits("result", self.dataBit, 4)
		string += "\t\t\t\tself.poke(self." + self.outputs[0] + ", 'b' + str(result))\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
