from translator.visitor.DEVSlibrary.Memory import *

class Register(Memory):
	def __init__(self, bitSize, delay, inputs, outputs, trigger):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		bitlist.append(bitSize)
		for i in range(len(inputs) - 1):
			bitlist.append(1)
		Memory.__init__(self, bitSize, "Register" + "b" + str(bitSize) + "i" + str(len(inputs)) + "t" + str(trigger), delay, inputs, outputs, bitlist, trigger, 1)
		self.outbitlist = [bitSize]

	def extraExtTransition(self, opt = None):
		string = ""
		string += "\t\tif state." + self.inputs[3] + " == '1':\n"
		string += "\t\t\tstate.memory = '0'\n"
		string += "\t\telif state." + self.inputs[2] + " != '0' and state.triggered:\n"
		string += "\t\t\tgoodInput = True\n"
		string += "\t\t\tfor i in state." + self.inputs[0] + ":\n"
		string += "\t\t\t\tif i != '0' and i != '1':\n"
		string += "\t\t\t\t\tgoodInput = False\n"
		string += "\t\t\tif goodInput:\n"
		string += "\t\t\t\tstate.memory = state." + self.inputs[0] + "\n"
		return string

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\tresult = str(self.state.memory)\n"
		string += padBits("result", self.bitSize, 3)
		string += "\t\t\tself.poke(self." + self.outputs[0] + ", 'b' + str(result))\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
