from translator.visitor.DEVSlibrary.Arithmetic import *

class Shifter(Arithmetic):
	def __init__(self, bitSize, delay, inputs, outputs, shiftType):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = []
		bitlist.append(bitSize)
		from math import log
		from math import ceil
		bitlist.append(ceil(log(bitSize, 2)))
		Arithmetic.__init__(self, bitSize, "Shifter" + "b" + str(bitSize) + "i" + str(len(inputs)) + "s" + str(shiftType), delay, inputs, outputs, bitlist)
		self.shiftType = shiftType
		self.outbitlist = [bitSize]

	def logicalLeft(self, tabs):
		""" What should happen to the input when logical left is selected """
		string = ""
		string += setTabs(tabs) + "newInp = ''\n"
		string += setTabs(tabs) + "for j in range(len(inp)):\n"
		string += setTabs(tabs+1) + "if j == 0:\n"
		string += setTabs(tabs+2) + "continue\n"
		string += setTabs(tabs+1) + "else:\n"
		string += setTabs(tabs+2) + "newInp += inp[j]\n"
		string += setTabs(tabs) + "newInp += '0'\n"
		return string

	def logicalRight(self, tabs):
		""" What should happen to the input when logical right is selected """
		string = ""
		string += setTabs(tabs) + "newInp = ''\n"
		string += setTabs(tabs) + "newInp += '0'\n"
		string += setTabs(tabs) + "for j in range(len(inp)):\n"
		string += setTabs(tabs+1) + "if j == len(inp)-1:\n"
		string += setTabs(tabs+2) + "continue\n"
		string += setTabs(tabs+1) + "else:\n"
		string += setTabs(tabs+2) + "newInp += inp[j]\n"
		return string

	def arithmeticRight(self, tabs):
		""" What should happen to the input when arithmetic right is selected """
		string = ""
		string += setTabs(tabs) + "newInp = ''\n"
		string += setTabs(tabs) + "newInp += inp[0]\n"
		string += setTabs(tabs) + "for j in range(len(inp)):\n"
		string += setTabs(tabs+1) + "if j == len(inp)-1:\n"
		string += setTabs(tabs+2) + "continue\n"
		string += setTabs(tabs+1) + "else:\n"
		string += setTabs(tabs+2) + "newInp += inp[j]\n"
		return string

	def rotateLeft(self, tabs):
		""" What should happen to the input when rotate left is selected """
		string = ""
		string += setTabs(tabs) + "newInp = ''\n"
		string += setTabs(tabs) + "for j in range(len(inp)):\n"
		string += setTabs(tabs+1) + "if j == 0:\n"
		string += setTabs(tabs+2) + "continue\n"
		string += setTabs(tabs+1) + "else:\n"
		string += setTabs(tabs+2) + "newInp += inp[j]\n"
		string += setTabs(tabs) + "newInp += inp[0]\n"
		return string

	def rotateRight(self, tabs):
		""" What should happen to the input when rotate right is selected """
		string = ""
		string += setTabs(tabs) + "newInp = ''\n"
		string += setTabs(tabs) + "newInp += inp[-1]\n"
		string += setTabs(tabs) + "for j in range(len(inp)):\n"
		string += setTabs(tabs+1) + "if j == len(inp)-1:\n"
		string += setTabs(tabs+2) + "continue\n"
		string += setTabs(tabs+1) + "else:\n"
		string += setTabs(tabs+2) + "newInp += inp[j]\n"
		return string

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\tinp = state." + self.inputs[0] + "\n"
		string += "\t\t\tcount = state." + self.inputs[1] + "\n"
		string += "\t\t\terror = ''\n"
		string += "\t\t\tfor i in count:\n"
		string += "\t\t\t\tif i == 'x' or i == 'E':\n"
		string += "\t\t\t\t\terror = 'E'\n"
		string += "\t\t\t\t\tbreak\n"
		string += "\t\t\tif error == '':\n"
		string += "\t\t\t\tcount = int(count, 2)\n"
		string += "\t\t\telse:\n"
		string += "\t\t\t\tcount = 0\n"
		string += "\t\t\tfor i in range(count):\n"

		# Do the actual shifting
		if self.shiftType == "LogicalLeft":
			string += self.logicalLeft(4)
		elif self.shiftType == "LogicalRight":
			string += self.logicalRight(4)
		elif self.shiftType == "ArithmeticRight":
			string += self.arithmeticRight(4)
		elif self.shiftType == "RotateLeft":
			string += self.rotateLeft(4)
		elif self.shiftType == "RotateRight":
			string += self.rotateRight(4)

		# Overwrite previous input
		string += "\t\t\t\tinp = newInp\n"
		string += "\t\t\tif error == '':\n"
		string += "\t\t\t\tresult = inp\n"
		string += "\t\t\telse:\n"
		string += "\t\t\t\tresult = error * " + str(self.bitSize) + "\n"
		string += "\t\t\tself.poke(self." + self.outputs[0] + ", 'b' + str(result))\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
