from translator.visitor.DEVSlibrary.Model import *
from translator.visitor.DEVSlibrary.Arithmetic import *

class Subtractor(Arithmetic):
	def __init__(self, bitSize, delay, inputs, outputs):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = [bitSize, bitSize]
		if len(inputs) > 2:
			bitlist.append(1)
		Arithmetic.__init__(self, bitSize, "Sub" + "b" + str(bitSize) + "i" + str(len(inputs)) + "o" + str(len(outputs)), delay, inputs, outputs, bitlist)
		self.outbitlist = [bitSize, 1]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		if len(self.inputs) > 2:
			string += "\t\t\textra = " + toState(self.inputs[2]) + "\n"
		else:
			string += "\t\t\textra = '0'\n"
		string += self.bitSubtract(toState(self.inputs[0]), toState(self.inputs[1]), "extra",  3)
		string += "\t\t\tself.poke(self." + self.outputs[0] + ", out)\n"
		if len(self.outputs) > 1:
			string += "\t\t\tself.poke(self." + self.outputs[1] + ", carryOut)\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string

	def bitSubtract(self, in1, in2, carryIn, tabs):
		""" The real work for the subtraction """
		string = setTabs(tabs) + "tmpVal = ''\n"
		string += setTabs(tabs) + "oriIn2 = " + in2 + "\n"
		string += setTabs(tabs) + "for i in reversed(" + in2 + "):\n"
		string += setTabs(tabs+1) + "if i == '0':\n"
		string += setTabs(tabs+2) + "tmpVal = '1' + tmpVal\n"
		string += setTabs(tabs+1) + "elif i == '1':\n"
		string += setTabs(tabs+2) + "tmpVal = '0' + tmpVal\n"
		string += setTabs(tabs+1) + "elif i == 'x':\n"
		string += setTabs(tabs+2) + "tmpVal = 'x' + tmpVal\n"
		string += setTabs(tabs+1) + "elif i == 'E':\n"
		string += setTabs(tabs+2) + "tmpVal = 'E' + tmpVal\n"
	
		string += setTabs(tabs) + "if " + str(carryIn) + " == '1':\n"
		string += setTabs(tabs+1) + "newcarry = '0'\n"
		string += setTabs(tabs) + "elif " + str(carryIn) + " == '0':\n"
		string += setTabs(tabs+1) + "newcarry = '1'\n"
		string += setTabs(tabs) + "elif " + str(carryIn) + " == 'x':\n"
		string += setTabs(tabs+1) + "newcarry = '1'\n"
		string += setTabs(tabs) + "else:\n"
		string += setTabs(tabs+1) + "newcarry = " + str(carryIn) + "\n"
		string += setTabs(tabs) + "new2 = tmpVal\n"
		string += self.bitArithmetic(in1, "new2", "newcarry", "-", tabs)
		string += setTabs(tabs+1) + "result = int1 + int2\n"
		string += setTabs(tabs+1) + "if newcarry == '1':\n"
		string += setTabs(tabs+2) + "result += 1\n"
		"""
		string += setTabs(tabs+1) + "if result < 0:\n"
		string += setTabs(tabs+2) + "result += 2 ** " + str(self.bitSize) + "\n"
		"""
	
		string += setTabs(tabs+1) + "bitresult = (bin(result))[2:]\n"
	
		string += setTabs(tabs+1) + "setTrue = False\n"
		string += setTabs(tabs+1) + "for i,j in zip(" + in1 + ", oriIn2):\n"
		string += setTabs(tabs+2) + "if (i == '0' and j == '0') or (i == '1' and j == '1'):\n"
		string += setTabs(tabs+3) + "continue\n"
		string += setTabs(tabs+2) + "elif i == '1':\n"
		string += setTabs(tabs+3) + "break\n"
		string += setTabs(tabs+2) + "elif j == '1':\n"
		string += setTabs(tabs+3) + "setTrue = True\n"
		string += setTabs(tabs+3) + "break\n"
	
		string += setTabs(tabs+1) + "if setTrue or (("+ in1 + " == oriIn2) and (" + str(carryIn) + " == '1')):\n"
		string += setTabs(tabs+2) + "carryOut = 'b1'\n"
		string += setTabs(tabs+1) + "else:\n"
		string += setTabs(tabs+2) + "carryOut = 'b0'\n"
	
		string += setTabs(tabs+1) + "if correct != len(" + in1 + "):\n"
		string += setTabs(tabs+2) + "carryOut = 'bE'\n"
		string += setTabs(tabs+1) + "while len(bitresult) > len(bitstring1):\n"
		string += setTabs(tabs+2) + "bitresult = bitresult[1:]\n"
		string += setTabs(tabs+1) + "while len(bitresult) < len(bitstring1):\n"
		string += setTabs(tabs+2) + "bitresult = '0' + bitresult\n"
		string += setTabs(tabs+1) + "out += bitresult\n"
		string += setTabs(tabs) + "else:\n"
		string += setTabs(tabs+1) + "carryOut = 'bE'\n"
		string += setTabs(tabs) + "while len(out) < len(" + in1 + "):\n"
		string += setTabs(tabs+2) + "out = '0' + out\n"
		string += setTabs(tabs) + "out = 'b' + out\n"
		return string
