from translator.visitor.DEVSlibrary.Wiring import *

class Transistor(Wiring):
	def __init__(self, bitSize, delay, inputs, outputs, outChange, transistorType):
		""" The basic constructor of the model, name should be unique for the Model's configuration """
		bitlist = [bitSize, 1]
		if transistorType == 'c':
			bitlist.append(1)
		Wiring.__init__(self, bitSize, "Transistor" + "b" + str(bitSize) + "i" + str(len(inputs)) + "oc" + str(outChange) + "t" + str(transistorType), delay, inputs, outputs, bitlist)
		self.out = outChange
		self.type = transistorType
		self.outbitlist = [bitSize]

	def generateOutputFnc(self):
		""" The output function for the model, this is the main part of the Model """
		string = "\tdef outputFnc(self):\n"
		string += "\t\tstate = self.state\n"
		string += "\t\tif str(state) == 'active':\n"
		string += "\t\t\toutValue = ''\n"
		string += "\t\t\tif " + toState(self.inputs[1]) + " == "
		if self.type == 'p':
			string += "'0'"
		elif self.type == 'n':
			string += "'1'"
		elif self.type == 'c':
			string += "'0' and " + toState(self.inputs[2]) + " == '1'"
		string += ":\n"
		string += "\t\t\t\toutValue = " + toState(self.inputs[0]) + "\n"
		string += "\t\t\telif " + toState(self.inputs[1]) + " == "
		if self.type == 'p':
			string += "'1'"
		elif self.type == 'n':
			string += "'0'"
		elif self.type == 'c':
			string += "'1' and " + toState(self.inputs[2]) + " == '0'"
		string += ":\n"
		string += "\t\t\t\toutValue = '" + "x" * self.bitSize + "'\n"
		if self.type != 'c':
			string += "\t\t\telif " + toState(self.inputs[1]) + " == 'x' or " + toState(self.inputs[1]) + " == 'E'"
		else:
			string += "\t\t\telse"
		string += ":\n"
		string += "\t\t\t\tfor i in range(len(" + toState(self.inputs[0]) + ")):\n"
		string += "\t\t\t\t\tif " + toState(self.inputs[0]) + "[i] == 'x':\n"
		string += "\t\t\t\t\t\toutValue += 'x'\n"
		string += "\t\t\t\t\telse:\n"
		string += "\t\t\t\t\t\toutValue += 'E'\n"
		string += "\t\t\tself.poke(self."
		string += self.outputs[0]
		string += ", 'b' + str(outValue))\n"
		string += "\t\telse:\n"
		string += "\t\t\traise DEVSException('Should not output when not active')\n"
		return string
