#!/usr/bin/env python3

class VerilogTree():
	""" The verilog tree (of the intermediate tree)
It is an abstract tree (created by traversing the intermediate tree with the translator visitor) """
	
	def __init__(self, moduleList):
		""" Constructor """
		self.moduleList = moduleList
	
	def traverse(self, visitor, startFresh= True):		
		""" Traverses the tree and visits every node while using the visitor parameter """	
		if startFresh:
			visitor.__init__()
		
		for module in self.moduleList:
			visitor.visit(module)
			for input in module.inputList:
				visitor.visit(input)
			for output in module.outputList:
				visitor.visit(output)
			for gate in module.gateList:
				visitor.visit(gate)
			for net in module.netList:
				visitor.visit(net)
			for parameter in module.parameterList:
				visitor.visit(parameter)
			for statement in module.statementList:
				visitor.visit(statement)