#!/usr/bin/env python3

class ModuleDescriptor():
	""" The ModuleDescriptor defines what the heading, declarations, ... would be, if we needed to make verilog code """
	
	def __init__(self, moduleName):
		""" Constructor """
		self.name = moduleName
		self.heading = 'module ' + moduleName
		self.parameters = ""
		self.inputs = []
		self.outputs = []
		self.nets = []
		self.assignments = []
		self.initialBlock = '\tinitial \n\tbegin\n'
		self.initialBlockEnding = '\tend\n'
		self.alwaysBlock = '\talways \n\tbegin\n'
		self.alwaysBlockEnding = '\tend\n'
		self.ending = 'endmodule\n'
		self.extraBlocks = []
		self.extraModules = []