/**
 * @author R. Diez
 */

package vcdEngine;

class VcdToken
{
    private String tokenStr;
    private long lineNumber;
    private int columnNumber;
    
    public boolean isEndOfFile  () { return lineNumber == 0; }
    public boolean isEndKeyword () { return tokenStr.equals( VcdKeywords.END_KEYWORD ); }

    
    public VcdToken ()
    {
    }
    
    public VcdToken ( VcdToken tok )
    {
        tokenStr     = tok.tokenStr;
        lineNumber   = tok.lineNumber;
        columnNumber = tok.columnNumber;
    }
    

	public void set ( String tokenStr, long lineNumber, int columnNumber )
	{
		this.tokenStr     = tokenStr;
		this.lineNumber   = lineNumber;
		this.columnNumber = columnNumber;
	}

	
	public String getTokenStr()
	{
		return tokenStr;
	}
	
	public long getLineNumber()
	{
		return lineNumber;
	}
	
	public int getColumnNumber()
	{
		return columnNumber;
	}

	
    public void trace ()
    {
        if ( isEndOfFile() )
        {
            System.out.printf( "Token <end of file>\n" );
        }
        else
        {
            System.out.printf( "Token at %d:%d: \"%s\"\n",
                               lineNumber,
                               columnNumber,
                               tokenStr );
        }
    }
}
